;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 160 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "TestSisiV1.vec"
	.INCLUDE "TestSisiV1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x100)
	LDI  R29,HIGH(0x100)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x100
;       1 /********************************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot solaire
;      10 Version : 1.0.0
;      11 Date    : 06/01/2010
;      12 Mise  jour: 10/11/2010
;      13 Author  : Philippe Mariano                            
;      14 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      15 Comments: Test de la carte SISI
;      16 Mise en oeuvre du protocole I2C par l'interface TWI 
;      17 - Commande d'un afficheur LCD Batron I2C (PCF2119x)
;      18 - Lecture des BP et recopie sur les LED. 
;      19 - Test de la carte MD23(Reglage et commande des moteurs en
;      20 Mode0, lecture et affichage des registres)
;      21 - Test de la carte SD21
;      22 
;      23 File : TestSisiV1.c
;      24 Target:  Robot S_ISI
;      25 Chip type           : ATmega8535
;      26 Program type        : Application
;      27 Clock frequency     : 8,000000 MHz
;      28 Memory model        : Small
;      29 External SRAM size  : 0
;      30 Data Stack size     : 128
;      31 *********************************************************************/
;      32 
;      33 // =============================================================================================================================
;      34 // Partie dclarative du programme
;      35 // =============================================================================================================================
;      36 // Bibliothques et dfinitions
;      37 // =============================================================================================================================
;      38 #include <mega8535.h>      
;      39 // -----------------------------------------------------------------------------------------------------------------------------
;      40 // Bibliothque  rajouter manuellement   
;      41 // -----------------------------------------------------------------------------------------------------------------------------
;      42 #include <stdlib.h> 
;      43 #include <stdio.h>				// Fonction sprintf
;      44 #include <math.h>
;      45 #include <string.h>				// Fonctions de traitement des chanes de caractres  
;      46 #include <delay.h>				// Fonction temporisation   
;      47 // -----------------------------------------------------------------------------------------------------------------------------    
;      48 // Bibliothque dveloppes pour la carte SISI    
;      49 // -----------------------------------------------------------------------------------------------------------------------------
;      50 #include "MD23.h"				// Dfinitions des registres de la carte moteur MD23  
;      51 #include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C 
;      52 #include "SISISOL.h"            // Gestion de l'IHM SISI
;      53 // -----------------------------------------------------------------------------------------------------------------------------
;      54 // Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
;      55 // -----------------------------------------------------------------------------------------------------------------------------
;      56 #define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
;      57 #include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
;      58 /***********************************************************************
;      59 Project : PPE Robot(s)
;      60 Version : 1
;      61 Date    : 12/08/2009
;      62 Author  : MNO
;      63 File : twi_f.c
;      64 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      65 et dcrites dans la note d'application AVR315, adaptes au
;      66 cross compilateur CVAVR.
;      67 Fichier  inclure en en tte d'une application ncessitant une interface
;      68 2 fil I2C.
;      69 Evolution:  remplacer par une bibliothque
;      70 ***********************************************************************/
;      71 
;      72 
;      73 #include <TWI_Master_CVAVR.h>  
;      74 
;      75 // Declare your global variables here 
;      76 //-----------------------------------------------------------------------------------------------------------------------------
;      77 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      78 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      79 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      80  
;      81 union TWI_STR                      					// Status byte holding flags.
;      82 {
;      83     unsigned char all;
;      84     unsigned char lastTransOK:1;      
;      85     unsigned char unusedBits:7; 
;      86 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      87 //-----------------------------------------------------------------------------------------------------------------------------
;      88 
;      89 //-----------------------------------------------------------------------------------------------------------------------------
;      90 // Fonctions du drivers TWI
;      91 //-----------------------------------------------------------------------------------------------------------------------------
;      92 void TWI_Master_Initialise(void)
;      93 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      94   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      95 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      96   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      97   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;      98   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;      99                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;     100                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;     101                                          		// 0<<TWWC); 
;     102 } 
	RET
;     103 //-----------------------------------------------------------------------------------------------------------------------------
;     104 unsigned char TWI_Transceiver_Busy(void)
;     105 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;     106   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;     107 }
;     108 //-----------------------------------------------------------------------------------------------------------------------------
;     109 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;     110 {
_TWI_Start_Transc_With_Data:
;     111   unsigned char temp;
;     112                                                 // Adapte pour CVAVR
;     113   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x70:
	RCALL SUBOPT_0x0
	BRNE _0x70
;     114 
;     115   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;     116   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;     117   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x73
;     118   {												// If it is a write operation, then also copy data.
;     119     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x75:
	RCALL SUBOPT_0x2
	BRSH _0x76
;     120       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x6
	RJMP _0x75
_0x76:
;     121   }
;     122   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x73:
	CLR  R30
	STS  _TWI_statusReg,R30
;     123   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     124   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     125                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     126                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     127                                       			// (0<<TWWC);
;     128 } 
	RJMP _0x21D
;     129 //-----------------------------------------------------------------------------------------------------------------------------
;     130 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     131 {
_TWI_Get_Data_From_Transceiver:
;     132   unsigned char i;
;     133           
;     134   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0x78:
	RCALL SUBOPT_0x0
	BRNE _0x78
;     135 
;     136   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x7
	BREQ _0x7B
;     137   {                                             
;     138     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x7D:
	RCALL SUBOPT_0x2
	BRSH _0x7E
;     139     {
;     140       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     141     }
	RCALL SUBOPT_0x6
	RJMP _0x7D
_0x7E:
;     142   }
;     143   return( TWI_statusReg.lastTransOK );                                   
_0x7B:
	RCALL SUBOPT_0x7
_0x21D:
	ADIW R28,4
	RET
;     144 }  
;     145 //-----------------------------------------------------------------------------------------------------------------------------
;     146 
;     147 // ----------------------------------------------------------------------------------------------------------------------------
;     148 // Interruption TWI
;     149 // ----------------------------------------------------------------------------------------------------------------------------
;     150 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     151 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     152 												// __interrupt void TWI_ISR(void)
;     153   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     154   
;     155   switch (TWSR)
	IN   R30,0x1
;     156   {
;     157     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x84
;     158     
;     159     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x85
_0x84:
;     160       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     161       				
;     162     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x86
_0x85:
	CPI  R30,LOW(0x18)
	BRNE _0x87
_0x86:
;     163     
;     164     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x88
_0x87:
	CPI  R30,LOW(0x28)
	BRNE _0x89
_0x88:
;     165       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x8A
;     166       {
;     167         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x8
	LD   R30,Z
	OUT  0x3,R30
;     168         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x21E
;     169         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     170                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     171                						  			// (0<<TWWC); 
;     172       }
;     173       else                    					// Send STOP after last byte
_0x8A:
;     174       {
;     175         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x9
;     176          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     177         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x21E:
	OUT  0x36,R30
;     178         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     179                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     180                                				  	// (0<<TWWC);
;     181       }
;     182     break;
	RJMP _0x82
;     183       
;     184     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x89:
	CPI  R30,LOW(0x50)
	BRNE _0x8C
;     185       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x8
	MOVW R26,R30
	RCALL SUBOPT_0xA
;     186       
;     187     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x8D
_0x8C:
	CPI  R30,LOW(0x40)
	BRNE _0x8E
_0x8D:
;     188       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x8F
;     189       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     190         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x21F
;     191         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     192                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     193                                   				// (0<<TWWC);  
;     194       } else                    				// Send NACK after next reception
_0x8F:
;     195       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     196         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x21F:
	OUT  0x36,R30
;     197         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     198                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     199                                 			  	// (0<<TWWC); 
;     200       }    
;     201     break; 
	RJMP _0x82
;     202       
;     203     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x8E:
	CPI  R30,LOW(0x58)
	BRNE _0x91
;     204       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0xA
;     205       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x9
;     206       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     207       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x220
;     208                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     209                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     210                               					// (0<<TWWC); 
;     211     break;  
;     212           
;     213     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x91:
	CPI  R30,LOW(0x38)
	BRNE _0x92
;     214     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     215       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x220
;     216                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     217                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     218                               					// (0<<TWWC);
;     219     break;
;     220       
;     221     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x92:
	CPI  R30,LOW(0x20)
	BREQ _0x94
;     222     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x95
_0x94:
;     223     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0x96
_0x95:
	CPI  R30,LOW(0x30)
	BRNE _0x97
_0x96:
;     224 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     225     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0x98
_0x97:
	CPI  R30,0
	BRNE _0x9A
_0x98:
;     226     
;     227     default:     
_0x9A:
;     228       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     229       											// Reset TWI Interface
;     230                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     231       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x220:
	OUT  0x36,R30
;     232                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     233                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     234                               					// (0<<TWWC);
;     235   }
_0x82:
;     236 } 
	RCALL __LOADISR
	RETI
;     237 
;     238 										// A remplacer par une bibliothque ! 
;     239 // Dclarations divers
;     240 #define	Moteur1			0
;     241 #define	Moteur2			1
;     242 // =============================================================================================================================   
;     243 
;     244 // =============================================================================================================================
;     245 // =============================================================================================================================
;     246 // Constantes en flash
;     247 // -----------------------------------------------------------------------------------------------------------------------------
;     248 // Structure pour l'affichage du nom des registres  (A terminer)
;     249 //flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
;     250 // -----------------------------------------------------------------------------------------------------------------------------
;     251 // Messages textuels prdfinis
;     252 // ATTENTION: imprativement 16 caractres 
;     253 // ----------------------------------------------------------------------------------------------------------------------------- 
;     254 flash char *Texte_Accueil_Ligne1 	= "   Test SISI    ";

	.DSEG
_Texte_Accueil_Ligne1:
	.BYTE 0x2
;     255 flash char *Texte_Accueil_Ligne2 	= "     [TWI]      ";
_Texte_Accueil_Ligne2:
	.BYTE 0x2
;     256 flash char *TexteMenuLedBp			= "1 Test BP->Led  ";
_TexteMenuLedBp:
	.BYTE 0x2
;     257 flash char *TexteMenuMD23			= "2 Test MD23     "; 
_TexteMenuMD23:
	.BYTE 0x2
;     258 flash char *TexteMenuSD21			= "3 Test SD21     ";
_TexteMenuSD21:
	.BYTE 0x2
;     259 flash char *Ligne0MenuMode			= "21 Choix Modes  ";
_Ligne0MenuMode:
	.BYTE 0x2
;     260 flash char *Ligne0MenuInfos			= "22 Aff Infos    ";
_Ligne0MenuInfos:
	.BYTE 0x2
;     261 flash char *TexteTestBpsurLed	    = "Recopie Bp->Led ";
_TexteTestBpsurLed:
	.BYTE 0x2
;     262 flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
_Ligne1PlusMoins:
	.BYTE 0x2
;     263 flash char *Ligne1ChoixEntr			= "[Entr]          ";
_Ligne1ChoixEntr:
	.BYTE 0x2
;     264 flash char *Ligne1ChoixEchap		= "        [Echap] ";
_Ligne1ChoixEchap:
	.BYTE 0x2
;     265 flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
_Ligne1ChoixEchapOk:
	.BYTE 0x2
;     266 flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
_BpPlusSurD0:
	.BYTE 0x2
;     267 flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
_BpFlecheHSurD1:
	.BYTE 0x2
;     268 flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
_BpFlecheHSurD2:
	.BYTE 0x2
;     269 flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
_BpMoinsSurD3:
	.BYTE 0x2
;     270 flash char *BpSetSurD4				= "SET->D4 [Echap] ";
_BpSetSurD4:
	.BYTE 0x2
;     271 flash char *BpOkSurD5				= "Ok-> D5 [Echap] "; 
_BpOkSurD5:
	.BYTE 0x2
;     272 flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
_BpEntrSurD6:
	.BYTE 0x2
;     273 flash char *BpEchSurD7				= "ECH->D7 [Echap] ";
_BpEchSurD7:
	.BYTE 0x2
;     274 
;     275 // =============================================================================================================================
;     276 
;     277 // =============================================================================================================================
;     278 // =============================================================================================================================
;     279 // Prototypes des fonctions en cours de test
;     280 // ----------------------------------------------------------------------------------------------------------------------------- 
;     281 // ============================================================================================================================= 
;     282 
;     283 // ============================================================================================================================= 
;     284 // =============================================================================================================================
;     285 // ---------------------------------------------- Declare your global variables here -------------------------------------------
;     286 // -----------------------------------------------------------------------------------------------------------------------------
;     287 // Type				Nom														Description  
;     288 // ----------------------------------------------------------------------------------------------------------------------------- 
;     289 // Etats du graphe des transitions "Menus"
;     290 // -----------------------------------------------------------------------------------------------------------------------------
;     291 enum TMenu {Menu1_LED_BP, Menu2_MD23, Menu3_SD21, Copie_BP_Sur_Led, Menu21_Mode_MD23, Menu22_Infos_MD23, Choix_Mode_MD23, 
;     292 Reglage_Mode0_MD23, Reglage_Mode1_MD23,  Reglage_Mode2_MD23,Reglage_Mode3_MD23, Controle_Moteurs, Info_Batt, Info_Vers, Info_All} 
;     293 Menu=Menu1_LED_BP, Menu_1=Menu2_MD23;
;     294 // -----------------------------------------------------------------------------------------------------------------------------					
;     295 bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0 
;     296 // =============================================================================================================================
;     297 
;     298 
;     299 // =============================================================================================================================
;     300 // =============================================================================================================================
;     301 // Partie excutive du programme 
;     302 // =============================================================================================================================
;     303 // =============================================================================================================================
;     304 void main(void)
;     305 {

	.CSEG
_main:
;     306 // =============================================================================================================================
;     307 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     308 // =============================================================================================================================
;     309 // Messages pour les composants I2C 
;     310 // =============================================================================================================================
;     311 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
;     312 // ----------------------------------------------------------------------------------------------------------------------------- 
;     313 // Type 	   		Nom 				       						Description 
;     314 // ----------------------------------------------------------------------------------------------------------------------------- 
;     315 unsigned char Frame_I2C_LED_All_Off[]={Add_LED_I2C,0xff}; 		// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
;     316 unsigned char Frame_I2C_LED_Switching[]={Add_LED_I2C,0x00}; 	// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
;     317 																// or Off=1}. Initialisation = All On.
;     318 unsigned char Frame_I2C_BP_Read[]={Add_BP_I2C,0x00}; 			// Trame de lecture des BP {SLA+R=0x43, Data=Nul}      
;     319 // ============================================================================================================================= 
;     320 // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
;     321 // ----------------------------------------------------------------------------------------------------------------------------- 
;     322 // Type 	   		Nom 				       						Description 
;     323 // ----------------------------------------------------------------------------------------------------------------------------- 
;     324 unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
;     325 unsigned char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	// Trame de texte compose de: {SLA+W=0x76, cde=write to DDRAM ,  
;     326 						 	     								// le texte  afficher = 16 caractres max,  Nul }                  
;     327                                                             	// Cette trame est remplie avec le tableau String_to_LCD
;     328 // =============================================================================================================================
;     329 // 3) Liste de messages prdfinis pour la carte MD23 
;     330 // ============================================================================================================================= 
;     331 // 30) Initialisation
;     332 unsigned char Reset_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur};
;     333 
;     334 // 31) Mode
;     335 unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};
;     336 
;     337 // 32) Vitesse des moteurs 
;     338 unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur dans le mode 0
;     339 unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur dans le mode 0
;     340 unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs}; 
;     341 
;     342 // 33) Lecture des registres
;     343 unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		// Premire trame  envoyer { SLA_W=0xB0, N registre o commence
;     344 															// la lecture }
;     345 // ============================================================================================================================= 
;     346 
;     347 // =============================================================================================================================
;     348 // Variables diverses
;     349 // ----------------------------------------------------------------------------------------------------------------------------- 
;     350 // Type 			Nom 				       			   				Description 
;     351 // -----------------------------------------------------------------------------------------------------------------------------    
;     352 // 1) Gestion de la carte MD23
;     353 // -----------------------------------------------------------------------------------------------------------------------------
;     354 // Variables utilises dans la gestion de l'affichage:  limitent son rafrachissement
;     355 int Num_Reg_MD23_1=0, Num_Reg_MD23=0;                        		// Numro du registre slectionn pour l'affichage   
;     356 unsigned char Vitesse_MD23_1, Vitesse_MD23, BP_I2C=0, BP_I2C_1 = 1, Finesse_1=1, Finesse=1; 
;     357 unsigned char SpeedMot1, SpeedMot1_1, SpeedMot2, SpeedMot2_1; 		// Limite le rafrachissement de l'affichage
;     358 unsigned char Choix_Mode_1=1, Choix_Mode=0;                                                   		
;     359 unsigned char Ubatt_1=0, Ubatt=0;									// Tension alimentation carte MD23 
;     360 unsigned char Version_1=0, Version=0; 
;     361 // -----------------------------------------------------------------------------------------------------------------------------
;     362 															// Reoit le contenu des registres de la carte MD23. Liste ci-dessous
;     363 //Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev, AccRate, Mode, Cde
;     364 unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
;     365 
;     366 // 2) Gestion du LCD BATRON
;     367 // -----------------------------------------------------------------------------------------------------------------------------
;     368  char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];     // Reoivent les deux lignes de texte  envoyer  l'afficheur
;     369 															// (16 caractres max. + Nul)
;     370 // -----------------------------------------------------------------------------------------------------------------------------
;     371 // *****************************************************************************************************************************
;     372 
;     373 // =============================================================================================================================
;     374 // ===================================================== Initialisations =======================================================
;     375 // =============================================================================================================================
;     376 TWI_Master_Initialise(); 									// Initialisation de l'interface TWI en mode Standby 
	SBIW R28,63
	SBIW R28,48
	LDI  R24,77
	LDI  R26,LOW(34)
	LDI  R27,HIGH(34)
	LDI  R30,LOW(_0x9C*2)
	LDI  R31,HIGH(_0x9C*2)
	RCALL __INITLOCB
;	Frame_I2C_LED_All_Off -> Y+109
;	Frame_I2C_LED_Switching -> Y+107
;	Frame_I2C_BP_Read -> Y+105
;	Frame_I2C_LCD_BATRON_Clear -> Y+102
;	Frame_I2C_Lcd_Line -> Y+83
;	Reset_MD23 -> Y+80
;	Mode0_MD23 -> Y+77
;	Speed1 -> Y+74
;	Speed2 -> Y+71
;	Time_OUT_Desable -> Y+68
;	Read_Reg_MD23_W -> Y+66
;	Num_Reg_MD23_1 -> R16,R17
;	Num_Reg_MD23 -> R18,R19
;	Vitesse_MD23_1 -> R20
;	Vitesse_MD23 -> R21
;	BP_I2C -> Y+65
;	BP_I2C_1 -> Y+64
;	Finesse_1 -> Y+63
;	Finesse -> Y+62
;	SpeedMot1 -> Y+61
;	SpeedMot1_1 -> Y+60
;	SpeedMot2 -> Y+59
;	SpeedMot2_1 -> Y+58
;	Choix_Mode_1 -> Y+57
;	Choix_Mode -> Y+56
;	Ubatt_1 -> Y+55
;	Ubatt -> Y+54
;	Version_1 -> Y+53
;	Version -> Y+52
;	Table_Registers_MD23 -> Y+34
;	Buffer_for_LCD_Line0 -> Y+17
;	Buffer_for_LCD_Line1 -> Y+0
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	RCALL _TWI_Master_Initialise
;     377 // -----------------------------------------------------------------------------------------------------------------------------
;     378 // Global enable interrupts
;     379 #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI				
	sei
;     380 // -----------------------------------------------------------------------------------------------------------------------------
;     381 TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte S_ISI 	
	MOVW R30,R28
	SUBI R30,LOW(-(109))
	SBCI R31,HIGH(-(109))
	RCALL SUBOPT_0xB
;     382 // -----------------------------------------------------------------------------------------------------------------------------
;     383 // Initialisation de l'afficheur I2C BATRON 
;     384 // -----------------------------------------------------------------------------------------------------------------------------
;     385 Init_LCD_I2C_BATRON();
	RCALL _Init_LCD_I2C_BATRON
;     386 // -----------------------------------------------------------------------------------------------------------------------------
;     387 // Affichage d'un message d'accueil
;     388 // -----------------------------------------------------------------------------------------------------------------------------
;     389 sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	RCALL SUBOPT_0xC
	LDS  R30,_Texte_Accueil_Ligne1
	LDS  R31,_Texte_Accueil_Ligne1+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     390 sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	RCALL SUBOPT_0xE
	LDS  R30,_Texte_Accueil_Ligne2
	LDS  R31,_Texte_Accueil_Ligne2+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     391 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     392 delay_ms(4000); 
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x10
;     393 // -----------------------------------------------------------------------------------------------------------------------------
;     394 // Initialisation des registres de  la carte MD23
;     395 // -----------------------------------------------------------------------------------------------------------------------------
;     396  
;     397 TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));	
	MOVW R30,R28
	SUBI R30,LOW(-(80))
	SBCI R31,HIGH(-(80))
	RCALL SUBOPT_0x11
;     398 TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
	MOVW R30,R28
	SUBI R30,LOW(-(68))
	SBCI R31,HIGH(-(68))
	RCALL SUBOPT_0x11
;     399 TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(77))
	SBCI R31,HIGH(-(77))
	RCALL SUBOPT_0x11
;     400 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	RCALL SUBOPT_0x12
;     401 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
	RCALL SUBOPT_0x13
;     402 
;     403 
;     404 // =============================================================================================================================
;     405 // ================================================ Boucle principale ==========================================================
;     406 // =============================================================================================================================
;     407 while (1)
_0x9D:
;     408       { 
;     409 // ---------------------------------------------  Champ Lecture des donnes ---------------------------------------------------- 
;     410 // Lecture de l'tat des BP
;     411 // ---------------------------------------------------------------------------------------------------------------------------- 
;     412 // Lecture des BP pour affichage sur les LED
;     413 	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));    // Envoi de l'octet d'adresse des BP: SLA+R=0x43 
	MOVW R30,R28
	SUBI R30,LOW(-(105))
	SBCI R31,HIGH(-(105))
	RCALL SUBOPT_0xB
;     414 																		// Rcupration de l'octet reprsentatif de l'tat des BP	
;     415 	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read)); 
	MOVW R30,R28
	SUBI R30,LOW(-(105))
	SBCI R31,HIGH(-(105))
	RCALL SUBOPT_0x14
;     416 	
;     417     BP_I2C = Lire_BP_I2C();														// Lecture des BP avec gestion anti-rebond 
	RCALL _Lire_BP_I2C
	__PUTB1SX 65
;     418 // ----------------------------------------------------------------------------------------------------------------------------    
;     419 // Lecture des registres de la carte MD23 
;     420    if (Menu != Reglage_Mode0_MD23)
	LDI  R30,LOW(7)
	CP   R30,R5
	BREQ _0xA0
;     421    {                                                           // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
;     422 	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W)); 
	MOVW R30,R28
	SUBI R30,LOW(-(66))
	SBCI R31,HIGH(-(66))
	RCALL SUBOPT_0xB
;     423    	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture  
	RCALL SUBOPT_0x15
	RCALL _TWI_Start_Transc_With_Data
;     424 	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));  
	RCALL SUBOPT_0x15
	RCALL _TWI_Get_Data_From_Transceiver
;     425    }    
;     426 // ----------------------------------------------------------------------------------------------------------------------------
;     427 // --------------------------------------------------- Champ Traitement--------------------------------------------------------  
;     428     switch(Menu)
_0xA0:
	MOV  R30,R5
;     429     {// Dbut du switch1 
;     430 // -------------------------------------------------Dbut Menus droulants-----------------------------------------------------
;     431 // Menus Niveau 1 -------------------------------------------------------------------------------------------------------------
;     432 // ----------------------------------------------------------------------------------------------------------------------------
;     433 // Menu 1 : Recopie de l'tat des BP sur les LED
;     434        case Menu1_LED_BP : if (Menu_1 != Menu)
	CPI  R30,0
	BRNE _0xA4
	CP   R5,R6
	BREQ _0xA5
;     435        		{
;     436                 sprintf(Buffer_for_LCD_Line0,TexteMenuLedBp);
	RCALL SUBOPT_0xC
	LDS  R30,_TexteMenuLedBp
	LDS  R31,_TexteMenuLedBp+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     437 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     438 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     439 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     440        		}
;     441        		switch (BP_I2C)
_0xA5:
	RCALL SUBOPT_0x17
;     442 				{                                  
;     443 					case ENTR_I2C: Menu = Copie_BP_Sur_Led;  break; // touche Enter
	BRNE _0xA9
	RCALL SUBOPT_0x18
	RJMP _0xA8
;     444 					case FlecheH_I2C: Menu = Menu3_SD21;  break; // touche flche haut
_0xA9:
	CPI  R30,LOW(0x2)
	BRNE _0xAA
	LDI  R30,LOW(2)
	MOV  R5,R30
	RJMP _0xA8
;     445 					case FlecheB_I2C: Menu = Menu2_MD23;  break; // touche flche bas 
_0xAA:
	CPI  R30,LOW(0x4)
	BRNE _0xAC
	LDI  R30,LOW(1)
	MOV  R5,R30
	RJMP _0xA8
;     446 					default: Menu = Menu1_LED_BP;
_0xAC:
	CLR  R5
;     447 				} 
_0xA8:
;     448      			      
;     449 			Menu_1 = Menu1_LED_BP;
	CLR  R6
;     450        
;     451        break;
	RJMP _0xA3
;     452 // ----------------------------------------------------------------------------------------------------------------------------      
;     453 // Menu 2 : Test de la carte MD23
;     454        case Menu2_MD23 : if (Menu_1 != Menu)
_0xA4:
	CPI  R30,LOW(0x1)
	BRNE _0xAD
	CP   R5,R6
	BREQ _0xAE
;     455        		{
;     456                 sprintf(Buffer_for_LCD_Line0,TexteMenuMD23);
	RCALL SUBOPT_0xC
	LDS  R30,_TexteMenuMD23
	LDS  R31,_TexteMenuMD23+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     457 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     458 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     459 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     460        		}
;     461        		switch (BP_I2C)
_0xAE:
	RCALL SUBOPT_0x17
;     462 				{                                  
;     463 					case ENTR_I2C: Menu = Menu21_Mode_MD23;  break; // touche Enter
	BRNE _0xB2
	LDI  R30,LOW(4)
	RJMP _0x221
;     464 					case FlecheH_I2C: Menu = Menu1_LED_BP;  break; // touche flche haut
_0xB2:
	CPI  R30,LOW(0x2)
	BRNE _0xB3
	CLR  R5
	RJMP _0xB1
;     465 					case FlecheB_I2C: Menu = Menu3_SD21;  break; // touche flche bas 
_0xB3:
	CPI  R30,LOW(0x4)
	BRNE _0xB5
	LDI  R30,LOW(2)
	RJMP _0x221
;     466 					default: Menu = Menu2_MD23 ;
_0xB5:
	LDI  R30,LOW(1)
_0x221:
	MOV  R5,R30
;     467 				} 
_0xB1:
;     468      			      
;     469 			Menu_1 = Menu2_MD23 ;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     470        
;     471        break;   
	RJMP _0xA3
;     472 // ----------------------------------------------------------------------------------------------------------------------------      
;     473 // Menu 3 : Test de la carte SD21
;     474        case Menu3_SD21 : if (Menu_1 != Menu)
_0xAD:
	CPI  R30,LOW(0x2)
	BRNE _0xB6
	CP   R5,R6
	BREQ _0xB7
;     475        		{
;     476                 sprintf(Buffer_for_LCD_Line0,TexteMenuSD21);
	RCALL SUBOPT_0xC
	LDS  R30,_TexteMenuSD21
	LDS  R31,_TexteMenuSD21+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     477 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     478 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     479 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     480        		}
;     481        		switch (BP_I2C)
_0xB7:
	RCALL SUBOPT_0x17
;     482 				{                                  
;     483 					case ENTR_I2C: Menu = Menu21_Mode_MD23;  break; // touche Enter
	BRNE _0xBB
	LDI  R30,LOW(4)
	RJMP _0x222
;     484 					case FlecheH_I2C: Menu = Menu2_MD23;  break; // touche flche haut
_0xBB:
	CPI  R30,LOW(0x2)
	BRNE _0xBC
	LDI  R30,LOW(1)
	RJMP _0x222
;     485 					case FlecheB_I2C: Menu = Menu1_LED_BP;  break; // touche flche bas 
_0xBC:
	CPI  R30,LOW(0x4)
	BRNE _0xBE
	CLR  R5
	RJMP _0xBA
;     486 					default: Menu = Menu3_SD21 ;
_0xBE:
	LDI  R30,LOW(2)
_0x222:
	MOV  R5,R30
;     487 				} 
_0xBA:
;     488      			      
;     489 			Menu_1 = Menu3_SD21 ;
	LDI  R30,LOW(2)
	MOV  R6,R30
;     490        
;     491        break;
	RJMP _0xA3
;     492 // ----------------------------------------------------------------------------------------------------------------------------
;     493 // Menus Niveau 2 -------------------------------------------------------------------------------------------------------------
;     494 // ----------------------------------------------------------------------------------------------------------------------------
;     495 		case Menu21_Mode_MD23 : if (Menu_1 != Menu)
_0xB6:
	CPI  R30,LOW(0x4)
	BREQ PC+2
	RJMP _0xBF
	CP   R5,R6
	BREQ _0xC0
;     496 			{ 
;     497 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuMode
	LDS  R31,_Ligne0MenuMode+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     498 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x19
	LDI  R24,0
	RCALL SUBOPT_0xD
;     499 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     500 				LCD_I2C_BATRON_gotoxy(0,15); 						 	     
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1B
	RCALL _LCD_I2C_BATRON_gotoxy
;     501 				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0)); 
	MOVW R30,R28
	SUBI R30,LOW(-(83))
	SBCI R31,HIGH(-(83))
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
;     502 				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line)); 
	MOVW R30,R28
	SUBI R30,LOW(-(83))
	SBCI R31,HIGH(-(83))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(85))
	SBCI R31,HIGH(-(85))
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1E
;     503 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     504 			}
;     505      			     	
;     506 			switch (BP_I2C)
_0xC0:
	RCALL SUBOPT_0x17
;     507 				{                                  
;     508 					case ENTR_I2C: Menu = Choix_Mode_MD23;  break; // touche Enter
	BRNE _0xC4
	LDI  R30,LOW(6)
	RJMP _0x223
;     509 					case FlecheH_I2C: Menu = Menu22_Infos_MD23;  break; // touche flche haut
_0xC4:
	CPI  R30,LOW(0x2)
	BRNE _0xC5
	LDI  R30,LOW(5)
	RJMP _0x223
;     510 					case FlecheB_I2C: Menu = Menu22_Infos_MD23;  break; // touche flche bas 
_0xC5:
	CPI  R30,LOW(0x4)
	BRNE _0xC6
	LDI  R30,LOW(5)
	RJMP _0x223
;     511 					case ECHAP_I2C : Menu = Menu2_MD23; break;  // touche ECHAP
_0xC6:
	CPI  R30,LOW(0x80)
	BRNE _0xC8
	LDI  R30,LOW(1)
	RJMP _0x223
;     512 					default: Menu = Menu21_Mode_MD23 ;
_0xC8:
	LDI  R30,LOW(4)
_0x223:
	MOV  R5,R30
;     513 				} 
;     514      			      
;     515 			Menu_1 = Menu21_Mode_MD23;
	LDI  R30,LOW(4)
	MOV  R6,R30
;     516 		break;
	RJMP _0xA3
;     517 // ----------------------------------------------------------------------------------------------------------------------------     
;     518 		case Menu22_Infos_MD23: if (Menu_1 != Menu)
_0xBF:
	CPI  R30,LOW(0x5)
	BRNE _0xC9
	CP   R5,R6
	BREQ _0xCA
;     519 			{ 
;     520 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuInfos
	LDS  R31,_Ligne0MenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     521 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     522 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     523 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     524 			}
;     525      			     	
;     526 			switch (BP_I2C)
_0xCA:
	RCALL SUBOPT_0x17
;     527 				{                                  
;     528 					case ENTR_I2C: Menu = Info_All;  break; 
	BRNE _0xCE
	LDI  R30,LOW(14)
	RJMP _0x224
;     529 					case FlecheH_I2C: Menu = Menu21_Mode_MD23;  break; 
_0xCE:
	CPI  R30,LOW(0x2)
	BRNE _0xCF
	LDI  R30,LOW(4)
	RJMP _0x224
;     530 					case FlecheB_I2C: Menu = Menu21_Mode_MD23;  break; 
_0xCF:
	CPI  R30,LOW(0x4)
	BRNE _0xD0
	LDI  R30,LOW(4)
	RJMP _0x224
;     531 					case ECHAP_I2C : Menu = Menu2_MD23; break;  // touche ECHAP 
_0xD0:
	CPI  R30,LOW(0x80)
	BRNE _0xD2
	LDI  R30,LOW(1)
	RJMP _0x224
;     532 					default: Menu = Menu22_Infos_MD23 ;
_0xD2:
	LDI  R30,LOW(5)
_0x224:
	MOV  R5,R30
;     533 				}  
;     534      			      
;     535 			Menu_1 = Menu22_Infos_MD23 ;
	LDI  R30,LOW(5)
	MOV  R6,R30
;     536 		break;
	RJMP _0xA3
;     537 // ----------------------------------------------------------------------------------------------------------------------------
;     538 // Menus Niveau 3 -------------------------------------------------------------------------------------------------------------
;     539 // ----------------------------------------------------------------------------------------------------------------------------  
;     540 // Affichage du nom du BP et de la LED  laquelle il est associ
;     541 			case Copie_BP_Sur_Led : if ((Menu_1 != Menu) || ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF)))
_0xC9:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xD3
	CP   R5,R6
	BRNE _0xD5
	__GETB1SX 64
	__GETB2SX 65
	CP   R30,R26
	BREQ _0xD6
	CPI  R26,LOW(0xFF)
	BRNE _0xD5
_0xD6:
	RJMP _0xD4
_0xD5:
;     542 				{   
;     543 				 sprintf(Buffer_for_LCD_Line0,TexteTestBpsurLed); 
	RCALL SUBOPT_0xC
	LDS  R30,_TexteTestBpsurLed
	LDS  R31,_TexteTestBpsurLed+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     544 				 
;     545 				 switch (BP_I2C)
	RCALL SUBOPT_0x17
;     546 				  {
;     547 				 	case ENTR_I2C : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
	BRNE _0xDC
	RCALL SUBOPT_0xE
	LDS  R30,_BpEntrSurD6
	LDS  R31,_BpEntrSurD6+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     548 				 	case FlecheH_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
_0xDC:
	CPI  R30,LOW(0x2)
	BRNE _0xDD
	RCALL SUBOPT_0xE
	LDS  R30,_BpFlecheHSurD1
	LDS  R31,_BpFlecheHSurD1+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     549 				 	case FlecheB_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
_0xDD:
	CPI  R30,LOW(0x4)
	BRNE _0xDE
	RCALL SUBOPT_0xE
	LDS  R30,_BpFlecheHSurD2
	LDS  R31,_BpFlecheHSurD2+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     550 				 	case ECHAP_I2C : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break; 
_0xDE:
	CPI  R30,LOW(0x80)
	BRNE _0xDF
	RCALL SUBOPT_0xE
	LDS  R30,_BpEchSurD7
	LDS  R31,_BpEchSurD7+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     551 				 	case OK_I2C : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
_0xDF:
	CPI  R30,LOW(0x20)
	BRNE _0xE0
	RCALL SUBOPT_0xE
	LDS  R30,_BpOkSurD5
	LDS  R31,_BpOkSurD5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     552 				 	case MOINS_I2C: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
_0xE0:
	CPI  R30,LOW(0x8)
	BRNE _0xE1
	RCALL SUBOPT_0xE
	LDS  R30,_BpMoinsSurD3
	LDS  R31,_BpMoinsSurD3+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     553 				 	case PLUS_I2C: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
_0xE1:
	CPI  R30,LOW(0x1)
	BRNE _0xE2
	RCALL SUBOPT_0xE
	LDS  R30,_BpPlusSurD0
	LDS  R31,_BpPlusSurD0+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     554 				 	case SET_I2C: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
_0xE2:
	CPI  R30,LOW(0x10)
	BRNE _0xE3
	RCALL SUBOPT_0xE
	LDS  R30,_BpSetSurD4
	LDS  R31,_BpSetSurD4+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x225
;     555 				 	case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap ); 	 
_0xE3:
	CPI  R30,0
	BRNE _0xDB
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1F
	LDI  R24,0
_0x225:
	RCALL _sprintf
	ADIW R28,4
;     556 				  }
_0xDB:
;     557 					
;     558 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     559 					BP_I2C_1 = BP_I2C;
	__GETB1SX 65
	__PUTB1SX 64
;     560 			   	 } 
;     561 
;     562         		if (BP_I2C == ECHAP_I2C)  
_0xD4:
	__GETB2SX 65
	CPI  R26,LOW(0x80)
	BRNE _0xE5
;     563         		  { 
;     564         			Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1]; 
	RCALL SUBOPT_0x20
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x21
	POP  R26
	POP  R27
	RCALL SUBOPT_0x22
;     565         			TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
;     566         			delay_ms(1000); 
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x10
;     567         			Menu = Menu1_LED_BP;
	CLR  R5
;     568         		  } 
;     569         		else  Menu = Copie_BP_Sur_Led;
	RJMP _0xE6
_0xE5:
	RCALL SUBOPT_0x18
_0xE6:
;     570 					 
;     571 			    Menu_1 = Copie_BP_Sur_Led;
	LDI  R30,LOW(3)
	MOV  R6,R30
;     572 			break;
	RJMP _0xA3
;     573 // ----------------------------------------------------------------------------------------------------------------------------			 
;     574 	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
_0xD3:
	CPI  R30,LOW(0x6)
	BREQ PC+2
	RJMP _0xE7
	CP   R5,R6
	BRNE _0xE9
	LDD  R30,Y+56
	LDD  R26,Y+57
	CP   R30,R26
	BREQ _0xE8
_0xE9:
;     575 	          {
;     576 	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,0
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
	LDI  R24,4
	RCALL SUBOPT_0x25
;     577 	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	RCALL SUBOPT_0x19
	LDI  R24,0
	RCALL SUBOPT_0xD
;     578 	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     579 	        	 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     580 	        	 Choix_Mode_1 = Choix_Mode;
	LDD  R30,Y+56
	STD  Y+57,R30
;     581 	          }  
;     582 	          
;     583 	          switch (BP_I2C)
_0xE8:
	RCALL SUBOPT_0x26
;     584 				{
;     585 					case ECHAP_I2C : Menu=Menu21_Mode_MD23; break;  // touche ECHAP
	BRNE _0xEE
	LDI  R30,LOW(4)
	RJMP _0x226
;     586 					case FlecheH_I2C: if (Choix_Mode < 3) Choix_Mode = Choix_Mode + 1; else Choix_Mode=0;  break; // touche +
_0xEE:
	CPI  R30,LOW(0x2)
	BRNE _0xEF
	LDD  R26,Y+56
	CPI  R26,LOW(0x3)
	BRSH _0xF0
	LDD  R30,Y+56
	SUBI R30,-LOW(1)
	RJMP _0x227
_0xF0:
	CLR  R30
_0x227:
	STD  Y+56,R30
	RJMP _0xED
;     587 					case FlecheB_I2C: if (Choix_Mode > 0) Choix_Mode = Choix_Mode - 1; else Choix_Mode=3;  break; // touche -
_0xEF:
	CPI  R30,LOW(0x4)
	BRNE _0xF2
	LDD  R26,Y+56
	RCALL SUBOPT_0x27
	BRSH _0xF3
	LDD  R30,Y+56
	SUBI R30,LOW(1)
	RJMP _0x228
_0xF3:
	LDI  R30,LOW(3)
_0x228:
	STD  Y+56,R30
	RJMP _0xED
;     588 					case ENTR_I2C: if (Choix_Mode == 0) {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Mode0_MD23;};	break; 
_0xF2:
	CPI  R30,LOW(0x40)
	BRNE _0xF7
	LDD  R30,Y+56
	CPI  R30,0
	BRNE _0xF6
	LDI  R30,LOW(128)
	STD  Y+61,R30
	STD  Y+59,R30
	LDI  R30,LOW(7)
	MOV  R5,R30
_0xF6:
	RJMP _0xED
;     589 					 
;     590 					default: Menu=Choix_Mode_MD23;
_0xF7:
	LDI  R30,LOW(6)
_0x226:
	MOV  R5,R30
;     591 				}  
_0xED:
;     592        		 	
;     593 			  Menu_1 = Choix_Mode_MD23;
	LDI  R30,LOW(6)
	MOV  R6,R30
;     594 	        break;
	RJMP _0xA3
;     595 // ----------------------------------------------------------------------------------------------------------------------------
;     596             case Reglage_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
_0xE7:
	CPI  R30,LOW(0x7)
	BREQ PC+2
	RJMP _0xF8
	CP   R5,R6
	BRNE _0xFA
	LDD  R30,Y+61
	LDD  R26,Y+60
	CP   R30,R26
	BRNE _0xFA
	LDD  R30,Y+59
	LDD  R26,Y+58
	CP   R30,R26
	BRNE _0xFA
	LDD  R30,Y+62
	LDD  R26,Y+63
	CP   R30,R26
	BREQ _0xF9
_0xFA:
;     597               {
;     598                 sprintf(Buffer_for_LCD_Line0,"1.%-u Mode%-u (+%-u)  ",Choix_Mode+1,Choix_Mode,Finesse);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,19
	RCALL SUBOPT_0x23
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x24
	__GETB1SX 64
	RCALL SUBOPT_0x24
	__GETB1SX 74
	RCALL SUBOPT_0x24
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     599                 sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
	RCALL SUBOPT_0xE
	__POINTW1FN _155,42
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 65
	RCALL SUBOPT_0x24
	__GETB1SX 67
	RCALL SUBOPT_0x24
	LDI  R24,8
	RCALL SUBOPT_0x28
;     600                 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     601                 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     602                 SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
	LDD  R30,Y+61
	STD  Y+60,R30
	LDD  R30,Y+59
	STD  Y+58,R30
	LDD  R30,Y+62
	STD  Y+63,R30
;     603               }
;     604               
;     605               
;     606               switch (BP_I2C)
_0xF9:
	RCALL SUBOPT_0x26
;     607 				{
;     608 				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;  
	BRNE _0xFF
	LDI  R30,LOW(6)
	RJMP _0x229
;     609 				 	
;     610 				 	case PLUS_I2C:  
_0xFF:
	CPI  R30,LOW(0x1)
	BRNE _0x100
;     611 				 		switch (Choix_Moteur)
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     612 				 		  { 
;     613 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0x104
	RCALL SUBOPT_0x29
	BRNE _0x105
;     614 				 		   					if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
	LDD  R26,Y+61
	CPI  R26,LOW(0xFF)
	BRSH _0x106
	LDD  R30,Y+61
	SUBI R30,-LOW(1)
	RJMP _0x22A
_0x106:
	LDI  R30,LOW(255)
_0x22A:
	STD  Y+61,R30
;     615 				 		   			else    
	RJMP _0x108
_0x105:
;     616 				 		   					if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
	LDD  R26,Y+61
	CPI  R26,LOW(0xFA)
	BRSH _0x109
	LDD  R30,Y+61
	SUBI R30,-LOW(5)
	RJMP _0x22B
_0x109:
	LDI  R30,LOW(255)
_0x22B:
	STD  Y+61,R30
_0x108:
;     617 				 		   	break;
	RJMP _0x103
;     618 				 		   	case Moteur2: if (Finesse==1)
_0x104:
	CPI  R30,LOW(0x1)
	BRNE _0x103
	RCALL SUBOPT_0x29
	BRNE _0x10C
;     619 				 		   					if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
	LDD  R26,Y+59
	CPI  R26,LOW(0xFF)
	BRSH _0x10D
	LDD  R30,Y+59
	SUBI R30,-LOW(1)
	RJMP _0x22C
_0x10D:
	LDI  R30,LOW(255)
_0x22C:
	STD  Y+59,R30
;     620 				 		   			else    
	RJMP _0x10F
_0x10C:
;     621 				 		   					if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
	LDD  R26,Y+59
	CPI  R26,LOW(0xFA)
	BRSH _0x110
	LDD  R30,Y+59
	SUBI R30,-LOW(5)
	RJMP _0x22D
_0x110:
	LDI  R30,LOW(255)
_0x22D:
	STD  Y+59,R30
_0x10F:
;     622 				 		   	break;
;     623 				 		  }
_0x103:
;     624 				 	break;
	RJMP _0xFE
;     625 				 	case MOINS_I2C:   
_0x100:
	CPI  R30,LOW(0x8)
	BRNE _0x112
;     626 				 	    switch (Choix_Moteur)
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     627 				 		  { 
;     628 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0x116
	RCALL SUBOPT_0x29
	BRNE _0x117
;     629 				 		   					if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
	LDD  R26,Y+61
	RCALL SUBOPT_0x27
	BRSH _0x118
	LDD  R30,Y+61
	SUBI R30,LOW(1)
	RJMP _0x22E
_0x118:
	CLR  R30
_0x22E:
	STD  Y+61,R30
;     630 				 		   			else    
	RJMP _0x11A
_0x117:
;     631 				 		   					if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0; 
	LDD  R26,Y+61
	RCALL SUBOPT_0x2A
	BRSH _0x11B
	LDD  R30,Y+61
	SUBI R30,LOW(5)
	RJMP _0x22F
_0x11B:
	CLR  R30
_0x22F:
	STD  Y+61,R30
_0x11A:
;     632 				 		   	break;
	RJMP _0x115
;     633 				 		   	case Moteur2: if (Finesse==1)
_0x116:
	CPI  R30,LOW(0x1)
	BRNE _0x115
	RCALL SUBOPT_0x29
	BRNE _0x11E
;     634 				 		   					if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
	LDD  R26,Y+59
	RCALL SUBOPT_0x27
	BRSH _0x11F
	LDD  R30,Y+59
	SUBI R30,LOW(1)
	RJMP _0x230
_0x11F:
	CLR  R30
_0x230:
	STD  Y+59,R30
;     635 				 		   			else    
	RJMP _0x121
_0x11E:
;     636 				 		   					if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
	LDD  R26,Y+59
	RCALL SUBOPT_0x2A
	BRSH _0x122
	LDD  R30,Y+59
	SUBI R30,LOW(5)
	RJMP _0x231
_0x122:
	CLR  R30
_0x231:
	STD  Y+59,R30
_0x121:
;     637 				 			break;
;     638 				 		  }
_0x115:
;     639 				 	break;
	RJMP _0xFE
;     640 				 	
;     641 				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1;
_0x112:
	CPI  R30,LOW(0x2)
	BRNE _0x124
	RCALL SUBOPT_0x29
	BRNE _0x125
	LDI  R30,LOW(5)
	RJMP _0x232
_0x125:
	LDI  R30,LOW(1)
_0x232:
	STD  Y+62,R30
;     642 				 	break; 
	RJMP _0xFE
;     643 				 	
;     644 				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; 
_0x124:
	CPI  R30,LOW(0x4)
	BRNE _0x127
	RCALL SUBOPT_0x29
	BRNE _0x128
	LDI  R30,LOW(5)
	RJMP _0x233
_0x128:
	LDI  R30,LOW(1)
_0x233:
	STD  Y+62,R30
;     645 				 	break; 
	RJMP _0xFE
;     646 				 	
;     647 				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; 
_0x127:
	CPI  R30,LOW(0x20)
	BRNE _0x12A
	SBRS R2,0
	RJMP _0x12B
	CLT
	BLD  R2,0
	RJMP _0x12C
_0x12B:
	SET
	BLD  R2,0
_0x12C:
;     648 				 	break; 
	RJMP _0xFE
;     649 				 	
;     650 				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2; 
_0x12A:
	CPI  R30,LOW(0x10)
	BRNE _0x12E
	LDD  R30,Y+61
	__PUTB1SX 76
	LDD  R30,Y+59
	__PUTB1SX 73
;     651 				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	RCALL SUBOPT_0x12
;     652 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
	RCALL SUBOPT_0x13
;     653 				    break;
	RJMP _0xFE
;     654 				     
;     655 					default: Menu = Reglage_Mode0_MD23;
_0x12E:
	LDI  R30,LOW(7)
_0x229:
	MOV  R5,R30
;     656 				}  
_0xFE:
;     657 			  Menu_1 = Reglage_Mode0_MD23;   
	LDI  R30,LOW(7)
	MOV  R6,R30
;     658 			break;
	RJMP _0xA3
;     659 // ----------------------------------------------------------------------------------------------------------------------------	        
;     660 		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];  
_0xF8:
	CPI  R30,LOW(0xE)
	BREQ PC+2
	RJMP _0x12F
	LDD  R21,Y+40
;     661 			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23)) 
	CP   R5,R6
	BRNE _0x131
	__CPWRR 18,19,16,17
	BRNE _0x131
	CP   R21,R20
	BREQ _0x130
_0x131:
;     662 			  {	
;     663 				sprintf(Buffer_for_LCD_Line0,"2.1 Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;   
	RCALL SUBOPT_0xC
	__POINTW1FN _155,58
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 18,19
	RCALL __CWD1
	RCALL __PUTPARD1
	__GETW1R 18,19
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,42
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x24
	LDI  R24,8
	RCALL SUBOPT_0x28
;     664 				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
	RCALL SUBOPT_0xE
	LDS  R30,_Ligne1PlusMoins
	LDS  R31,_Ligne1PlusMoins+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x2B
;     665 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     666 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     667 				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
	__MOVEWRR 16,17,18,19
	MOV  R20,R21
;     668 			  }	
;     669        		              
;     670 			switch (BP_I2C)
_0x130:
	RCALL SUBOPT_0x26
;     671 				{
;     672 					case ECHAP_I2C : Menu=Menu22_Infos_MD23; break;  
	BRNE _0x136
	LDI  R30,LOW(5)
	RJMP _0x234
;     673 					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break; 
_0x136:
	CPI  R30,LOW(0x1)
	BRNE _0x137
	__CPWRN 18,19,16
	BRGE _0x138
	__ADDWRN 18,19,1
	RJMP _0x139
_0x138:
	__GETWRN 18,19,0
_0x139:
	RJMP _0x135
;     674 					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break; 
_0x137:
	CPI  R30,LOW(0x8)
	BRNE _0x13A
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x13B
	__SUBWRN 18,19,1
	RJMP _0x13C
_0x13B:
	__GETWRN 18,19,16
_0x13C:
	RJMP _0x135
;     675 					case FlecheH_I2C: Menu = Info_Batt;  break; 
_0x13A:
	CPI  R30,LOW(0x2)
	BRNE _0x13D
	LDI  R30,LOW(12)
	RJMP _0x234
;     676 					case FlecheB_I2C: Menu = Info_Vers;  break; 
_0x13D:
	CPI  R30,LOW(0x4)
	BRNE _0x13F
	LDI  R30,LOW(13)
	RJMP _0x234
;     677 					default: Menu=Info_All;
_0x13F:
	LDI  R30,LOW(14)
_0x234:
	MOV  R5,R30
;     678 				}  
_0x135:
;     679        		 	
;     680 			Menu_1 = Info_All;		   
	LDI  R30,LOW(14)
	MOV  R6,R30
;     681 		break;       
	RJMP _0xA3
;     682 // ----------------------------------------------------------------------------------------------------------------------------	        
;     683 		case Info_Vers:	Version = Table_Registers_MD23[14];  
_0x12F:
	CPI  R30,LOW(0xD)
	BRNE _0x140
	LDD  R30,Y+48
	STD  Y+52,R30
;     684 			if ((Menu_1 != Menu)||(Version_1 != Version)) 
	CP   R5,R6
	BRNE _0x142
	LDD  R26,Y+53
	CP   R30,R26
	BREQ _0x141
_0x142:
;     685    			  {	
;     686 				sprintf(Buffer_for_LCD_Line0,"2.2 Version=%-u",Version);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,74
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+56
	RCALL SUBOPT_0x24
	LDI  R24,4
	RCALL SUBOPT_0x25
;     687 				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x2B
;     688 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     689 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     690 				Version_1 = Version;
	LDD  R30,Y+52
	STD  Y+53,R30
;     691 			  }	
;     692        		              
;     693 			switch (BP_I2C)
_0x141:
	RCALL SUBOPT_0x26
;     694 				{
;     695 					case ECHAP_I2C : Menu=Menu22_Infos_MD23; break;  
	BRNE _0x147
	LDI  R30,LOW(5)
	RJMP _0x235
;     696 					case FlecheH_I2C: Menu = Info_All;  break; 
_0x147:
	CPI  R30,LOW(0x2)
	BRNE _0x148
	LDI  R30,LOW(14)
	RJMP _0x235
;     697 					case FlecheB_I2C: Menu = Info_Batt;  break; 
_0x148:
	CPI  R30,LOW(0x4)
	BRNE _0x14A
	LDI  R30,LOW(12)
	RJMP _0x235
;     698 					default: Menu=Info_Vers;
_0x14A:
	LDI  R30,LOW(13)
_0x235:
	MOV  R5,R30
;     699 				}  
;     700        		 	
;     701 			Menu_1 = Info_Vers;		   
	LDI  R30,LOW(13)
	MOV  R6,R30
;     702 		break;     
	RJMP _0xA3
;     703 // ----------------------------------------------------------------------------------------------------------------------------       
;     704 		case Info_Batt:  	Ubatt = Table_Registers_MD23[11];  
_0x140:
	CPI  R30,LOW(0xC)
	BRNE _0xA3
	LDD  R30,Y+45
	STD  Y+54,R30
;     705 			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt)) 
	CP   R5,R6
	BRNE _0x14D
	LDD  R26,Y+55
	CP   R30,R26
	BREQ _0x14C
_0x14D:
;     706    			  {	
;     707 					sprintf(Buffer_for_LCD_Line0,"2.3 Ubatt=%-u.%-uV",Ubatt/10, Ubatt-10*(Ubatt/10));
	RCALL SUBOPT_0xC
	__POINTW1FN _155,90
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+58
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x24
	LDD  R26,Y+62
	RCALL SUBOPT_0x2C
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	LDD  R26,Y+62
	RCALL __SWAPB12
	SUB  R30,R26
	RCALL SUBOPT_0x24
	LDI  R24,8
	RCALL SUBOPT_0x28
;     708 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x2B
;     709 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     710 					Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     711 					Ubatt_1 = Ubatt;
	LDD  R30,Y+54
	STD  Y+55,R30
;     712 			  }	
;     713        		              
;     714 			switch (BP_I2C)
_0x14C:
	RCALL SUBOPT_0x26
;     715 				{
;     716 					case ECHAP_I2C : Menu=Menu22_Infos_MD23; break;  
	BRNE _0x152
	LDI  R30,LOW(5)
	RJMP _0x236
;     717 					case FlecheH_I2C: Menu = Info_Vers;  break; 
_0x152:
	CPI  R30,LOW(0x2)
	BRNE _0x153
	LDI  R30,LOW(13)
	RJMP _0x236
;     718 					case FlecheB_I2C: Menu = Info_All;  break; 
_0x153:
	CPI  R30,LOW(0x4)
	BRNE _0x155
	LDI  R30,LOW(14)
	RJMP _0x236
;     719 					default: Menu=Info_Batt;
_0x155:
	LDI  R30,LOW(12)
_0x236:
	MOV  R5,R30
;     720 				}  
;     721        		 	
;     722 			Menu_1 = Info_Batt;
	LDI  R30,LOW(12)
	MOV  R6,R30
;     723 		break;   
;     724 // ----------------------------------------------------------------------------------------------------------------------------       
;     725 	
;     726     }// Fin du switch1  
_0xA3:
;     727        
;     728     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];  
	RCALL SUBOPT_0x20
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x21
	POP  R26
	POP  R27
	RCALL SUBOPT_0x22
;     729 // ----------------------------------------------------------------------------------------------------------------------------
;     730 // ----------------------------------------  Champ Ecriture des rsultats  ----------------------------------------------------
;     731 // Ecriture sur les LED                              	
;     732     TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
;     733 // ----------------------------------------------------------------------------------------------------------------------------  
;     734  // delay_ms(100);   // A utiliser pour visualiser les trames I2C
;     735   }; // Fin while(1)
	RJMP _0x9D
;     736       
;     737 } //Fin main  
	ADIW R28,63
	ADIW R28,48
_0x156:
	RJMP _0x156
;     738 
;     739 
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x2D
	SBIW R30,0
	BREQ _0x18D
	RCALL SUBOPT_0x2D
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x18E
_0x18D:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x18E:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x190:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x192
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x196
	CPI  R19,37
	BRNE _0x197
	LDI  R16,LOW(1)
	RJMP _0x198
_0x197:
	RCALL SUBOPT_0x2E
_0x198:
	RJMP _0x195
_0x196:
	CPI  R30,LOW(0x1)
	BRNE _0x199
	CPI  R19,37
	BRNE _0x19A
	RCALL SUBOPT_0x2E
	LDI  R16,LOW(0)
	RJMP _0x195
_0x19A:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x19B
	LDI  R17,LOW(1)
	RJMP _0x195
_0x19B:
	CPI  R19,43
	BRNE _0x19C
	LDI  R21,LOW(43)
	RJMP _0x195
_0x19C:
	CPI  R19,32
	BRNE _0x19D
	LDI  R21,LOW(32)
	RJMP _0x195
_0x19D:
	RJMP _0x19E
_0x199:
	CPI  R30,LOW(0x2)
	BRNE _0x19F
_0x19E:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x1A0
	ORI  R17,LOW(128)
	RJMP _0x195
_0x1A0:
	RJMP _0x1A1
_0x19F:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x195
_0x1A1:
	CPI  R19,48
	BRLO _0x1A4
	CPI  R19,58
	BRLO _0x1A5
_0x1A4:
	RJMP _0x1A3
_0x1A5:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x195
_0x1A3:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x1A9
	RCALL SUBOPT_0x2F
	LD   R30,X
	RCALL SUBOPT_0x30
	RJMP _0x1AA
_0x1A9:
	CPI  R30,LOW(0x73)
	BRNE _0x1AC
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x1C
	MOV  R16,R30
	RJMP _0x1AD
_0x1AC:
	CPI  R30,LOW(0x70)
	BRNE _0x1AF
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x1AD:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x1B0
_0x1AF:
	CPI  R30,LOW(0x64)
	BREQ _0x1B3
	CPI  R30,LOW(0x69)
	BRNE _0x1B4
_0x1B3:
	ORI  R17,LOW(4)
	RJMP _0x1B5
_0x1B4:
	CPI  R30,LOW(0x75)
	BRNE _0x1B6
_0x1B5:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x1B7
_0x1B6:
	CPI  R30,LOW(0x58)
	BRNE _0x1B9
	ORI  R17,LOW(8)
	RJMP _0x1BA
_0x1B9:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x1E8
_0x1BA:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x1B7:
	SBRS R17,2
	RJMP _0x1BC
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x32
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x1BD
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x1BD:
	CPI  R21,0
	BREQ _0x1BE
	SUBI R16,-LOW(1)
	RJMP _0x1BF
_0x1BE:
	ANDI R17,LOW(251)
_0x1BF:
	RJMP _0x1C0
_0x1BC:
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x32
_0x1C0:
_0x1B0:
	SBRC R17,0
	RJMP _0x1C1
_0x1C2:
	CP   R16,R20
	BRSH _0x1C4
	SBRS R17,7
	RJMP _0x1C5
	SBRS R17,2
	RJMP _0x1C6
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x1C7
_0x1C6:
	LDI  R19,LOW(48)
_0x1C7:
	RJMP _0x1C8
_0x1C5:
	LDI  R19,LOW(32)
_0x1C8:
	RCALL SUBOPT_0x2E
	SUBI R20,LOW(1)
	RJMP _0x1C2
_0x1C4:
_0x1C1:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x1C9
_0x1CA:
	CPI  R18,0
	BREQ _0x1CC
	SBRS R17,3
	RJMP _0x1CD
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x237
_0x1CD:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x237:
	ST   -Y,R30
	RCALL SUBOPT_0x33
	CPI  R20,0
	BREQ _0x1CF
	SUBI R20,LOW(1)
_0x1CF:
	SUBI R18,LOW(1)
	RJMP _0x1CA
_0x1CC:
	RJMP _0x1D0
_0x1C9:
_0x1D2:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x1D4
	SBRS R17,3
	RJMP _0x1D5
	SUBI R19,-LOW(7)
	RJMP _0x1D6
_0x1D5:
	SUBI R19,-LOW(39)
_0x1D6:
_0x1D4:
	SBRC R17,4
	RJMP _0x1D8
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x1DA
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x1D9
_0x1DA:
	ORI  R17,LOW(16)
	RJMP _0x1DC
_0x1D9:
	CP   R20,R18
	BRLO _0x1DE
	SBRS R17,0
	RJMP _0x1DF
_0x1DE:
	RJMP _0x1DD
_0x1DF:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x1E0
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x1DC:
	SBRS R17,2
	RJMP _0x1E1
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x33
	CPI  R20,0
	BREQ _0x1E2
	SUBI R20,LOW(1)
_0x1E2:
_0x1E1:
_0x1E0:
_0x1D8:
	RCALL SUBOPT_0x2E
	CPI  R20,0
	BREQ _0x1E3
	SUBI R20,LOW(1)
_0x1E3:
_0x1DD:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x1D3
	RJMP _0x1D2
_0x1D3:
_0x1D0:
	SBRS R17,0
	RJMP _0x1E4
_0x1E5:
	CPI  R20,0
	BREQ _0x1E7
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x30
	RJMP _0x1E5
_0x1E7:
_0x1E4:
_0x1E8:
_0x1AA:
	LDI  R16,LOW(0)
_0x195:
	RJMP _0x190
_0x192:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x34
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x34
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x35
	ADIW R28,4
	RET
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1F0*2)
	LDI  R31,HIGH(_0x1F0*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0xE
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x1E
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R24,3
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1F2*2)
	LDI  R31,HIGH(_0x1F2*2)
	RCALL __INITLOCB
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x1F4
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x1F5
_0x1F4:
	RJMP _0x1F3
_0x1F5:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x1F9
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	STD  Y+2,R30
	RJMP _0x1F8
_0x1F9:
	CPI  R30,LOW(0x1)
	BRNE _0x1F8
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
	STD  Y+2,R30
_0x1F8:
_0x1F3:
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x36
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	SBIW R28,4
	RCALL __SAVELOCR2
	LDD  R30,Y+8
	CLR  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+9
	SUBI R30,-LOW(2)
	CLR  R31
	STD  Y+2,R30
	STD  Y+2+1,R31
	__GETWRN 16,17,0
_0x1FD:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x1FE
	RCALL SUBOPT_0x37
	CPI  R26,LOW(0x5B)
	BRNE _0x1FF
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(138)
	ST   X,R30
	RJMP _0x200
_0x1FF:
	RCALL SUBOPT_0x37
	CPI  R26,LOW(0x5D)
	BRNE _0x201
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(84)
	RJMP _0x238
_0x201:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X
	SUBI R30,-LOW(128)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
_0x238:
	ST   X,R30
_0x200:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	__ADDWRN 16,17,1
	RJMP _0x1FD
_0x1FE:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0x35
	RCALL __LOADLOCR2
	ADIW R28,10
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,20
	LDI  R24,19
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x204*2)
	LDI  R31,HIGH(_0x204*2)
	RCALL __INITLOCB
	CLR  R30
	STD  Y+19,R30
_0x206:
	LDD  R26,Y+19
	CPI  R26,LOW(0x2)
	BRSH _0x207
	RCALL SUBOPT_0x1A
	LDD  R30,Y+20
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x1E
	LDD  R30,Y+19
	SUBI R30,-LOW(1)
	STD  Y+19,R30
	RJMP _0x206
_0x207:
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x1A
	RCALL _LCD_I2C_BATRON_gotoxy
	RCALL SUBOPT_0x3A
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3A
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x1E
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R24,6
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x209*2)
	LDI  R31,HIGH(_0x209*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1A
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x36
	ADIW R28,6
	RET
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R24,2
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x20E*2)
	LDI  R31,HIGH(_0x20E*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x3D
	LDD  R17,Y+3
	MOV  R30,R7
	CPI  R30,0
	BRNE _0x212
	CPI  R17,0
	BRNE _0x213
	MOV  R16,R17
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x3D
	LDD  R17,Y+3
	CP   R17,R16
	BRNE _0x214
	LDI  R30,LOW(1)
	MOV  R7,R30
	CLR  R30
	RJMP _0x21C
_0x214:
	LDI  R30,LOW(255)
	RJMP _0x21C
	RJMP _0x216
_0x213:
	LDI  R30,LOW(255)
	RJMP _0x21C
_0x216:
	RJMP _0x211
_0x212:
	CPI  R30,LOW(0x1)
	BRNE _0x211
	CPI  R17,0
	BREQ _0x218
	MOV  R16,R17
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x3D
	LDD  R17,Y+3
	CP   R17,R16
	BRNE _0x219
	CLR  R7
	MOV  R30,R17
	RJMP _0x21C
_0x219:
	CLR  R30
	RJMP _0x21C
	RJMP _0x21B
_0x218:
	CLR  R30
_0x21B:
_0x211:
_0x21C:
	RCALL __LOADLOCR2
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES
SUBOPT_0xC:
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0xD:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES
SUBOPT_0xE:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0xF:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Displ_2Lines_On_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x11:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x14:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _TWI_Get_Data_From_Transceiver

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	MOVW R30,R28
	ADIW R30,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x17:
	__GETB1SX 65
	CPI  R30,LOW(0x40)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(3)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1A:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1B:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x1C:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _strlen

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1D:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Built_Strng_Fram_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x1E:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1F:
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	__GETB1SX 106
	COM  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+60
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x24:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x26:
	__GETB1SX 65
	CPI  R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x27:
	CLR  R30
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x28:
	RCALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x29:
	LDD  R26,Y+62
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	LDI  R30,LOW(5)
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2B:
	RCALL _strcpyf
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2E:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2F:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x35:
	CLR  R30
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x36:
	LDI  R30,LOW(3)
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R26,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x38:
	ST   -Y,R30
	RJMP _LCD_I2C_BATRON_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x39:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x1C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3A:
	MOVW R30,R28
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	LDI  R30,LOW(1)
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3C:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3D:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3E:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x10

_strcpyf:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcpyf0:
	lpm  r0,z+
	st   x+,r0
	tst  r0
	brne __strcpyf0
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

