;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "TWI1.vec"
	.INCLUDE "TWI1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot(s)
;      10 Version : 1
;      11 Date    : 04/07/2009
;      12 Author  : MNO                             
;      13 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      14 Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
;      15 (Cde des LEDs de la carte relies  un PCF8574)
;      16 Adaptation de la note d'application AVR315 d'ATMEL
;      17 
;      18 Chip type           : ATmega8535
;      19 Program type        : Application
;      20 Clock frequency     : 8,000000 MHz
;      21 Memory model        : Small
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 #include <mega8535.h>
;      27 #include <delay.h>
;      28 
;      29 #define TWI_TWBR            	0x20	// 0x20 100kHz0k 
;      30 #define TWI_BUFFER_SIZE 	4   	// Set this to the largest message size that will be sent including address byte.    
;      31 #define TWI_NO_STATE            0xF8  	// No relevant state information available; TWINT = 0
;      32 
;      33 #define TWI_READ_BIT  0       // Bit position for R/W bit in "address byte".
;      34 #define TWI_ADR_BITS  1       // Bit position for LSB of the slave address bits in the init byte.
;      35 
;      36 #define TRUE          1
;      37 #define FALSE         0
;      38 
;      39 /****************************************************************************
;      40   TWI State codes
;      41 ****************************************************************************/
;      42 // General TWI Master staus codes                      
;      43 #define TWI_START                  0x08  // START has been transmitted  
;      44 #define TWI_REP_START              0x10  // Repeated START has been transmitted
;      45 #define TWI_ARB_LOST               0x38  // Arbitration lost
;      46 
;      47 // TWI Master Transmitter status codes                      
;      48 #define TWI_MTX_ADR_ACK            0x18  // SLA+W has been tramsmitted and ACK received
;      49 #define TWI_MTX_ADR_NACK           0x20  // SLA+W has been tramsmitted and NACK received 
;      50 #define TWI_MTX_DATA_ACK           0x28  // Data byte has been tramsmitted and ACK received
;      51 #define TWI_MTX_DATA_NACK          0x30  // Data byte has been tramsmitted and NACK received 
;      52 
;      53 // TWI Master Receiver staus codes  
;      54 #define TWI_MRX_ADR_ACK            0x40  // SLA+R has been tramsmitted and ACK received
;      55 #define TWI_MRX_ADR_NACK           0x48  // SLA+R has been tramsmitted and NACK received
;      56 #define TWI_MRX_DATA_ACK           0x50  // Data byte has been received and ACK tramsmitted
;      57 #define TWI_MRX_DATA_NACK          0x58  // Data byte has been received and NACK tramsmitted
;      58 
;      59 // TWI Slave Transmitter staus codes
;      60 #define TWI_STX_ADR_ACK            0xA8  // Own SLA+R has been received; ACK has been returned
;      61 #define TWI_STX_ADR_ACK_M_ARB_LOST 0xB0  // Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
;      62 #define TWI_STX_DATA_ACK           0xB8  // Data byte in TWDR has been transmitted; ACK has been received
;      63 #define TWI_STX_DATA_NACK          0xC0  // Data byte in TWDR has been transmitted; NOT ACK has been received
;      64 #define TWI_STX_DATA_ACK_LAST_BYTE 0xC8  // Last data byte in TWDR has been transmitted (TWEA = 0); ACK has been received
;      65 
;      66 // TWI Slave Receiver staus codes
;      67 #define TWI_SRX_ADR_ACK            0x60  // Own SLA+W has been received ACK has been returned
;      68 #define TWI_SRX_ADR_ACK_M_ARB_LOST 0x68  // Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned
;      69 #define TWI_SRX_GEN_ACK            0x70  // General call address has been received; ACK has been returned
;      70 #define TWI_SRX_GEN_ACK_M_ARB_LOST 0x78  // Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
;      71 #define TWI_SRX_ADR_DATA_ACK       0x80  // Previously addressed with own SLA+W; data has been received; ACK has been returned
;      72 #define TWI_SRX_ADR_DATA_NACK      0x88  // Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
;      73 #define TWI_SRX_GEN_DATA_ACK       0x90  // Previously addressed with general call; data has been received; ACK has been returned
;      74 #define TWI_SRX_GEN_DATA_NACK      0x98  // Previously addressed with general call; data has been received; NOT ACK has been returned
;      75 #define TWI_SRX_STOP_RESTART       0xA0  // A STOP condition or repeated START condition has been received while still addressed as Slave
;      76 
;      77 // TWI Miscellaneous status codes
;      78 
;      79 #define TWI_BUS_ERROR              0x00  // Bus error due to an illegal START or STOP condition     
;      80 
;      81 
;      82 /****************************************************************************
;      83   Function definitions
;      84 ****************************************************************************/
;      85 void TWI_Master_Initialise( void );
;      86 unsigned char TWI_Transceiver_Busy( void );
;      87 void TWI_Start_Transc_With_Data( unsigned char * , unsigned char );
;      88 
;      89 
;      90 // Declare your global variables here
;      91 //****************************************************************************
;      92 static unsigned char TWI_buf[ TWI_BUFFER_SIZE ];    // Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x4
;      93   static unsigned char TWI_msgSize;                   // Number of bytes to be transmitted.
_TWI_msgSize_G1:
	.BYTE 0x1
;      94   static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE
_TWI_state_G1:
	.BYTE 0x1
;      95 union TWI_STR                      // Status byte holding flags.
;      96 {
;      97     unsigned char all;
;      98     unsigned char lastTransOK:1;      
;      99     unsigned char unusedBits:7;
;     100 } TWI_statusReg={0}; 
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;     101 
;     102 
;     103 interrupt [TWI] void twi_isr(void)      // Adapte pour CVAVR
;     104 {					// #pragma vector=TWI_vect

	.CSEG
_twi_isr:
	RCALL __SAVEISR
;     105 					// __interrupt void TWI_ISR(void)
;     106 
;     107   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     108   
;     109   switch (TWSR)
	IN   R30,0x1
;     110   {
;     111     case TWI_START:             // START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0xB
;     112     
;     113     case TWI_REP_START:         // Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0xC
_0xB:
;     114       TWI_bufPtr = 0;   	// Set buffer pointer to the TWI Address location
	CLR  R4
;     115       				
;     116     case TWI_MTX_ADR_ACK:       // SLA+W has been tramsmitted and ACK received 
	RJMP _0xD
_0xC:
	CPI  R30,LOW(0x18)
	BRNE _0xE
_0xD:
;     117     
;     118     case TWI_MTX_DATA_ACK:      // Data byte has been tramsmitted and ACK received
	RJMP _0xF
_0xE:
	CPI  R30,LOW(0x28)
	BRNE _0x10
_0xF:
;     119       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x11
;     120       {
;     121         TWDR = TWI_buf[TWI_bufPtr++];                     // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x0
	LD   R30,Z
	OUT  0x3,R30
;     122         TWCR = 0b10000101;                                // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x32
;     123                                      			  // (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     124                          				  // (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     125                						  // (0<<TWWC); 
;     126       }else                    // Send STOP after last byte
_0x11:
;     127       {
;     128         TWI_statusReg.lastTransOK = TRUE;                 // Set status bits to completed successfully.
	RCALL SUBOPT_0x1
;     129          						  // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     130         TWCR = 0b10010100; 		                  // (1<<TWEN)| TWI Interface enabled
_0x32:
	OUT  0x36,R30
;     131                                     			  // (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     132                          				  // (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     133                                				  // (0<<TWWC);
;     134       }
;     135     break;
	RJMP _0x9
;     136       
;     137     case TWI_MRX_DATA_ACK:      // Data byte has been received and ACK tramsmitted
_0x10:
	CPI  R30,LOW(0x50)
	BRNE _0x13
;     138       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x0
	MOVW R26,R30
	RCALL SUBOPT_0x2
;     139       
;     140     case TWI_MRX_ADR_ACK:       // SLA+R has been tramsmitted and ACK received
	RJMP _0x14
_0x13:
	CPI  R30,LOW(0x40)
	BRNE _0x15
_0x14:
;     141       if (TWI_bufPtr < (TWI_msgSize-1) )                  // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x16
;     142       {                                                   // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     143         TWCR = 0b10000101;                                // (1<<TWEN)| TWI Interface enabled
;     144                                      			  // (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     145                           				  // (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     146                                                           // (0<<TWWC);  
;     147       }else                    // Send NACK after next reception
_0x16:
;     148       {						          // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     149         TWCR = 0b10000101;                                // (1<<TWEN)| TWI Interface enabled
_0x33:
	LDI  R30,LOW(133)
	OUT  0x36,R30
;     150                                      			  // (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     151                           				  // (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     152                                 			  // (0<<TWWC); 
;     153       }    
;     154     break; 
	RJMP _0x9
;     155       
;     156     case TWI_MRX_DATA_NACK:     // Data byte has been received and NACK tramsmitted
_0x15:
	CPI  R30,LOW(0x58)
	BRNE _0x18
;     157       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0x2
;     158       TWI_statusReg.lastTransOK = TRUE;                 // Set status bits to completed successfully. 
	RCALL SUBOPT_0x1
;     159       							// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     160       TWCR = 0b10010100;                                // (1<<TWEN)| TWI Interface enabled
	RJMP _0x34
;     161                                   			// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     162                        					// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     163                                              		// (0<<TWWC); 
;     164     break;  
;     165           
;     166     case TWI_ARB_LOST:          // Arbitration lost                             
_0x18:
	CPI  R30,LOW(0x38)
	BRNE _0x19
;     167     							// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     168       TWCR = 0b10100101;                                // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x34
;     169                                    			// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     170                         				// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     171                                               		// (0<<TWWC);
;     172     break;
;     173       
;     174     case TWI_MTX_ADR_NACK:      // SLA+W has been tramsmitted and NACK received
_0x19:
	CPI  R30,LOW(0x20)
	BREQ _0x1B
;     175     case TWI_MRX_ADR_NACK:      // SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x1C
_0x1B:
;     176     case TWI_MTX_DATA_NACK:     // Data byte has been tramsmitted and NACK received
	RJMP _0x1D
_0x1C:
	CPI  R30,LOW(0x30)
	BRNE _0x1E
_0x1D:
;     177 //    case TWI_NO_STATE              // No relevant state information available; TWINT = 0
;     178     case TWI_BUS_ERROR:         // Bus error due to an illegal START or STOP condition  
	RJMP _0x1F
_0x1E:
	CPI  R30,0
	BRNE _0x21
_0x1F:
;     179     
;     180     default:     
_0x21:
;     181       TWI_state = TWSR;                                 // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     182                                                         // Reset TWI Interface
;     183                                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     184       TWCR = 0b00000100;                                // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x34:
	OUT  0x36,R30
;     185                                    			// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     186                        					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     187                                               		// (0<<TWWC);
;     188   }
_0x9:
;     189 }
	RCALL __LOADISR
	RETI
;     190 void main(void)
;     191 {
_main:
;     192 // Declare your local variables here
;     193 unsigned char messageLEDOn[]={0x40,0x55}; 
;     194 unsigned char messageLEDOff[]={0x40,0xff}; 
;     195 
;     196 TWI_Master_Initialise();
	SBIW R28,4
	LDI  R24,4
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x23*2)
	LDI  R31,HIGH(_0x23*2)
	RCALL __INITLOCB
;	messageLEDOn -> Y+2
;	messageLEDOff -> Y+0
	RCALL _TWI_Master_Initialise
;     197 // Global enable interrupts
;     198 #asm("sei")
	sei
;     199 
;     200 while (1)
_0x24:
;     201       {
;     202         TWI_Start_Transc_With_Data(messageLEDOn,2); 
	MOVW R30,R28
	ADIW R30,2
	RCALL SUBOPT_0x3
;     203         delay_ms(200);
;     204 	TWI_Start_Transc_With_Data(messageLEDOff,2);  
	MOVW R30,R28
	RCALL SUBOPT_0x3
;     205 	delay_ms(200);
;     206       };
	RJMP _0x24
;     207 }
	ADIW R28,4
_0x27:
	RJMP _0x27
;     208 
;     209 // Fonctions
;     210 
;     211 void TWI_Master_Initialise(void)
;     212 {                                               // Adapte pour CVAVR
_TWI_Master_Initialise:
;     213   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;     214 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;     215   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;     216   						//  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     217   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;     218                                			// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;     219                                			// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;     220                                          	// 0<<TWWC); 
;     221 } 
	RET
;     222 
;     223 unsigned char TWI_Transceiver_Busy( void )
;     224 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;     225   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;     226 }
;     227 
;     228 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;     229 {
_TWI_Start_Transc_With_Data:
;     230   unsigned char temp;
;     231                                                 // Adapte pour CVAVR
;     232   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x2B:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2B
;     233 
;     234   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;     235   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x4
	STS  _TWI_buf_G1,R30
;     236   if (!( msg[0] & 0b00000001 ))       		// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x4
	ANDI R30,LOW(0x1)
	BRNE _0x2E
;     237   {						// If it is a write operation, then also copy data.
;     238     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x30:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	BRSH _0x31
;     239       TWI_buf[ temp ] = msg[ temp ];
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	PUSH R31
	PUSH R30
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x30
_0x31:
;     240   }
;     241   TWI_statusReg.all = 0;      
_0x2E:
	CLR  R30
	STS  _TWI_statusReg,R30
;     242   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     243   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     244                            			// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     245                 				// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition.
;     246                                       		// (0<<TWWC);
;     247 }   
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

