;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "twi2.vec"
	.INCLUDE "twi2.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot(s)
;      10 Version : 1
;      11 Date    : 05/07/2009
;      12 Author  : MNO                             
;      13 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      14 Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
;      15 Transfert de l'tat des BP sur les LEDs de la carte (PCF8574)
;      16 Adaptation de la note d'application AVR315 d'ATMEL
;      17 
;      18 Chip type           : ATmega8535
;      19 Program type        : Application
;      20 Clock frequency     : 8,000000 MHz
;      21 Memory model        : Small
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 #include <mega8535.h>
;      27 #include <delay.h>  
;      28 
;      29 #include "TWI_F.c" // Fonctions du drivers TWI adaptes pour CVAVR
;      30 /***********************************************************************
;      31 Project : PPE Robot(s)
;      32 Version : 1
;      33 Date    : 12/08/2009
;      34 Author  : MNO
;      35 File : twi_f.c
;      36 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      37 et dcrites dans la note d'application AVR315, adaptes au
;      38 cross compilateur CVAVR.
;      39 Fichier  inclure en en tte d'une application ncessitant une interface
;      40 2 fil I2C.
;      41 Evolution:  remplacer par une bibliothque
;      42 ***********************************************************************/
;      43 
;      44 
;      45 #include <TWI_Master_CVAVR.h>  
;      46 
;      47 // Declare your global variables here 
;      48 //-----------------------------------------------------------------------------------------------------------------------------
;      49 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      50 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x4
;      51 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      52  
;      53 union TWI_STR                      					// Status byte holding flags.
;      54 {
;      55     unsigned char all;
;      56     unsigned char lastTransOK:1;      
;      57     unsigned char unusedBits:7; 
;      58 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      59 //-----------------------------------------------------------------------------------------------------------------------------
;      60 
;      61 //-----------------------------------------------------------------------------------------------------------------------------
;      62 // Fonctions du drivers TWI
;      63 //-----------------------------------------------------------------------------------------------------------------------------
;      64 void TWI_Master_Initialise(void)
;      65 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      66   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      67 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      68   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      69   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;      70   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;      71                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;      72                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;      73                                          		// 0<<TWWC); 
;      74 } 
	RET
;      75 //-----------------------------------------------------------------------------------------------------------------------------
;      76 unsigned char TWI_Transceiver_Busy(void)
;      77 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;      78   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;      79 }
;      80 //-----------------------------------------------------------------------------------------------------------------------------
;      81 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;      82 {
_TWI_Start_Transc_With_Data:
;      83   unsigned char temp;
;      84                                                 // Adapte pour CVAVR
;      85   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x6:
	RCALL SUBOPT_0x0
	BRNE _0x6
;      86 
;      87   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;      88   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;      89   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x9
;      90   {												// If it is a write operation, then also copy data.
;      91     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0xB:
	RCALL SUBOPT_0x2
	BRSH _0xC
;      92       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x5
	RJMP _0xB
_0xC:
;      93   }
;      94   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x9:
	CLR  R30
	STS  _TWI_statusReg,R30
;      95   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;      96   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;      97                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;      98                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;      99                                       			// (0<<TWWC);
;     100 } 
	RJMP _0x37
;     101 //-----------------------------------------------------------------------------------------------------------------------------
;     102 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     103 {
_TWI_Get_Data_From_Transceiver:
;     104   unsigned char i;
;     105           
;     106   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0xE:
	RCALL SUBOPT_0x0
	BRNE _0xE
;     107 
;     108   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x6
	BREQ _0x11
;     109   {                                             
;     110     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x13:
	RCALL SUBOPT_0x2
	BRSH _0x14
;     111     {
;     112       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     113     }
	RCALL SUBOPT_0x5
	RJMP _0x13
_0x14:
;     114   }
;     115   return( TWI_statusReg.lastTransOK );                                   
_0x11:
	RCALL SUBOPT_0x6
_0x37:
	ADIW R28,4
	RET
;     116 }  
;     117 //-----------------------------------------------------------------------------------------------------------------------------
;     118 
;     119 // ----------------------------------------------------------------------------------------------------------------------------
;     120 // Interruption TWI
;     121 // ----------------------------------------------------------------------------------------------------------------------------
;     122 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     123 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     124 												// __interrupt void TWI_ISR(void)
;     125   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     126   
;     127   switch (TWSR)
	IN   R30,0x1
;     128   {
;     129     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x1A
;     130     
;     131     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x1B
_0x1A:
;     132       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     133       				
;     134     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x1C
_0x1B:
	CPI  R30,LOW(0x18)
	BRNE _0x1D
_0x1C:
;     135     
;     136     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x1E
_0x1D:
	CPI  R30,LOW(0x28)
	BRNE _0x1F
_0x1E:
;     137       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x20
;     138       {
;     139         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x7
	LD   R30,Z
	OUT  0x3,R30
;     140         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x38
;     141         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     142                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     143                						  			// (0<<TWWC); 
;     144       }
;     145       else                    					// Send STOP after last byte
_0x20:
;     146       {
;     147         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x8
;     148          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     149         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x38:
	OUT  0x36,R30
;     150         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     151                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     152                                				  	// (0<<TWWC);
;     153       }
;     154     break;
	RJMP _0x18
;     155       
;     156     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x1F:
	CPI  R30,LOW(0x50)
	BRNE _0x22
;     157       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x7
	MOVW R26,R30
	RCALL SUBOPT_0x9
;     158       
;     159     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x23
_0x22:
	CPI  R30,LOW(0x40)
	BRNE _0x24
_0x23:
;     160       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x25
;     161       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     162         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x39
;     163         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     164                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     165                                   				// (0<<TWWC);  
;     166       } else                    				// Send NACK after next reception
_0x25:
;     167       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     168         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x39:
	OUT  0x36,R30
;     169         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     170                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     171                                 			  	// (0<<TWWC); 
;     172       }    
;     173     break; 
	RJMP _0x18
;     174       
;     175     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x24:
	CPI  R30,LOW(0x58)
	BRNE _0x27
;     176       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0x9
;     177       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x8
;     178       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     179       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x3A
;     180                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     181                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     182                               					// (0<<TWWC); 
;     183     break;  
;     184           
;     185     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x27:
	CPI  R30,LOW(0x38)
	BRNE _0x28
;     186     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     187       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x3A
;     188                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     189                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     190                               					// (0<<TWWC);
;     191     break;
;     192       
;     193     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x28:
	CPI  R30,LOW(0x20)
	BREQ _0x2A
;     194     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x2B
_0x2A:
;     195     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0x2C
_0x2B:
	CPI  R30,LOW(0x30)
	BRNE _0x2D
_0x2C:
;     196 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     197     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0x2E
_0x2D:
	CPI  R30,0
	BRNE _0x30
_0x2E:
;     198     
;     199     default:     
_0x30:
;     200       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     201       											// Reset TWI Interface
;     202                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     203       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x3A:
	OUT  0x36,R30
;     204                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     205                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     206                               					// (0<<TWWC);
;     207   }
_0x18:
;     208 } 
	RCALL __LOADISR
	RETI
;     209 
;     210 
;     211 
;     212 // ----------------------------------------------------------------------------------------------------------
;     213 // Boucle principale
;     214 // ----------------------------------------------------------------------------------------------------------
;     215 void main(void)
;     216 {
_main:
;     217 // Declare your local variables here
;     218 unsigned char messageLEDOn[]={0x40,0x00}; 	// {addLed out, data = all Led on}
;     219 unsigned char messageLEDOff[]={0x40,0xff}; 	// {addLed out, data = all Led off}
;     220 unsigned char messageBP[]={0x43,0x00}; 		// {addBP out, data=nothing}
;     221 unsigned char DonneeBP[]={0xff,0x00};		// {addBP in, data=nothing}
;     222 
;     223 TWI_Master_Initialise(); 	// Initialisation de l'interface TWI en mode Standby
	SBIW R28,8
	LDI  R24,8
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x32*2)
	LDI  R31,HIGH(_0x32*2)
	RCALL __INITLOCB
;	messageLEDOn -> Y+6
;	messageLEDOff -> Y+4
;	messageBP -> Y+2
;	DonneeBP -> Y+0
	RCALL _TWI_Master_Initialise
;     224 
;     225 // Global enable interrupts
;     226 #asm("sei")
	sei
;     227 
;     228 TWI_Start_Transc_With_Data(messageLEDOff,2);  //
	MOVW R30,R28
	ADIW R30,4
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     229 
;     230 while (1)
_0x33:
;     231       {
;     232         TWI_Start_Transc_With_Data(messageBP,1);  	// Envoi octet d'adresse des BP + bit RW=lecture(0x43)
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
;     233         TWI_Get_Data_From_Transceiver(DonneeBP, 2 );  	// Lecture du buffer (octet1=add, octet2=donnee etat BP)
	MOVW R30,R28
	RCALL SUBOPT_0xA
	RCALL _TWI_Get_Data_From_Transceiver
;     234         messageLEDOn[1]=~DonneeBP[1];                  	// Transfert etat BP dans message LED On
	LDD  R30,Y+1
	COM  R30
	STD  Y+7,R30
;     235         TWI_Start_Transc_With_Data(messageLEDOn,2); 	// Commande des LED
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     236         delay_ms(200);
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     237 	/*TWI_Start_Transc_With_Data(messageLEDOff,2);
;     238 	delay_ms(200);      */
;     239       };
	RJMP _0x33
;     240 }
	ADIW R28,8
_0x36:
	RJMP _0x36
;     241 

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

