;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "twi2bBat.vec"
	.INCLUDE "twi2bBat.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /********************************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot solaire
;      10 Version : 1
;      11 Date    : 28/11/2009
;      12 Author  : Philippe Mariano                            
;      13 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      14 Comments: Fichier de la fiche guide 1bis
;      15 Mise en oeuvre du protocole I2C par l'interface TWI 
;      16 Commande d'un afficheur LCD Batron I2C (PCF2119x)
;      17 Lecture des BP et recopie sur les LED
;      18 
;      19 File : twi2bBat.c
;      20 Target:  Robot S_ISI
;      21 Chip type           : ATmega8535
;      22 Program type        : Application
;      23 Clock frequency     : 8,000000 MHz
;      24 Memory model        : Small
;      25 External SRAM size  : 0
;      26 Data Stack size     : 128
;      27 *********************************************************************/
;      28 
;      29 // *****************************************************************************************************************************
;      30 // Bibliothques et dfinitions
;      31 // -----------------------------------------------------------------------------------------------------------------------------
;      32 #include <mega8535.h> 
;      33 #include <stdlib.h>
;      34 #include <string.h>				// Fonction de traitement des chanes de caractres  
;      35 #include <delay.h>				// Fonction temporisation  
;      36 // -----------------------------------------------------------------------------------------------------------------------------
;      37 
;      38 // Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
;      39 // -----------------------------------------------------------------------------------------------------------------------------
;      40 #define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
;      41 	
;      42 #include "TWI_F.c" 				// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
;      43 /***********************************************************************
;      44 Project : PPE Robot(s)
;      45 Version : 1
;      46 Date    : 12/08/2009
;      47 Author  : MNO
;      48 File : twi_f.c
;      49 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      50 et dcrites dans la note d'application AVR315, adaptes au
;      51 cross compilateur CVAVR.
;      52 Fichier  inclure en en tte d'une application ncessitant une interface
;      53 2 fil I2C.
;      54 Evolution:  remplacer par une bibliothque
;      55 ***********************************************************************/
;      56 
;      57 
;      58 #include <TWI_Master_CVAVR.h>  
;      59 
;      60 // Declare your global variables here 
;      61 //-----------------------------------------------------------------------------------------------------------------------------
;      62 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      63 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      64 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      65  
;      66 union TWI_STR                      					// Status byte holding flags.
;      67 {
;      68     unsigned char all;
;      69     unsigned char lastTransOK:1;      
;      70     unsigned char unusedBits:7; 
;      71 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      72 //-----------------------------------------------------------------------------------------------------------------------------
;      73 
;      74 //-----------------------------------------------------------------------------------------------------------------------------
;      75 // Fonctions du drivers TWI
;      76 //-----------------------------------------------------------------------------------------------------------------------------
;      77 void TWI_Master_Initialise(void)
;      78 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      79   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      80 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      81   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      82   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;      83   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;      84                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;      85                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;      86                                          		// 0<<TWWC); 
;      87 } 
	RET
;      88 //-----------------------------------------------------------------------------------------------------------------------------
;      89 unsigned char TWI_Transceiver_Busy(void)
;      90 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;      91   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;      92 }
;      93 //-----------------------------------------------------------------------------------------------------------------------------
;      94 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;      95 {
_TWI_Start_Transc_With_Data:
;      96   unsigned char temp;
;      97                                                 // Adapte pour CVAVR
;      98   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x38:
	RCALL SUBOPT_0x0
	BRNE _0x38
;      99 
;     100   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;     101   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;     102   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x3B
;     103   {												// If it is a write operation, then also copy data.
;     104     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x3D:
	RCALL SUBOPT_0x2
	BRSH _0x3E
;     105       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x5
	RJMP _0x3D
_0x3E:
;     106   }
;     107   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x3B:
	CLR  R30
	STS  _TWI_statusReg,R30
;     108   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     109   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     110                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     111                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     112                                       			// (0<<TWWC);
;     113 } 
	RJMP _0x7C
;     114 //-----------------------------------------------------------------------------------------------------------------------------
;     115 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     116 {
_TWI_Get_Data_From_Transceiver:
;     117   unsigned char i;
;     118           
;     119   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0x40:
	RCALL SUBOPT_0x0
	BRNE _0x40
;     120 
;     121   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x6
	BREQ _0x43
;     122   {                                             
;     123     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x45:
	RCALL SUBOPT_0x2
	BRSH _0x46
;     124     {
;     125       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     126     }
	RCALL SUBOPT_0x5
	RJMP _0x45
_0x46:
;     127   }
;     128   return( TWI_statusReg.lastTransOK );                                   
_0x43:
	RCALL SUBOPT_0x6
_0x7C:
	ADIW R28,4
	RET
;     129 }  
;     130 //-----------------------------------------------------------------------------------------------------------------------------
;     131 
;     132 // ----------------------------------------------------------------------------------------------------------------------------
;     133 // Interruption TWI
;     134 // ----------------------------------------------------------------------------------------------------------------------------
;     135 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     136 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     137 												// __interrupt void TWI_ISR(void)
;     138   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     139   
;     140   switch (TWSR)
	IN   R30,0x1
;     141   {
;     142     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x4C
;     143     
;     144     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x4D
_0x4C:
;     145       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     146       				
;     147     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x4E
_0x4D:
	CPI  R30,LOW(0x18)
	BRNE _0x4F
_0x4E:
;     148     
;     149     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x50
_0x4F:
	CPI  R30,LOW(0x28)
	BRNE _0x51
_0x50:
;     150       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x52
;     151       {
;     152         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x7
	LD   R30,Z
	OUT  0x3,R30
;     153         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x7D
;     154         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     155                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     156                						  			// (0<<TWWC); 
;     157       }
;     158       else                    					// Send STOP after last byte
_0x52:
;     159       {
;     160         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x8
;     161          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     162         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x7D:
	OUT  0x36,R30
;     163         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     164                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     165                                				  	// (0<<TWWC);
;     166       }
;     167     break;
	RJMP _0x4A
;     168       
;     169     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x51:
	CPI  R30,LOW(0x50)
	BRNE _0x54
;     170       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x7
	MOVW R26,R30
	RCALL SUBOPT_0x9
;     171       
;     172     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x55
_0x54:
	CPI  R30,LOW(0x40)
	BRNE _0x56
_0x55:
;     173       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x57
;     174       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     175         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x7E
;     176         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     177                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     178                                   				// (0<<TWWC);  
;     179       } else                    				// Send NACK after next reception
_0x57:
;     180       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     181         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x7E:
	OUT  0x36,R30
;     182         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     183                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     184                                 			  	// (0<<TWWC); 
;     185       }    
;     186     break; 
	RJMP _0x4A
;     187       
;     188     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x56:
	CPI  R30,LOW(0x58)
	BRNE _0x59
;     189       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0x9
;     190       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x8
;     191       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     192       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x7F
;     193                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     194                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     195                               					// (0<<TWWC); 
;     196     break;  
;     197           
;     198     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x59:
	CPI  R30,LOW(0x38)
	BRNE _0x5A
;     199     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     200       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x7F
;     201                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     202                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     203                               					// (0<<TWWC);
;     204     break;
;     205       
;     206     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x5A:
	CPI  R30,LOW(0x20)
	BREQ _0x5C
;     207     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x5D
_0x5C:
;     208     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0x5E
_0x5D:
	CPI  R30,LOW(0x30)
	BRNE _0x5F
_0x5E:
;     209 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     210     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0x60
_0x5F:
	CPI  R30,0
	BRNE _0x62
_0x60:
;     211     
;     212     default:     
_0x62:
;     213       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     214       											// Reset TWI Interface
;     215                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     216       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x7F:
	OUT  0x36,R30
;     217                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     218                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     219                               					// (0<<TWWC);
;     220   }
_0x4A:
;     221 } 
	RCALL __LOADISR
	RETI
;     222 
;     223 // *****************************************************************************************************************************   
;     224 
;     225 // *****************************************************************************************************************************
;     226 // Constantes en flash
;     227 // -----------------------------------------------------------------------------------------------------------------------------
;     228 // Description des commandes d'initialisation de l'afficheur LCD I2C BATRON (voir doc PCF2119x p22  p25)
;     229 /* -----------------------------------------------------------------------------------------------------------------------------
;     230 Ordre   Dsignation					Valeur		Remarques
;     231 // -----------------------------------------------------------------------------------------------------------------------------
;     232 1 	Adresse de l'afficheur 			=	0x76 		(SA0 = 1) [ envoyer en premier!!!]
;     233 2 	Select function setting			=	0x00 		Doit prcder une ou plusieurs commandes dans la trame 
;     234 									I2C ! (accs au reg IR ) doc PCF2119x p22
;     235 3 	Command : Function set			=	0x34            2 lignes de 16 caractres 
;     236 4 	Command : Display control		=	0x0c            Display on, curseur off
;     237 5 	Command : Entry mode set		=       0x06  		Incrment, no shift
;     238 6	Command : Extended instruction set	= 	0x35            -------------------------------------------------------
;     239 7	Command : Set display configuration	= 	0x04  		left-to-right, top to bottom 
;     240 8	Command : Set coefficient temperature	= 	0x10            TC1 = 0, TC2 = 0 (Par default)
;     241 9	Command : Set Internal HVgen stages	=	0x42            HV stage 3  ???
;     242 10	Command : Set VLCD			= 	0x9F            set VLCD, store VA (Rglage contraste)
;     243 11	Command : Normal instruction set	= 	0x34            -------------------------------------------------------
;     244 12	Command : Set DDRAM address		= 	0x80            DDRAM address = 0x00 
;     245 // -----------------------------------------------------------------------------------------------------------------------------
;     246 Autres commandes
;     247  	Command : Clear display			= 	0x01 
;     248  	Command : Write to DDRAM		=	0x40		Doit prcder une ou plusieurs donnes dans la trame 
;     249  									I2C ! (accs au registre DR)  
;     250 -----------------------------------------------------------------------------------------------------------------------------*/ 
;     251 // Messages textuels prdfinis 
;     252 // ----------------------------------------------------------------------------------------------------------------------------- 
;     253 flash char Texte_Accueil_Ligne1[] = "PPE Robsol";
;     254 flash char Texte_Accueil_Ligne2[] = "TWI2b.c";
;     255 
;     256 // Message d'initialisation de l'afficheur LCD I2C BATRON (voir doc PCF2119x p22  p25)
;     257 // ----------------------------------------------------------------------------------------------------------------------------- 
;     258 flash unsigned char Frame_I2C_LCD_BATRON_Init[]={0x76,0x00,0x34,0x0d,0x06,0x35,0x04,0x10,0x42,0x9F,0x34,0x83,0x02};   
;     259 
;     260 // *****************************************************************************************************************************
;     261 
;     262 // *****************************************************************************************************************************
;     263 // Prototypes des fonctions
;     264 // ----------------------------------------------------------------------------------------------------------------------------- 
;     265 void LCD_I2C_BATRON_gotoxy(unsigned char x, unsigned char y);  // x=position dans la ligne [0,15], y=n de la ligne [0,1] 
;     266 // Construction d'une trame de texte pour l'afficheur LCD BATRON
;     267 void Built_Frame_String_I2C(unsigned char FrameI2C, unsigned char Tstring, int Tstringsize); 
;     268 // ***************************************************************************************************************************** 
;     269  
;     270 
;     271 // *****************************************************************************************************************************
;     272 // *****************************************************************************************************************************
;     273 // Programme principal
;     274 // *****************************************************************************************************************************
;     275 void main(void)
;     276 {
_main:
;     277 // *****************************************************************************************************************************
;     278 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     279 // =============================================================================================================================
;     280 // Messages pour les composants I2C 
;     281 // =============================================================================================================================
;     282 // 1) Message pour le buffer TWI
;     283 // ----------------------------------------------------------------------------------------------------------------------------- 
;     284 // Type 		Nom 				       Description 
;     285 // -----------------------------------------------------------------------------------------------------------------------------    
;     286 unsigned char Frame_I2C_For_TWI_Buffer[TWI_BUFFER_SIZE];     	// La taille de ce buffer doit tre rgl en fonction de
;     287 								// la taille maximum des messages
;     288 // ============================================================================================================================= 
;     289 
;     290 // -----------------------------------------------------------------------------------------------------------------------------
;     291 // 2) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
;     292 // ----------------------------------------------------------------------------------------------------------------------------- 
;     293 // Type 		Nom 				       Description 
;     294 // ----------------------------------------------------------------------------------------------------------------------------- 
;     295 unsigned char Frame_I2C_LED_All_Off[]={0x40,0xff}; 	// Trame d'extinction des LED {addLed + W (ox40), data = all Led off}
;     296 unsigned char Frame_I2C_LED_Switching[]={0x40,0x00}; 	// Trame de commande des LED {addLed + W (0x40), data = Led on=0
;     297 							// or off=1}. Initialisation = All on
;     298 unsigned char Frame_I2C_BP_Read[]={0x43,0x00}; 		// Trame de lecture des BP {addBP + R (0x43), data=nothing}      
;     299 // ============================================================================================================================= 
;     300 
;     301 // -----------------------------------------------------------------------------------------------------------------------------
;     302 // 3) Messages pour le LCD I2C BATRON de la carte S_ISI
;     303 // ----------------------------------------------------------------------------------------------------------------------------- 
;     304 // Type 		Nom 				       Description 
;     305 // ----------------------------------------------------------------------------------------------------------------------------- 
;     306 unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; // Effacement de l'cran {addLCD, acces RegInst, cde effacement}
;     307 unsigned char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	     // Trame de texte compose de: {addLCD, commande criture en DDRAM,  
;     308 						 	     //  Le texte  afficher : 16 caractre max,  /0 }
;     309 unsigned char String_to_LCD[17]; 			     // Reoit Le texte  afficher (16 caractres max. + /0
;     310 							     // ATTENTION  la position du curseur sur l'afficheur!!!!!!!!) 
;     311 // =============================================================================================================================
;     312 
;     313 // =============================================================================================================================
;     314 // Divers variables
;     315 // ----------------------------------------------------------------------------------------------------------------------------- 
;     316 // Type 		Nom 				       Description 
;     317 // -----------------------------------------------------------------------------------------------------------------------------    
;     318 unsigned char i, Digit; 
;     319 unsigned char Digit_to_String[4]={0xa0,0xa0,0xa0,0};   	// Contient la reprsentation textuelle d'un nombre de 3 chiffres
;     320                                                      	// Initialisation avec 3 espaces (0x20+0x80) et /0 
;     321 // -----------------------------------------------------------------------------------------------------------------------------
;     322 // *****************************************************************************************************************************
;     323 
;     324 
;     325 // =============================================================================================================================
;     326 // ===================================================== Initialisations =======================================================
;     327 // =============================================================================================================================
;     328 // Initialisation de l'interface TWI en mode Standby
;     329 TWI_Master_Initialise(); 
	SBIW R28,63
	SBIW R28,6
	LDI  R24,49
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x66*2)
	LDI  R31,HIGH(_0x66*2)
	RCALL __INITLOCB
;	Frame_I2C_For_TWI_Buffer -> Y+49
;	Frame_I2C_LED_All_Off -> Y+47
;	Frame_I2C_LED_Switching -> Y+45
;	Frame_I2C_BP_Read -> Y+43
;	Frame_I2C_LCD_BATRON_Clear -> Y+40
;	Frame_I2C_Lcd_Line -> Y+21
;	String_to_LCD -> Y+4
;	i -> R16
;	Digit -> R17
;	Digit_to_String -> Y+0
	RCALL _TWI_Master_Initialise
;     330 
;     331 // Global enable interrupts
;     332 #asm("sei")			// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI				
	sei
;     333 
;     334 // Extinction des LEDs de la carte S_ISI
;     335 TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); 	
	MOVW R30,R28
	ADIW R30,47
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     336 
;     337 // Initialisation de l'afficheur BATRON
;     338 for (i=0;i<13;i++)  
	LDI  R16,LOW(0)
_0x68:
	CPI  R16,13
	BRSH _0x69
;     339 {
;     340   Frame_I2C_For_TWI_Buffer[i]=Frame_I2C_LCD_BATRON_Init[i];   // Tableau MI2C_LCD_BATRON_Init en flash !!!!! Utilisation pointeur ???
	RCALL SUBOPT_0xB
	MOVW R26,R28
	ADIW R26,49
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R26,LOW(_Frame_I2C_LCD_BATRON_Init*2)
	LDI  R27,HIGH(_Frame_I2C_LCD_BATRON_Init*2)
	RCALL SUBOPT_0xB
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     341 } 
	SUBI R16,-1
	RJMP _0x68
_0x69:
;     342 TWI_Start_Transc_With_Data(Frame_I2C_For_TWI_Buffer,sizeof(Frame_I2C_LCD_BATRON_Init));
	MOVW R30,R28
	ADIW R30,49
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(13)
	RCALL SUBOPT_0xC
;     343 
;     344 //******************************************************************************************************************************
;     345 // Message d'accueil
;     346 // -----------------------------------------------------------------------------------------------------------------------------
;     347 TWI_Start_Transc_With_Data(Frame_I2C_LCD_BATRON_Clear,sizeof(Frame_I2C_LCD_BATRON_Clear));	// Effacement de l'cran 
	RCALL SUBOPT_0xD
;     348 
;     349 // Message 1 sur ligne 1
;     350 // -----------------------------------------------------------------------------------------------------------------------------
;     351 // Positionner le curseur
;     352 LCD_I2C_BATRON_gotoxy(3,0); 
	LDI  R30,LOW(3)
	ST   -Y,R30
	CLR  R30
	RCALL SUBOPT_0xE
;     353 // Copier le texte  envoyer dans le tableau String_to_LCD (16 caractres max)  
;     354 strcpyf(String_to_LCD, Texte_Accueil_Ligne1); // strcpyf car constante en flash !
	LDI  R30,LOW(_Texte_Accueil_Ligne1*2)
	LDI  R31,HIGH(_Texte_Accueil_Ligne1*2)
	RCALL SUBOPT_0xF
;     355 // Rajouter le texte prcdent  l'en tte de la trame et le transcoder pour le LCD BATRON
;     356 Built_Frame_String_I2C(Frame_I2C_Lcd_Line, String_to_LCD, strlen(String_to_LCD)); // strlen pour des messages textuels termins 
;     357 // Transmettre la trame I2C                                                      // par /0
;     358 TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
;     359 // -----------------------------------------------------------------------------------------------------------------------------	
;     360 // Message 2 sur ligne 2 
;     361 // ----------------------------------------------------------------------------------------------------------------------------- 
;     362 LCD_I2C_BATRON_gotoxy(4,1);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xE
;     363 strcpyf(String_to_LCD, Texte_Accueil_Ligne2);  
	LDI  R30,LOW(_Texte_Accueil_Ligne2*2)
	LDI  R31,HIGH(_Texte_Accueil_Ligne2*2)
	RCALL SUBOPT_0xF
;     364 Built_Frame_String_I2C(Frame_I2C_Lcd_Line, String_to_LCD, strlen(String_to_LCD));  
;     365 TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
;     366 //******************************************************************************************************************************
;     367 
;     368 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x10
;     369  
;     370 // Construction d'un message et envoi 
;     371 // -----------------------------------------------------------------------------------------------------------------------------
;     372 TWI_Start_Transc_With_Data(Frame_I2C_LCD_BATRON_Clear,sizeof(Frame_I2C_LCD_BATRON_Clear));	// Effacement de l'cran
	RCALL SUBOPT_0xD
;     373 Digit = 145;
	LDI  R17,LOW(145)
;     374 itoa((int)Digit, Digit_to_String);			// Conversion de la valeur 145 en chane de caractres
	MOV  R30,R17
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x11
	RCALL _itoa
;     375 Built_Frame_String_I2C(Frame_I2C_Lcd_Line, Digit_to_String, strlen(Digit_to_String)); 
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R30
	RCALL SUBOPT_0x11
	RCALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Frame_String_I2C
;     376 TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	RCALL SUBOPT_0xC
;     377 // =============================================================================================================================
;     378 
;     379 // =============================================================================================================================
;     380 // ================================================ Boucle principale ==========================================================
;     381 // =============================================================================================================================
;     382 while (1)
_0x6A:
;     383       { 
;     384 // ----------------------------------  Champ Lecture des donnes ---------------------------------------------------- 
;     385 // Lecture de l'tat des BP
;     386     TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);      	// Envoi de l'octet d'adresse des BP + bit RW=lecture(0x43)
	MOVW R30,R28
	ADIW R30,43
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xC
;     387     TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,2);   	// TWI_Get_Data_From_Transceiver(Donnee_BP,2);
	MOVW R30,R28
	ADIW R30,43
	RCALL SUBOPT_0xA
	RCALL _TWI_Get_Data_From_Transceiver
;     388           
;     389 // ----------------------------------  Champ Traitement -------------------------------------------------------------        
;     390     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];   	
	LDD  R30,Y+44
	COM  R30
	STD  Y+46,R30
;     391     
;     392 // ----------------------------------  Champ Ecriture des rsultats  ------------------------------------------------
;     393 // Ecriture sur les LED                              	
;     394     TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  // Les LED affichent l'tat des BP
	MOVW R30,R28
	ADIW R30,45
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     395     delay_ms(200);					// Lecture des BP toutes les 200ms
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x10
;     396     
;     397       }; // Fin while(1)
	RJMP _0x6A
;     398       
;     399 } //Fin main  
	ADIW R28,63
	ADIW R28,6
_0x6D:
	RJMP _0x6D
;     400 // =============================================================================================================================
;     401 
;     402 // =============================================================================================================================
;     403 // Fonctions pour le LCD BATRON    
;     404 // A mettre dans une bibliothque
;     405 // =============================================================================================================================
;     406 
;     407 void LCD_I2C_BATRON_gotoxy(unsigned char posx , unsigned char posy) 
;     408 {
_LCD_I2C_BATRON_gotoxy:
;     409  unsigned char LCD_BATRON_XY[] = {0x76,0x00,0x80};
;     410  
;     411  if((posx<16)&&(posy<2))
	SBIW R28,3
	LDI  R24,3
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x6F*2)
	LDI  R31,HIGH(_0x6F*2)
	RCALL __INITLOCB
;	posx -> Y+4
;	posy -> Y+3
;	LCD_BATRON_XY -> Y+0
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x71
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x72
_0x71:
	RJMP _0x70
_0x72:
;     412  {
;     413   switch(posy)
	LDD  R30,Y+3
;     414   {
;     415     case 0:LCD_BATRON_XY[2]=posx+0x80; break;
	CPI  R30,0
	BRNE _0x76
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	STD  Y+2,R30
	RJMP _0x75
;     416     case 1:LCD_BATRON_XY[2]=posx+0xC0; break;
_0x76:
	CPI  R30,LOW(0x1)
	BRNE _0x75
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
	STD  Y+2,R30
;     417   } 
_0x75:
;     418  }
;     419   TWI_Start_Transc_With_Data(LCD_BATRON_XY, sizeof(LCD_BATRON_XY));
_0x70:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	RCALL SUBOPT_0xC
;     420 } 
	ADIW R28,5
	RET
;     421 // =============================================================================================================================
;     422 
;     423 void Built_Frame_String_I2C(unsigned char FrameI2C, unsigned char Tstring, int Tstringsize)
;     424 {     
_Built_Frame_String_I2C:
;     425  int i; 
;     426  unsigned char *p_Tstring, *p_FrameI2C;
;     427  p_Tstring = Tstring; p_FrameI2C = FrameI2C + 2; 
	SBIW R28,4
	RCALL __SAVELOCR2
;	FrameI2C -> Y+9
;	Tstring -> Y+8
;	Tstringsize -> Y+6
;	i -> R16,R17
;	*p_Tstring -> Y+4
;	*p_FrameI2C -> Y+2
	LDD  R30,Y+8
	CLR  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+9
	SUBI R30,-LOW(2)
	CLR  R31
	STD  Y+2,R30
	STD  Y+2+1,R31
;     428  
;     429  for(i=0;i<Tstringsize;i++)                  
	__GETWRN 16,17,0
_0x7A:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x7B
;     430  {
;     431   *p_FrameI2C = *p_Tstring + 0x80;
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X
	SUBI R30,-LOW(128)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
;     432    p_Tstring++; p_FrameI2C++;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
;     433  }
	__ADDWRN 16,17,1
	RJMP _0x7A
_0x7B:
;     434  *p_FrameI2C = 0;
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ST   X,R30
;     435 }
	RCALL __LOADLOCR2
	ADIW R28,10
	RET
;     436 // =============================================================================================================================

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	MOV  R30,R16
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xC:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	MOVW R30,R28
	ADIW R30,40
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Frame_String_I2C
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RET

_itoa:
	ld   r26,y+
	ld   r27,y+
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	brpl __itoa0
	com  r30
	com  r31
	adiw r30,1
	ldi  r22,'-'
	st   x+,r22
__itoa0:
	clt
	ldi  r24,low(10000)
	ldi  r25,high(10000)
	rcall __itoa1
	ldi  r24,low(1000)
	ldi  r25,high(1000)
	rcall __itoa1
	ldi  r24,100
	clr  r25
	rcall __itoa1
	ldi  r24,10
	rcall __itoa1
	mov  r22,r30
	rcall __itoa5
	clr  r22
	st   x,r22
	ret
__itoa1:
	clr	 r22
__itoa2:
	cp   r30,r24
	cpc  r31,r25
	brlo __itoa3
	inc  r22
	sub  r30,r24
	sbc  r31,r25
	brne __itoa2
__itoa3:
	tst  r22
	brne __itoa4
	brts __itoa5
	ret
__itoa4:
	set
__itoa5:
	subi r22,-0x30
	st   x+,r22
	ret

_strcpyf:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcpyf0:
	lpm  r0,z+
	st   x+,r0
	tst  r0
	brne __strcpyf0
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

