;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "TBOUSSO.vec"
	.INCLUDE "TBOUSSO.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 // =============================================================================================================================
;       2 // Partie dclarative du programme
;       3 // =============================================================================================================================
;       4 // Bibliothques et dfinitions
;       5 // =============================================================================================================================
;       6 #include <mega8535.h>      
;       7 // -----------------------------------------------------------------------------------------------------------------------------
;       8 // Bibliothque  rajouter manuellement   
;       9 // -----------------------------------------------------------------------------------------------------------------------------
;      10 #include <stdlib.h> 
;      11 #include <stdio.h>				// Fonction sprintf
;      12 #include <math.h>
;      13 #include <string.h>				// Fonctions de traitement des chanes de caractres  
;      14 #include <delay.h>				// Fonction temporisation 
;      15 // -----------------------------------------------------------------------------------------------------------------------------    
;      16 // Bibliothque dveloppes pour la carte SISI    
;      17 // -----------------------------------------------------------------------------------------------------------------------------
;      18 #include "HMC6352.h"			// Dfinition des registres de la boussole Honeywell HMC6352
;      19 #include "MD23.h"				// Dfinitions des registres de la carte moteur MD23  
;      20 #include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C 
;      21 #include "SISISOL.h"            // Gestion de l'IHM SISI 
;      22 
;      23 // -----------------------------------------------------------------------------------------------------------------------------
;      24 // Redfinition des adresses (lecture / criture) de la boussole HMC6352 (0x42 par dfaut)
;      25 // -----------------------------------------------------------------------------------------------------------------------------
;      26 #define NEW_HMC6352_SLA_W 	0x44 // Ox42 est utilis par le PCF8574 reli aux LEDs sur l'IHM SISIV1 ! 
;      27 #define	NEW_HMC6352_SLA_R   0x45 
;      28 
;      29 #define Empty	0	
;      30 // -----------------------------------------------------------------------------------------------------------------------------
;      31 // Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
;      32 // -----------------------------------------------------------------------------------------------------------------------------
;      33 #define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
;      34 #include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
;      35 /***********************************************************************
;      36 Project : PPE Robot(s)
;      37 Version : 1
;      38 Date    : 12/08/2009
;      39 Author  : MNO
;      40 File : twi_f.c
;      41 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      42 et dcrites dans la note d'application AVR315, adaptes au
;      43 cross compilateur CVAVR.
;      44 Fichier  inclure en en tte d'une application ncessitant une interface
;      45 2 fil I2C.
;      46 Evolution:  remplacer par une bibliothque
;      47 ***********************************************************************/
;      48 
;      49 
;      50 #include <TWI_Master_CVAVR.h>  
;      51 
;      52 // Declare your global variables here 
;      53 //-----------------------------------------------------------------------------------------------------------------------------
;      54 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      55 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      56 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      57  
;      58 union TWI_STR                      					// Status byte holding flags.
;      59 {
;      60     unsigned char all;
;      61     unsigned char lastTransOK:1;      
;      62     unsigned char unusedBits:7; 
;      63 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      64 //-----------------------------------------------------------------------------------------------------------------------------
;      65 
;      66 //-----------------------------------------------------------------------------------------------------------------------------
;      67 // Fonctions du drivers TWI
;      68 //-----------------------------------------------------------------------------------------------------------------------------
;      69 void TWI_Master_Initialise(void)
;      70 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      71   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      72 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      73   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      74   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;      75   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;      76                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;      77                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;      78                                          		// 0<<TWWC); 
;      79 } 
	RET
;      80 //-----------------------------------------------------------------------------------------------------------------------------
;      81 unsigned char TWI_Transceiver_Busy(void)
;      82 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;      83   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;      84 }
;      85 //-----------------------------------------------------------------------------------------------------------------------------
;      86 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;      87 {
_TWI_Start_Transc_With_Data:
;      88   unsigned char temp;
;      89                                                 // Adapte pour CVAVR
;      90   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x70:
	RCALL SUBOPT_0x0
	BRNE _0x70
;      91 
;      92   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;      93   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;      94   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x73
;      95   {												// If it is a write operation, then also copy data.
;      96     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x75:
	RCALL SUBOPT_0x2
	BRSH _0x76
;      97       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x5
	RJMP _0x75
_0x76:
;      98   }
;      99   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x73:
	CLR  R30
	STS  _TWI_statusReg,R30
;     100   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     101   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     102                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     103                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     104                                       			// (0<<TWWC);
;     105 } 
	RJMP _0x148
;     106 //-----------------------------------------------------------------------------------------------------------------------------
;     107 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     108 {
_TWI_Get_Data_From_Transceiver:
;     109   unsigned char i;
;     110           
;     111   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0x78:
	RCALL SUBOPT_0x0
	BRNE _0x78
;     112 
;     113   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x6
	BREQ _0x7B
;     114   {                                             
;     115     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x7D:
	RCALL SUBOPT_0x2
	BRSH _0x7E
;     116     {
;     117       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     118     }
	RCALL SUBOPT_0x5
	RJMP _0x7D
_0x7E:
;     119   }
;     120   return( TWI_statusReg.lastTransOK );                                   
_0x7B:
	RCALL SUBOPT_0x6
_0x148:
	ADIW R28,4
	RET
;     121 }  
;     122 //-----------------------------------------------------------------------------------------------------------------------------
;     123 
;     124 // ----------------------------------------------------------------------------------------------------------------------------
;     125 // Interruption TWI
;     126 // ----------------------------------------------------------------------------------------------------------------------------
;     127 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     128 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     129 												// __interrupt void TWI_ISR(void)
;     130   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     131   
;     132   switch (TWSR)
	IN   R30,0x1
;     133   {
;     134     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x84
;     135     
;     136     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x85
_0x84:
;     137       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     138       				
;     139     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x86
_0x85:
	CPI  R30,LOW(0x18)
	BRNE _0x87
_0x86:
;     140     
;     141     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x88
_0x87:
	CPI  R30,LOW(0x28)
	BRNE _0x89
_0x88:
;     142       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x8A
;     143       {
;     144         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x7
	LD   R30,Z
	OUT  0x3,R30
;     145         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x149
;     146         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     147                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     148                						  			// (0<<TWWC); 
;     149       }
;     150       else                    					// Send STOP after last byte
_0x8A:
;     151       {
;     152         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x8
;     153          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     154         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x149:
	OUT  0x36,R30
;     155         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     156                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     157                                				  	// (0<<TWWC);
;     158       }
;     159     break;
	RJMP _0x82
;     160       
;     161     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x89:
	CPI  R30,LOW(0x50)
	BRNE _0x8C
;     162       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x7
	MOVW R26,R30
	RCALL SUBOPT_0x9
;     163       
;     164     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x8D
_0x8C:
	CPI  R30,LOW(0x40)
	BRNE _0x8E
_0x8D:
;     165       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x8F
;     166       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     167         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x14A
;     168         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     169                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     170                                   				// (0<<TWWC);  
;     171       } else                    				// Send NACK after next reception
_0x8F:
;     172       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     173         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x14A:
	OUT  0x36,R30
;     174         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     175                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     176                                 			  	// (0<<TWWC); 
;     177       }    
;     178     break; 
	RJMP _0x82
;     179       
;     180     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x8E:
	CPI  R30,LOW(0x58)
	BRNE _0x91
;     181       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0x9
;     182       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x8
;     183       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     184       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x14B
;     185                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     186                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     187                               					// (0<<TWWC); 
;     188     break;  
;     189           
;     190     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x91:
	CPI  R30,LOW(0x38)
	BRNE _0x92
;     191     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     192       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x14B
;     193                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     194                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     195                               					// (0<<TWWC);
;     196     break;
;     197       
;     198     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x92:
	CPI  R30,LOW(0x20)
	BREQ _0x94
;     199     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x95
_0x94:
;     200     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0x96
_0x95:
	CPI  R30,LOW(0x30)
	BRNE _0x97
_0x96:
;     201 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     202     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0x98
_0x97:
	CPI  R30,0
	BRNE _0x9A
_0x98:
;     203     
;     204     default:     
_0x9A:
;     205       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     206       											// Reset TWI Interface
;     207                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     208       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x14B:
	OUT  0x36,R30
;     209                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     210                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     211                               					// (0<<TWWC);
;     212   }
_0x82:
;     213 } 
	RCALL __LOADISR
	RETI
;     214 
;     215 
;     216 flash char *Ligne1ChoixEchap		= "        [Echap] ";							// A remplacer par une bibliothque ! 

	.DSEG
_Ligne1ChoixEchap:
	.BYTE 0x2
;     217 										
;     218 void main(void)
;     219 {

	.CSEG
_main:
;     220 // =============================================================================================================================
;     221 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     222 // =============================================================================================================================
;     223 // Messages pour les composants I2C 
;     224 // =============================================================================================================================
;     225 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
;     226 // ----------------------------------------------------------------------------------------------------------------------------- 
;     227 // Type 	   		Nom 				       						Description 
;     228 // ----------------------------------------------------------------------------------------------------------------------------- 
;     229 // =============================================================================================================================
;     230 // 4) Liste des messages prdfinis pour la boussole HMC6352
;     231 // =============================================================================================================================
;     232 // Lecture de la direction (comprise entre 0 et 3599, code sur deux octets)
;     233 unsigned char Frame_I2C_W_Cde_HMC6352[] = {NEW_HMC6352_SLA_W,'A'}; 
;     234 unsigned char Frame_I2C_Read_Data_HMC6352[] = {NEW_HMC6352_SLA_R,Empty,Empty}; 
;     235 
;     236 // Lecture Adresse base
;     237 unsigned char Frame_I2C_W_Add_EEPROM_HMC6352[] = {NEW_HMC6352_SLA_W,'r',Operational_Mode_EEPROM};   
;     238 unsigned char Frame_I2C_Read_Add_Reg_HMC6352[] = {NEW_HMC6352_SLA_R,Empty};
;     239  
;     240 // Trame de changement de l'addresse de la boussole (A faire une seule fois)
;     241 unsigned char Frame_I2C_Change_Add_HMC6352[] = {HMC6352_SLA_W,'w',HMC6352_Reg_ADD_BASE,NEW_HMC6352_SLA_W}; 
;     242 
;     243 // =============================================================================================================================
;     244 // Variables diverses
;     245 // ----------------------------------------------------------------------------------------------------------------------------- 
;     246 // Type 		Nom 				       Description 
;     247 // -----------------------------------------------------------------------------------------------------------------------------
;     248 // 2) Boussole HMC6352
;     249 unsigned char Direction_MSB, Direction_MSB_1, Direction_LSB, Direction_LSB_1;
;     250 
;     251 // 2) Gestion du LCD BATRON
;     252 // -----------------------------------------------------------------------------------------------------------------------------
;     253  char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];     // Reoivent les deux lignes de texte  envoyer  l'afficheur
;     254 															// (16 caractres max. + Nul)
;     255 // -----------------------------------------------------------------------------------------------------------------------------
;     256 
;     257 // =============================================================================================================================
;     258 // ===================================================== Initialisations =======================================================
;     259 // =============================================================================================================================
;     260 TWI_Master_Initialise(); 									// Initialisation de l'interface TWI en mode Standby 
	SBIW R28,48
	LDI  R24,14
	LDI  R26,LOW(34)
	LDI  R27,HIGH(34)
	LDI  R30,LOW(_0x9C*2)
	LDI  R31,HIGH(_0x9C*2)
	RCALL __INITLOCB
;	Frame_I2C_W_Cde_HMC6352 -> Y+46
;	Frame_I2C_Read_Data_HMC6352 -> Y+43
;	Frame_I2C_W_Add_EEPROM_HMC6352 -> Y+40
;	Frame_I2C_Read_Add_Reg_HMC6352 -> Y+38
;	Frame_I2C_Change_Add_HMC6352 -> Y+34
;	Direction_MSB -> R16
;	Direction_MSB_1 -> R17
;	Direction_LSB -> R18
;	Direction_LSB_1 -> R19
;	Buffer_for_LCD_Line0 -> Y+17
;	Buffer_for_LCD_Line1 -> Y+0
	RCALL _TWI_Master_Initialise
;     261 // -----------------------------------------------------------------------------------------------------------------------------
;     262 // Global enable interrupts
;     263 #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI
	sei
;     264 // -----------------------------------------------------------------------------------------------------------------------------
;     265 // Initialisation de l'afficheur I2C BATRON 
;     266 // -----------------------------------------------------------------------------------------------------------------------------
;     267 Init_LCD_I2C_BATRON();
	RCALL _Init_LCD_I2C_BATRON
;     268 
;     269 // Prparation de l'opration de lecture en EEPROM : Ecriture de la commande 'r' et de l'argument "EEPROM Address"
;     270 //TWI_Start_Transc_With_Data(Frame_I2C_W_Add_EEPROM_HMC6352,sizeof(Frame_I2C_W_Add_EEPROM_HMC6352)); // (1)
;     271 
;     272 
;     273 
;     274 while(1)
_0x9D:
;     275 {
;     276 
;     277 // Initialisation de la boussole HMC6352
;     278 // ----------------------------------------------------------------------------------------------------------------------------- 
;     279 // Lecture de l'adresse EEPROM prcise en (1)
;     280 // TWI_Start_Transc_With_Data(Frame_I2C_Read_Add_Reg_HMC6352,sizeof(Frame_I2C_Read_Add_Reg_HMC6352)); 
;     281 
;     282 // Prparation de l'opration de lecture des donnes: Ecriture de la commande 'A' 
;     283 TWI_Start_Transc_With_Data(Frame_I2C_W_Cde_HMC6352, sizeof(Frame_I2C_W_Cde_HMC6352));
	MOVW R30,R28
	ADIW R30,46
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	RCALL SUBOPT_0xA
;     284 TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	RCALL SUBOPT_0xA
;     285 TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
;     286 
;     287 
;     288 Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2]; 
	LDD  R16,Y+44
	LDD  R18,Y+45
;     289  
;     290 if ((Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB)) 
	CP   R16,R17
	BRNE _0xA1
	CP   R18,R19
	BREQ _0xA0
_0xA1:
;     291 {	
;     292 	sprintf(Buffer_for_LCD_Line0,"3.1 MSB=%-x LSB=%-x",Direction_MSB, Direction_LSB);
	RCALL SUBOPT_0xB
	__POINTW1FN _155,0
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	RCALL SUBOPT_0xC
	MOV  R30,R18
	RCALL SUBOPT_0xC
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
;     293 	strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0xD
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
;     294 	Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xE
	RCALL _Displ_2Lines_On_I2C_LCDBATRON
;     295 	Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     296 	Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB;
	MOV  R17,R16
	MOV  R19,R18
;     297 }
;     298 	
;     299 delay_us(2000); // pour affichage stable sur l'oscilloscope 
_0xA0:
	__DELAY_USW 4000
;     300 
;     301 // -----------------------------------------------------------------------------------------------------------------------------
;     302 }
	RJMP _0x9D
;     303 }
	ADIW R28,48
_0xA3:
	RJMP _0xA3
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0xF
	SBIW R30,0
	BREQ _0xDA
	RCALL SUBOPT_0xF
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xDB
_0xDA:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0xDB:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0xDD:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xDF
	MOV  R30,R16
	CPI  R30,0
	BRNE _0xE3
	CPI  R19,37
	BRNE _0xE4
	LDI  R16,LOW(1)
	RJMP _0xE5
_0xE4:
	RCALL SUBOPT_0x10
_0xE5:
	RJMP _0xE2
_0xE3:
	CPI  R30,LOW(0x1)
	BRNE _0xE6
	CPI  R19,37
	BRNE _0xE7
	RCALL SUBOPT_0x10
	LDI  R16,LOW(0)
	RJMP _0xE2
_0xE7:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xE8
	LDI  R17,LOW(1)
	RJMP _0xE2
_0xE8:
	CPI  R19,43
	BRNE _0xE9
	LDI  R21,LOW(43)
	RJMP _0xE2
_0xE9:
	CPI  R19,32
	BRNE _0xEA
	LDI  R21,LOW(32)
	RJMP _0xE2
_0xEA:
	RJMP _0xEB
_0xE6:
	CPI  R30,LOW(0x2)
	BRNE _0xEC
_0xEB:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xED
	ORI  R17,LOW(128)
	RJMP _0xE2
_0xED:
	RJMP _0xEE
_0xEC:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xE2
_0xEE:
	CPI  R19,48
	BRLO _0xF1
	CPI  R19,58
	BRLO _0xF2
_0xF1:
	RJMP _0xF0
_0xF2:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xE2
_0xF0:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xF6
	RCALL SUBOPT_0x11
	LD   R30,X
	RCALL SUBOPT_0x12
	RJMP _0xF7
_0xF6:
	CPI  R30,LOW(0x73)
	BRNE _0xF9
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL _strlen
	MOV  R16,R30
	RJMP _0xFA
_0xF9:
	CPI  R30,LOW(0x70)
	BRNE _0xFC
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xFA:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xFD
_0xFC:
	CPI  R30,LOW(0x64)
	BREQ _0x100
	CPI  R30,LOW(0x69)
	BRNE _0x101
_0x100:
	ORI  R17,LOW(4)
	RJMP _0x102
_0x101:
	CPI  R30,LOW(0x75)
	BRNE _0x103
_0x102:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x104
_0x103:
	CPI  R30,LOW(0x58)
	BRNE _0x106
	ORI  R17,LOW(8)
	RJMP _0x107
_0x106:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x135
_0x107:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x104:
	SBRS R17,2
	RJMP _0x109
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x14
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x10A
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x10A:
	CPI  R21,0
	BREQ _0x10B
	SUBI R16,-LOW(1)
	RJMP _0x10C
_0x10B:
	ANDI R17,LOW(251)
_0x10C:
	RJMP _0x10D
_0x109:
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x14
_0x10D:
_0xFD:
	SBRC R17,0
	RJMP _0x10E
_0x10F:
	CP   R16,R20
	BRSH _0x111
	SBRS R17,7
	RJMP _0x112
	SBRS R17,2
	RJMP _0x113
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x114
_0x113:
	LDI  R19,LOW(48)
_0x114:
	RJMP _0x115
_0x112:
	LDI  R19,LOW(32)
_0x115:
	RCALL SUBOPT_0x10
	SUBI R20,LOW(1)
	RJMP _0x10F
_0x111:
_0x10E:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x116
_0x117:
	CPI  R18,0
	BREQ _0x119
	SBRS R17,3
	RJMP _0x11A
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x14C
_0x11A:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x14C:
	ST   -Y,R30
	RCALL SUBOPT_0x15
	CPI  R20,0
	BREQ _0x11C
	SUBI R20,LOW(1)
_0x11C:
	SUBI R18,LOW(1)
	RJMP _0x117
_0x119:
	RJMP _0x11D
_0x116:
_0x11F:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x121
	SBRS R17,3
	RJMP _0x122
	SUBI R19,-LOW(7)
	RJMP _0x123
_0x122:
	SUBI R19,-LOW(39)
_0x123:
_0x121:
	SBRC R17,4
	RJMP _0x125
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x127
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x126
_0x127:
	ORI  R17,LOW(16)
	RJMP _0x129
_0x126:
	CP   R20,R18
	BRLO _0x12B
	SBRS R17,0
	RJMP _0x12C
_0x12B:
	RJMP _0x12A
_0x12C:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x12D
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x129:
	SBRS R17,2
	RJMP _0x12E
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x15
	CPI  R20,0
	BREQ _0x12F
	SUBI R20,LOW(1)
_0x12F:
_0x12E:
_0x12D:
_0x125:
	RCALL SUBOPT_0x10
	CPI  R20,0
	BREQ _0x130
	SUBI R20,LOW(1)
_0x130:
_0x12A:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x120
	RJMP _0x11F
_0x120:
_0x11D:
	SBRS R17,0
	RJMP _0x131
_0x132:
	CPI  R20,0
	BREQ _0x134
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x12
	RJMP _0x132
_0x134:
_0x131:
_0x135:
_0xF7:
	LDI  R16,LOW(0)
_0xE2:
	RJMP _0xDD
_0xDF:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x16
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x16
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x13D*2)
	LDI  R31,HIGH(_0x13D*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0xD
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x17
	ADIW R28,13
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,20
	LDI  R24,19
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x13F*2)
	LDI  R31,HIGH(_0x13F*2)
	RCALL __INITLOCB
	CLR  R30
	STD  Y+19,R30
_0x141:
	LDD  R26,Y+19
	CPI  R26,LOW(0x2)
	BRSH _0x142
	RCALL SUBOPT_0x18
	LDD  R30,Y+20
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1A
	LDD  R30,Y+19
	SUBI R30,-LOW(1)
	STD  Y+19,R30
	RJMP _0x141
_0x142:
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x18
	RCALL _LCD_I2C_BATRON_gotoxy
	RCALL SUBOPT_0x1B
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x1B
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x1A
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R24,6
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x144*2)
	LDI  R31,HIGH(_0x144*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x18
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x1F
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,43
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xD:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xE:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x10:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x11:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x17:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x18:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x19:
	ST   -Y,R30
	RJMP _LCD_I2C_BATRON_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	RCALL _strlen
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	MOVW R30,R28
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(1)
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	LDI  R30,LOW(3)
	RJMP SUBOPT_0x17

_strcpyf:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcpyf0:
	lpm  r0,z+
	st   x+,r0
	tst  r0
	brne __strcpyf0
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

