// =============================================================================================================================
// Partie dclarative du programme
// =============================================================================================================================
// Bibliothques et dfinitions
// =============================================================================================================================
#include <mega8535.h>      
// -----------------------------------------------------------------------------------------------------------------------------
// Bibliothque  rajouter manuellement   
// -----------------------------------------------------------------------------------------------------------------------------
#include <stdlib.h> 
#include <stdio.h>				// Fonction sprintf
#include <math.h>
#include <string.h>				// Fonctions de traitement des chanes de caractres  
#include <delay.h>				// Fonction temporisation 
// -----------------------------------------------------------------------------------------------------------------------------    
// Bibliothque dveloppes pour la carte SISI    
// -----------------------------------------------------------------------------------------------------------------------------
#include "HMC6352.h"			// Dfinition des registres de la boussole Honeywell HMC6352
#include "MD23.h"				// Dfinitions des registres de la carte moteur MD23  
#include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C 
#include "SISISOL.h"            // Gestion de l'IHM SISI 

// -----------------------------------------------------------------------------------------------------------------------------
// Redfinition des adresses (lecture / criture) de la boussole HMC6352 (0x42 par dfaut)
// -----------------------------------------------------------------------------------------------------------------------------
#define NEW_HMC6352_SLA_W 	0x44 // Ox42 est utilis par le PCF8574 reli aux LEDs sur l'IHM SISIV1 ! 
#define	NEW_HMC6352_SLA_R   0x45 

#define Empty	0	
// -----------------------------------------------------------------------------------------------------------------------------
// Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
// -----------------------------------------------------------------------------------------------------------------------------
#define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
#include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 

flash char *Ligne1ChoixEchap		= "        [Echap] ";							// A remplacer par une bibliothque ! 
										
void main(void)
{
// =============================================================================================================================
// ---------------------------------------------- Declare your local variables here -------------------------------------------- 
// =============================================================================================================================
// Messages pour les composants I2C 
// =============================================================================================================================
// 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 	   		Nom 				       						Description 
// ----------------------------------------------------------------------------------------------------------------------------- 
// =============================================================================================================================
// 4) Liste des messages prdfinis pour la boussole HMC6352
// =============================================================================================================================
// Lecture de la direction (comprise entre 0 et 3599, code sur deux octets)
unsigned char Frame_I2C_W_Cde_HMC6352[] = {NEW_HMC6352_SLA_W,'A'}; 
unsigned char Frame_I2C_Read_Data_HMC6352[] = {NEW_HMC6352_SLA_R,Empty,Empty}; 

// Lecture Adresse base
unsigned char Frame_I2C_W_Add_EEPROM_HMC6352[] = {NEW_HMC6352_SLA_W,'r',Operational_Mode_EEPROM};   
unsigned char Frame_I2C_Read_Add_Reg_HMC6352[] = {NEW_HMC6352_SLA_R,Empty};
 
// Trame de changement de l'addresse de la boussole (A faire une seule fois)
unsigned char Frame_I2C_Change_Add_HMC6352[] = {HMC6352_SLA_W,'w',HMC6352_Reg_ADD_BASE,NEW_HMC6352_SLA_W}; 

// =============================================================================================================================
// Variables diverses
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 		Nom 				       Description 
// -----------------------------------------------------------------------------------------------------------------------------
// 2) Boussole HMC6352
unsigned char Direction_MSB, Direction_MSB_1, Direction_LSB, Direction_LSB_1;

// 2) Gestion du LCD BATRON
// -----------------------------------------------------------------------------------------------------------------------------
 char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];     // Reoivent les deux lignes de texte  envoyer  l'afficheur
															// (16 caractres max. + Nul)
// -----------------------------------------------------------------------------------------------------------------------------

// =============================================================================================================================
// ===================================================== Initialisations =======================================================
// =============================================================================================================================
TWI_Master_Initialise(); 									// Initialisation de l'interface TWI en mode Standby 
// -----------------------------------------------------------------------------------------------------------------------------
// Global enable interrupts
#asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI
// -----------------------------------------------------------------------------------------------------------------------------
// Initialisation de l'afficheur I2C BATRON 
// -----------------------------------------------------------------------------------------------------------------------------
Init_LCD_I2C_BATRON();

// Prparation de l'opration de lecture en EEPROM : Ecriture de la commande 'r' et de l'argument "EEPROM Address"
//TWI_Start_Transc_With_Data(Frame_I2C_W_Add_EEPROM_HMC6352,sizeof(Frame_I2C_W_Add_EEPROM_HMC6352)); // (1)



while(1)
{

// Initialisation de la boussole HMC6352
// ----------------------------------------------------------------------------------------------------------------------------- 
// Lecture de l'adresse EEPROM prcise en (1)
// TWI_Start_Transc_With_Data(Frame_I2C_Read_Add_Reg_HMC6352,sizeof(Frame_I2C_Read_Add_Reg_HMC6352)); 

// Prparation de l'opration de lecture des donnes: Ecriture de la commande 'A' 
TWI_Start_Transc_With_Data(Frame_I2C_W_Cde_HMC6352, sizeof(Frame_I2C_W_Cde_HMC6352));
TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));


Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2]; 
 
if ((Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB)) 
{	
	sprintf(Buffer_for_LCD_Line0,"3.1 MSB=%-x LSB=%-x",Direction_MSB, Direction_LSB);
	strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	Display_Arrow_0n_I2C_LCDBATRON();
	Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB;
}
	
delay_us(2000); // pour affichage stable sur l'oscilloscope 

// -----------------------------------------------------------------------------------------------------------------------------
}
}