;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 166 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "twi4bsol.vec"
	.INCLUDE "twi4bsol.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x106)
	LDI  R29,HIGH(0x106)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x106
;       1 /********************************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot solaire
;      10 Version : 4.0.0
;      11 Date    : 19/05/2010
;      12 Mise  jour: 19/05/2010
;      13 Author  : Philippe Mariano                            
;      14 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      15 Comments: Fichier de la fiche guide 2
;      16 Mise en oeuvre du protocole I2C par l'interface TWI 
;      17 Commande d'un afficheur LCD Batron I2C (PCF2119x)
;      18 Lecture des BP et recopie sur les LED. 
;      19 Programme de test de la boussole HMC6352
;      20 
;      21 File : twi4bsol.c
;      22 Target:  Robot S_ISI
;      23 Chip type           : ATmega8535
;      24 Program type        : Application
;      25 Clock frequency     : 8,000000 MHz
;      26 Memory model        : Small
;      27 External SRAM size  : 0
;      28 Data Stack size     : 128
;      29 *********************************************************************/
;      30 
;      31 // =============================================================================================================================
;      32 // Partie dclarative du programme
;      33 // =============================================================================================================================
;      34 // Bibliothques et dfinitions
;      35 // =============================================================================================================================
;      36 #include <mega8535.h>      
;      37 // -----------------------------------------------------------------------------------------------------------------------------
;      38 // Bibliothque  rajouter manuellement   
;      39 // -----------------------------------------------------------------------------------------------------------------------------
;      40 #include <stdlib.h> 
;      41 #include <stdio.h>				// Fonction sprintf
;      42 #include <math.h>
;      43 #include <string.h>				// Fonctions de traitement des chanes de caractres  
;      44 #include <delay.h>				// Fonction temporisation   
;      45 // -----------------------------------------------------------------------------------------------------------------------------    
;      46 // Bibliothque dveloppes pour la carte SISI    
;      47 // -----------------------------------------------------------------------------------------------------------------------------
;      48 #include "HMC6352.h"			// Dfinition des registres de la boussole Honeywell HMC6352
;      49 #include "MD23.h"				// Dfinitions des registres de la carte moteur MD23  
;      50 #include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C 
;      51 #include "SISISOL.h"            // Gestion de l'IHM SISI 
;      52 // -----------------------------------------------------------------------------------------------------------------------------
;      53 // Redfinition des adresses (lecture / criture) de la boussole HMC6352 (0x42 par dfaut)
;      54 // -----------------------------------------------------------------------------------------------------------------------------
;      55 #define NEW_HMC6352_SLA_W 	0x44 // Ox42 est utilis par le PCF8574 reli aux LEDs sur l'IHM SISIV1 ! 
;      56 #define	NEW_HMC6352_SLA_R   0x45	
;      57 // -----------------------------------------------------------------------------------------------------------------------------
;      58 // Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
;      59 // -----------------------------------------------------------------------------------------------------------------------------
;      60 #define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
;      61 #include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
;      62 /***********************************************************************
;      63 Project : PPE Robot(s)
;      64 Version : 1
;      65 Date    : 12/08/2009
;      66 Author  : MNO
;      67 File : twi_f.c
;      68 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      69 et dcrites dans la note d'application AVR315, adaptes au
;      70 cross compilateur CVAVR.
;      71 Fichier  inclure en en tte d'une application ncessitant une interface
;      72 2 fil I2C.
;      73 Evolution:  remplacer par une bibliothque
;      74 ***********************************************************************/
;      75 
;      76 
;      77 #include <TWI_Master_CVAVR.h>  
;      78 
;      79 // Declare your global variables here 
;      80 //-----------------------------------------------------------------------------------------------------------------------------
;      81 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      82 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      83 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      84  
;      85 union TWI_STR                      					// Status byte holding flags.
;      86 {
;      87     unsigned char all;
;      88     unsigned char lastTransOK:1;      
;      89     unsigned char unusedBits:7; 
;      90 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      91 //-----------------------------------------------------------------------------------------------------------------------------
;      92 
;      93 //-----------------------------------------------------------------------------------------------------------------------------
;      94 // Fonctions du drivers TWI
;      95 //-----------------------------------------------------------------------------------------------------------------------------
;      96 void TWI_Master_Initialise(void)
;      97 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      98   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      99 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;     100   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;     101   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     102   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;     103                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;     104                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;     105                                          		// 0<<TWWC); 
;     106 } 
	RET
;     107 //-----------------------------------------------------------------------------------------------------------------------------
;     108 unsigned char TWI_Transceiver_Busy(void)
;     109 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;     110   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;     111 }
;     112 //-----------------------------------------------------------------------------------------------------------------------------
;     113 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;     114 {
_TWI_Start_Transc_With_Data:
;     115   unsigned char temp;
;     116                                                 // Adapte pour CVAVR
;     117   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x70:
	RCALL SUBOPT_0x0
	BRNE _0x70
;     118 
;     119   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;     120   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;     121   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x73
;     122   {												// If it is a write operation, then also copy data.
;     123     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x75:
	RCALL SUBOPT_0x2
	BRSH _0x76
;     124       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x6
	RJMP _0x75
_0x76:
;     125   }
;     126   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x73:
	CLR  R30
	STS  _TWI_statusReg,R30
;     127   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     128   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     129                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     130                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     131                                       			// (0<<TWWC);
;     132 } 
	RJMP _0x1FD
;     133 //-----------------------------------------------------------------------------------------------------------------------------
;     134 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     135 {
_TWI_Get_Data_From_Transceiver:
;     136   unsigned char i;
;     137           
;     138   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0x78:
	RCALL SUBOPT_0x0
	BRNE _0x78
;     139 
;     140   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x7
	BREQ _0x7B
;     141   {                                             
;     142     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x7D:
	RCALL SUBOPT_0x2
	BRSH _0x7E
;     143     {
;     144       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     145     }
	RCALL SUBOPT_0x6
	RJMP _0x7D
_0x7E:
;     146   }
;     147   return( TWI_statusReg.lastTransOK );                                   
_0x7B:
	RCALL SUBOPT_0x7
_0x1FD:
	ADIW R28,4
	RET
;     148 }  
;     149 //-----------------------------------------------------------------------------------------------------------------------------
;     150 
;     151 // ----------------------------------------------------------------------------------------------------------------------------
;     152 // Interruption TWI
;     153 // ----------------------------------------------------------------------------------------------------------------------------
;     154 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     155 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     156 												// __interrupt void TWI_ISR(void)
;     157   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     158   
;     159   switch (TWSR)
	IN   R30,0x1
;     160   {
;     161     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x84
;     162     
;     163     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x85
_0x84:
;     164       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     165       				
;     166     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x86
_0x85:
	CPI  R30,LOW(0x18)
	BRNE _0x87
_0x86:
;     167     
;     168     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x88
_0x87:
	CPI  R30,LOW(0x28)
	BRNE _0x89
_0x88:
;     169       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x8A
;     170       {
;     171         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x8
	LD   R30,Z
	OUT  0x3,R30
;     172         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x1FE
;     173         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     174                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     175                						  			// (0<<TWWC); 
;     176       }
;     177       else                    					// Send STOP after last byte
_0x8A:
;     178       {
;     179         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x9
;     180          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     181         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x1FE:
	OUT  0x36,R30
;     182         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     183                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     184                                				  	// (0<<TWWC);
;     185       }
;     186     break;
	RJMP _0x82
;     187       
;     188     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x89:
	CPI  R30,LOW(0x50)
	BRNE _0x8C
;     189       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x8
	MOVW R26,R30
	RCALL SUBOPT_0xA
;     190       
;     191     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x8D
_0x8C:
	CPI  R30,LOW(0x40)
	BRNE _0x8E
_0x8D:
;     192       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x8F
;     193       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     194         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x1FF
;     195         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     196                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     197                                   				// (0<<TWWC);  
;     198       } else                    				// Send NACK after next reception
_0x8F:
;     199       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     200         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x1FF:
	OUT  0x36,R30
;     201         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     202                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     203                                 			  	// (0<<TWWC); 
;     204       }    
;     205     break; 
	RJMP _0x82
;     206       
;     207     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x8E:
	CPI  R30,LOW(0x58)
	BRNE _0x91
;     208       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0xA
;     209       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x9
;     210       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     211       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x200
;     212                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     213                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     214                               					// (0<<TWWC); 
;     215     break;  
;     216           
;     217     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x91:
	CPI  R30,LOW(0x38)
	BRNE _0x92
;     218     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     219       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x200
;     220                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     221                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     222                               					// (0<<TWWC);
;     223     break;
;     224       
;     225     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x92:
	CPI  R30,LOW(0x20)
	BREQ _0x94
;     226     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x95
_0x94:
;     227     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0x96
_0x95:
	CPI  R30,LOW(0x30)
	BRNE _0x97
_0x96:
;     228 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     229     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0x98
_0x97:
	CPI  R30,0
	BRNE _0x9A
_0x98:
;     230     
;     231     default:     
_0x9A:
;     232       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     233       											// Reset TWI Interface
;     234                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     235       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x200:
	OUT  0x36,R30
;     236                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     237                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     238                               					// (0<<TWWC);
;     239   }
_0x82:
;     240 } 
	RCALL __LOADISR
	RETI
;     241 
;     242 										// A remplacer par une bibliothque ! 
;     243 // Dclarations divers
;     244 // -----------------------------------------------------------------------------------------------------------------------------
;     245 #define	Moteur1			0
;     246 #define	Moteur2			1   
;     247 #define Empty			0
;     248 // =============================================================================================================================   
;     249 
;     250 // =============================================================================================================================
;     251 // =============================================================================================================================
;     252 // Constantes en flash
;     253 // -----------------------------------------------------------------------------------------------------------------------------
;     254 // Structure pour l'affichage du nom des registres  (A terminer)
;     255 //flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
;     256 // -----------------------------------------------------------------------------------------------------------------------------
;     257 // Messages textuels prdfinis
;     258 // ATTENTION: imprativement 16 caractres 
;     259 // ----------------------------------------------------------------------------------------------------------------------------- 
;     260 flash char *Texte_Accueil_Ligne1 	= "   PPE Robsol   ";

	.DSEG
_Texte_Accueil_Ligne1:
	.BYTE 0x2
;     261 flash char *Texte_Accueil_Ligne2 	= "   TWI4BSOL.c   ";
_Texte_Accueil_Ligne2:
	.BYTE 0x2
;     262 flash char *Ligne0MenuMode			= "1  Menu Mode    ";
_Ligne0MenuMode:
	.BYTE 0x2
;     263 flash char *Ligne0MenuInfos			= "2  Menu Infos   ";
_Ligne0MenuInfos:
	.BYTE 0x2
;     264 flash char *Ligne0MenuBoussole		= "3 Menu Boussole ";
_Ligne0MenuBoussole:
	.BYTE 0x2
;     265 flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
_Ligne1PlusMoins:
	.BYTE 0x2
;     266 flash char *Ligne1ChoixEntr			= "[Entr]          ";
_Ligne1ChoixEntr:
	.BYTE 0x2
;     267 flash char *Ligne1ChoixEchap		= "        [Echap] ";
_Ligne1ChoixEchap:
	.BYTE 0x2
;     268 flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
_Ligne1ChoixEchapOk:
	.BYTE 0x2
;     269 // =============================================================================================================================
;     270 
;     271 // =============================================================================================================================
;     272 // =============================================================================================================================
;     273 // Prototypes des fonctions en cours de test
;     274 // ----------------------------------------------------------------------------------------------------------------------------- 
;     275 // ============================================================================================================================= 
;     276 
;     277 // ============================================================================================================================= 
;     278 // =============================================================================================================================
;     279 // ---------------------------------------------- Declare your global variables here -------------------------------------------
;     280 // -----------------------------------------------------------------------------------------------------------------------------
;     281 // Type				Nom														Description  
;     282 // ----------------------------------------------------------------------------------------------------------------------------- 
;     283 // Etats du graphe des transitions "Menus"
;     284 // -----------------------------------------------------------------------------------------------------------------------------
;     285 enum TMenu {Choix_Menu_Mode, Choix_Menu_Infos, Choix_Mode_MD23, Choix_Menu_Boussole, Reglage_Mode0_MD23, Reglage_Mode1_MD23,  
;     286 Reglage_Mode2_MD23,Reglage_Mode3_MD23, Controle_Moteurs, Info_Batt, Info_Vers, Info_All, Menu_Boussole} Menu=Choix_Menu_Mode, 
;     287 Menu_1=Choix_Mode_MD23;
;     288 // -----------------------------------------------------------------------------------------------------------------------------					
;     289 bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0 
;     290 // =============================================================================================================================
;     291 
;     292 
;     293 // =============================================================================================================================
;     294 // =============================================================================================================================
;     295 // Partie excutive du programme 
;     296 // =============================================================================================================================
;     297 // =============================================================================================================================
;     298 void main(void)
;     299 {

	.CSEG
_main:
;     300 // =============================================================================================================================
;     301 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     302 // =============================================================================================================================
;     303 // Messages pour les composants I2C 
;     304 // =============================================================================================================================
;     305 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
;     306 // ----------------------------------------------------------------------------------------------------------------------------- 
;     307 // Type 	   		Nom 				       						Description 
;     308 // ----------------------------------------------------------------------------------------------------------------------------- 
;     309 unsigned char Frame_I2C_LED_All_Off[]={Add_LED_I2C,0xff}; 		// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
;     310 unsigned char Frame_I2C_LED_Switching[]={Add_LED_I2C,0x00}; 	// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
;     311 																// or Off=1}. Initialisation = All On.
;     312 unsigned char Frame_I2C_BP_Read[]={Add_BP_I2C,0x00}; 			// Trame de lecture des BP {SLA+R=0x43, Data=Nul}      
;     313 // ============================================================================================================================= 
;     314 // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
;     315 // ----------------------------------------------------------------------------------------------------------------------------- 
;     316 // Type 	   		Nom 				       						Description 
;     317 // ----------------------------------------------------------------------------------------------------------------------------- 
;     318 //unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
;     319 unsigned char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	// Trame de texte compose de: {SLA+W=0x76, cde=write to DDRAM ,  
;     320 						 	     								// le texte  afficher = 16 caractres max,  Nul }                  
;     321                                                             	// Cette trame est remplie avec le tableau String_to_LCD
;     322 // =============================================================================================================================
;     323 // 3) Liste de messages prdfinis pour la carte MD23 
;     324 // ============================================================================================================================= 
;     325 // 30) Initialisation
;     326 unsigned char Reset_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur};
;     327 
;     328 // 31) Mode
;     329 unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};
;     330 
;     331 // 32) Vitesse des moteurs 
;     332 unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur dans le mode 0
;     333 unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur dans le mode 0
;     334 unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs}; 
;     335 
;     336 // 33) Lecture des registres
;     337 unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		// Premire trame  envoyer { SLA_W=0xB0, N registre o commence
;     338 															// la lecture } 
;     339 // =============================================================================================================================
;     340 // 4) Liste des messages prdfinis pour la boussole HMC6352
;     341 // =============================================================================================================================
;     342 // Lecture de la direction (comprise entre 0 et 3599, code sur deux octets)
;     343 unsigned char Frame_I2C_W_Cde_HMC6352[] = {NEW_HMC6352_SLA_W,'A'}; 
;     344 unsigned char Frame_I2C_Read_Data_HMC6352[] = {NEW_HMC6352_SLA_R,Empty,Empty};  
;     345 // =============================================================================================================================
;     346 // Variables diverses
;     347 // ----------------------------------------------------------------------------------------------------------------------------- 
;     348 // Type 		Nom 				       Description 
;     349 // -----------------------------------------------------------------------------------------------------------------------------    
;     350 // 1) Gestion de la carte MD23
;     351 // -----------------------------------------------------------------------------------------------------------------------------
;     352 // Variables utilises dans la gestion de l'affichage:  limitent son rafrachissement
;     353 int Num_Reg_MD23_1=0, Num_Reg_MD23=0;                        // Numro du registre slectionn pour l'affichage   
;     354 unsigned char Vitesse_MD23_1, Vitesse_MD23, BP_I2C=0, Finesse_1=1, Finesse=1; 
;     355 unsigned char SpeedMot1, SpeedMot1_1, SpeedMot2, SpeedMot2_1; // Limite le rafrachissement de l'affichage
;     356 unsigned char Choix_Mode_1=1, Choix_Mode=0;                                                   		
;     357 unsigned char Ubatt_1=0, Ubatt=0;							// Tension alimentation carte MD23 
;     358 unsigned char Version_1=0, Version=0; 
;     359 // 2) Boussole HMC6352
;     360 unsigned char Direction_MSB, Direction_MSB_1, Direction_LSB, Direction_LSB_1; 
;     361 int Direction;
;     362 // -----------------------------------------------------------------------------------------------------------------------------
;     363 															// Reoit le contenu des registres de la carte MD23. Liste ci-dessous
;     364 //Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev, AccRate, Mode, Cde
;     365 unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
;     366 
;     367 // 2) Gestion du LCD BATRON
;     368 // -----------------------------------------------------------------------------------------------------------------------------
;     369  char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];     // Reoivent les deux lignes de texte  envoyer  l'afficheur
;     370 															// (16 caractres max. + Nul)
;     371 // -----------------------------------------------------------------------------------------------------------------------------
;     372 // *****************************************************************************************************************************
;     373 
;     374 // =============================================================================================================================
;     375 // ===================================================== Initialisations =======================================================
;     376 // =============================================================================================================================
;     377 TWI_Master_Initialise(); 									// Initialisation de l'interface TWI en mode Standby 
	SBIW R28,63
	SBIW R28,55
	LDI  R24,84
	LDI  R26,LOW(34)
	LDI  R27,HIGH(34)
	LDI  R30,LOW(_0x9C*2)
	LDI  R31,HIGH(_0x9C*2)
	RCALL __INITLOCB
;	Frame_I2C_LED_All_Off -> Y+116
;	Frame_I2C_LED_Switching -> Y+114
;	Frame_I2C_BP_Read -> Y+112
;	Frame_I2C_Lcd_Line -> Y+93
;	Reset_MD23 -> Y+90
;	Mode0_MD23 -> Y+87
;	Speed1 -> Y+84
;	Speed2 -> Y+81
;	Time_OUT_Desable -> Y+78
;	Read_Reg_MD23_W -> Y+76
;	Frame_I2C_W_Cde_HMC6352 -> Y+74
;	Frame_I2C_Read_Data_HMC6352 -> Y+71
;	Num_Reg_MD23_1 -> R16,R17
;	Num_Reg_MD23 -> R18,R19
;	Vitesse_MD23_1 -> R20
;	Vitesse_MD23 -> R21
;	BP_I2C -> Y+70
;	Finesse_1 -> Y+69
;	Finesse -> Y+68
;	SpeedMot1 -> Y+67
;	SpeedMot1_1 -> Y+66
;	SpeedMot2 -> Y+65
;	SpeedMot2_1 -> Y+64
;	Choix_Mode_1 -> Y+63
;	Choix_Mode -> Y+62
;	Ubatt_1 -> Y+61
;	Ubatt -> Y+60
;	Version_1 -> Y+59
;	Version -> Y+58
;	Direction_MSB -> Y+57
;	Direction_MSB_1 -> Y+56
;	Direction_LSB -> Y+55
;	Direction_LSB_1 -> Y+54
;	Direction -> Y+52
;	Table_Registers_MD23 -> Y+34
;	Buffer_for_LCD_Line0 -> Y+17
;	Buffer_for_LCD_Line1 -> Y+0
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	RCALL _TWI_Master_Initialise
;     378 // -----------------------------------------------------------------------------------------------------------------------------
;     379 // Global enable interrupts
;     380 #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI				
	sei
;     381 // -----------------------------------------------------------------------------------------------------------------------------
;     382 TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte S_ISI 	
	MOVW R30,R28
	SUBI R30,LOW(-(116))
	SBCI R31,HIGH(-(116))
	RCALL SUBOPT_0xB
;     383 // -----------------------------------------------------------------------------------------------------------------------------
;     384 // -----------------------------------------------------------------------------------------------------------------------------
;     385 // Initialisation de l'afficheur I2C BATRON 
;     386 // -----------------------------------------------------------------------------------------------------------------------------
;     387 Init_LCD_I2C_BATRON();
	RCALL _Init_LCD_I2C_BATRON
;     388 // -----------------------------------------------------------------------------------------------------------------------------
;     389 // Affichage d'un message d'accueil
;     390 // -----------------------------------------------------------------------------------------------------------------------------
;     391 sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	RCALL SUBOPT_0xC
	LDS  R30,_Texte_Accueil_Ligne1
	LDS  R31,_Texte_Accueil_Ligne1+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     392 sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	RCALL SUBOPT_0xE
	LDS  R30,_Texte_Accueil_Ligne2
	LDS  R31,_Texte_Accueil_Ligne2+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     393 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     394 delay_ms(4000); 
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x10
;     395 // -----------------------------------------------------------------------------------------------------------------------------
;     396 // Initialisation des registres de  la carte MD23
;     397 // -----------------------------------------------------------------------------------------------------------------------------
;     398 TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));			
	MOVW R30,R28
	SUBI R30,LOW(-(90))
	SBCI R31,HIGH(-(90))
	RCALL SUBOPT_0x11
;     399 TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
	MOVW R30,R28
	SUBI R30,LOW(-(78))
	SBCI R31,HIGH(-(78))
	RCALL SUBOPT_0x11
;     400 TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(87))
	SBCI R31,HIGH(-(87))
	RCALL SUBOPT_0x11
;     401 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	RCALL SUBOPT_0x12
;     402 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));  
	RCALL SUBOPT_0x13
;     403 
;     404 // =============================================================================================================================
;     405 // ================================================ Boucle principale ==========================================================
;     406 // =============================================================================================================================
;     407 while (1)
_0x9D:
;     408       { 
;     409 // ---------------------------------------------  Champ Lecture des donnes ---------------------------------------------------- 
;     410 // Lecture de l'tat des BP
;     411 // ---------------------------------------------------------------------------------------------------------------------------- 
;     412 // Lecture des BP pour affichage sur les LED
;     413 	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));    // Envoi de l'octet d'adresse des BP: SLA+R=0x43 
	MOVW R30,R28
	SUBI R30,LOW(-(112))
	SBCI R31,HIGH(-(112))
	RCALL SUBOPT_0xB
;     414 																		// Rcupration de l'octet reprsentatif de l'tat des BP	
;     415 	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read)); 
	MOVW R30,R28
	SUBI R30,LOW(-(112))
	SBCI R31,HIGH(-(112))
	RCALL SUBOPT_0x14
;     416 	
;     417     BP_I2C = Lire_BP_I2C();														// Lecture des BP avec gestion anti-rebond
	RCALL _Lire_BP_I2C
	__PUTB1SX 70
;     418 // ----------------------------------------------------------------------------------------------------------------------------    
;     419 // Lecture des registres de la carte MD23 
;     420 /*
;     421    if (Menu != Reglage_Mode0_MD23)
;     422    {                                                           // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
;     423 	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W)); 
;     424    	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture  
;     425 	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));  
;     426    }
;     427 */
;     428 // ---------------------------------------------------------------------------------------------------------------------------- 
;     429 // Prparation de l'opration de lecture des donnes: Ecriture de la commande 'A' 
;     430 TWI_Start_Transc_With_Data(Frame_I2C_W_Cde_HMC6352, sizeof(Frame_I2C_W_Cde_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	RCALL SUBOPT_0xB
;     431 // Lecture des donnes de la boussole
;     432 TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	RCALL SUBOPT_0x11
;     433 TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x15
	RCALL _TWI_Get_Data_From_Transceiver
;     434 	
;     435 // --------------------------------------------------- Champ Traitement--------------------------------------------------------  
;     436     switch(Menu)
	MOV  R30,R5
;     437     {// Dbut du switch1 
;     438 // -------------------------------------Dbut Menus droulants----------------------------------------------------------------- 
;     439 // Menus Niveau 1 -------------------------------------------------------------------------------------------------------------
;     440 // ----------------------------------------------------------------------------------------------------------------------------
;     441 		case Choix_Menu_Mode : if (Menu_1 != Menu)
	CPI  R30,0
	BRNE _0xA3
	CP   R5,R6
	BREQ _0xA4
;     442 			{ 
;     443 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuMode
	LDS  R31,_Ligne0MenuMode+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     444 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     445 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     446 				LCD_I2C_BATRON_gotoxy(0,15); 						 	     
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RCALL _LCD_I2C_BATRON_gotoxy
;     447 				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0)); 
	MOVW R30,R28
	SUBI R30,LOW(-(93))
	SBCI R31,HIGH(-(93))
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     448 				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line)); 
	MOVW R30,R28
	SUBI R30,LOW(-(93))
	SBCI R31,HIGH(-(93))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(95))
	SBCI R31,HIGH(-(95))
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1B
;     449 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     450 			}
;     451      			     	
;     452 			switch (BP_I2C)
_0xA4:
	RCALL SUBOPT_0x1C
;     453 				{                                  
;     454 					case ENTR_I2C: Menu = Choix_Mode_MD23;  break; // touche Enter
	BRNE _0xA8
	RCALL SUBOPT_0x1D
	RJMP _0xA7
;     455 					case FlecheH_I2C: Menu = Choix_Menu_Boussole;  break; // touche flche haut
_0xA8:
	CPI  R30,LOW(0x2)
	BRNE _0xA9
	LDI  R30,LOW(3)
	MOV  R5,R30
	RJMP _0xA7
;     456 					case FlecheB_I2C: Menu = Choix_Menu_Infos;  break; // touche flche bas 
_0xA9:
	CPI  R30,LOW(0x4)
	BRNE _0xAB
	LDI  R30,LOW(1)
	MOV  R5,R30
	RJMP _0xA7
;     457 					default: Menu = Choix_Menu_Mode ;
_0xAB:
	CLR  R5
;     458 				} 
_0xA7:
;     459      			      
;     460 			Menu_1 = Choix_Menu_Mode ;
	CLR  R6
;     461 		break;
	RJMP _0xA2
;     462 // ----------------------------------------------------------------------------------------------------------------------------     
;     463 		case Choix_Menu_Infos: if (Menu_1 != Menu)
_0xA3:
	CPI  R30,LOW(0x1)
	BRNE _0xAC
	CP   R5,R6
	BREQ _0xAD
;     464 			{ 
;     465 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuInfos
	LDS  R31,_Ligne0MenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     466 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     467 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     468 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     469 			}
;     470      			     	
;     471 			switch (BP_I2C)
_0xAD:
	RCALL SUBOPT_0x1C
;     472 				{                                  
;     473 					case ENTR_I2C: Menu = Info_All;  break; 
	BRNE _0xB1
	LDI  R30,LOW(11)
	RJMP _0x201
;     474 					case FlecheH_I2C: Menu = Choix_Menu_Mode;  break; 
_0xB1:
	CPI  R30,LOW(0x2)
	BRNE _0xB2
	CLR  R5
	RJMP _0xB0
;     475 					case FlecheB_I2C: Menu = Choix_Menu_Boussole;  break;  
_0xB2:
	CPI  R30,LOW(0x4)
	BRNE _0xB4
	LDI  R30,LOW(3)
	RJMP _0x201
;     476 					default: Menu = Choix_Menu_Infos ;
_0xB4:
	LDI  R30,LOW(1)
_0x201:
	MOV  R5,R30
;     477 				}  
_0xB0:
;     478      			      
;     479 			Menu_1 = Choix_Menu_Infos ;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     480 		break; 
	RJMP _0xA2
;     481 // ---------------------------------------------------------------------------------------------------------------------------- 		
;     482 		case Choix_Menu_Boussole: if (Menu_1 != Menu)
_0xAC:
	CPI  R30,LOW(0x3)
	BRNE _0xB5
	CP   R5,R6
	BREQ _0xB6
;     483 			{ 
;     484 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuBoussole);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuBoussole
	LDS  R31,_Ligne0MenuBoussole+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     485 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     486 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     487 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     488 			}
;     489      			     	
;     490 			switch (BP_I2C)
_0xB6:
	RCALL SUBOPT_0x1C
;     491 				{                                  
;     492 					case ENTR_I2C: Menu = Menu_Boussole;  break; 
	BRNE _0xBA
	LDI  R30,LOW(12)
	RJMP _0x202
;     493 					case FlecheH_I2C: Menu = Choix_Menu_Infos;  break; 
_0xBA:
	CPI  R30,LOW(0x2)
	BRNE _0xBB
	LDI  R30,LOW(1)
	RJMP _0x202
;     494 					case FlecheB_I2C: Menu = Choix_Menu_Mode;  break;  
_0xBB:
	CPI  R30,LOW(0x4)
	BRNE _0xBD
	CLR  R5
	RJMP _0xB9
;     495 					default: Menu = Choix_Menu_Boussole ;
_0xBD:
	LDI  R30,LOW(3)
_0x202:
	MOV  R5,R30
;     496 				}  
_0xB9:
;     497      			      
;     498 			Menu_1 = Choix_Menu_Boussole ;
	LDI  R30,LOW(3)
	MOV  R6,R30
;     499 		break; 
	RJMP _0xA2
;     500 // ----------------------------------------------------------------------------------------------------------------------------
;     501 // Menus Niveau 2 -------------------------------------------------------------------------------------------------------------
;     502 // ----------------------------------------------------------------------------------------------------------------------------     
;     503 	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
_0xB5:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0xBE
	CP   R5,R6
	BRNE _0xC0
	LDD  R30,Y+62
	LDD  R26,Y+63
	CP   R30,R26
	BREQ _0xBF
_0xC0:
;     504 	          {
;     505 	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,0
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1F
	LDI  R24,4
	RCALL SUBOPT_0x20
;     506 	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     507 	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     508 	        	 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     509 	        	 Choix_Mode_1 = Choix_Mode;
	LDD  R30,Y+62
	STD  Y+63,R30
;     510 	          }  
;     511 	          
;     512 	          switch (BP_I2C)
_0xBF:
	RCALL SUBOPT_0x21
;     513 				{
;     514 					case ECHAP_I2C : Menu=Choix_Menu_Mode; break;  // touche ECHAP
	BRNE _0xC5
	CLR  R5
	RJMP _0xC4
;     515 					case FlecheH_I2C: if (Choix_Mode < 3) Choix_Mode = Choix_Mode + 1; else Choix_Mode=0;  break; // touche +
_0xC5:
	CPI  R30,LOW(0x2)
	BRNE _0xC6
	LDD  R26,Y+62
	CPI  R26,LOW(0x3)
	BRSH _0xC7
	LDD  R30,Y+62
	SUBI R30,-LOW(1)
	RJMP _0x203
_0xC7:
	CLR  R30
_0x203:
	STD  Y+62,R30
	RJMP _0xC4
;     516 					case FlecheB_I2C: if (Choix_Mode > 0) Choix_Mode = Choix_Mode - 1; else Choix_Mode=3;  break; // touche -
_0xC6:
	CPI  R30,LOW(0x4)
	BRNE _0xC9
	LDD  R26,Y+62
	RCALL SUBOPT_0x22
	BRSH _0xCA
	LDD  R30,Y+62
	SUBI R30,LOW(1)
	RJMP _0x204
_0xCA:
	LDI  R30,LOW(3)
_0x204:
	STD  Y+62,R30
	RJMP _0xC4
;     517 					case ENTR_I2C: if (Choix_Mode == 0) {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Mode0_MD23;};	break; 
_0xC9:
	CPI  R30,LOW(0x40)
	BRNE _0xCE
	LDD  R30,Y+62
	CPI  R30,0
	BRNE _0xCD
	LDI  R30,LOW(128)
	__PUTB1SX 67
	__PUTB1SX 65
	LDI  R30,LOW(4)
	MOV  R5,R30
_0xCD:
	RJMP _0xC4
;     518 					 
;     519 					default: Menu=Choix_Mode_MD23;
_0xCE:
	RCALL SUBOPT_0x1D
;     520 				}  
_0xC4:
;     521        		 	
;     522 			  Menu_1 = Choix_Mode_MD23;
	LDI  R30,LOW(2)
	MOV  R6,R30
;     523 	        break;
	RJMP _0xA2
;     524 // ----------------------------------------------------------------------------------------------------------------------------
;     525             case Reglage_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
_0xBE:
	CPI  R30,LOW(0x4)
	BREQ PC+2
	RJMP _0xCF
	CP   R5,R6
	BRNE _0xD1
	__GETB1SX 67
	__GETB2SX 66
	CP   R30,R26
	BRNE _0xD1
	__GETB1SX 65
	__GETB2SX 64
	CP   R30,R26
	BRNE _0xD1
	__GETB1SX 68
	__GETB2SX 69
	CP   R30,R26
	BRNE _0xD1
	RJMP _0xD0
_0xD1:
;     526               {
;     527                 sprintf(Buffer_for_LCD_Line0,"1.%-u Mode%-u (+%-u)  ",Choix_Mode+1,Choix_Mode,Finesse);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,19
	RCALL SUBOPT_0x1E
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x1F
	__GETB1SX 70
	RCALL SUBOPT_0x1F
	__GETB1SX 80
	RCALL SUBOPT_0x1F
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     528                 sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
	RCALL SUBOPT_0xE
	__POINTW1FN _155,42
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 71
	RCALL SUBOPT_0x1F
	__GETB1SX 73
	RCALL SUBOPT_0x1F
	LDI  R24,8
	RCALL SUBOPT_0x23
;     529                 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     530                 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     531                 SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
	__GETB1SX 67
	__PUTB1SX 66
	__GETB1SX 65
	__PUTB1SX 64
	__GETB1SX 68
	__PUTB1SX 69
;     532               }
;     533               
;     534               
;     535               switch (BP_I2C)
_0xD0:
	RCALL SUBOPT_0x21
;     536 				{
;     537 				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;  
	BRNE _0xD6
	LDI  R30,LOW(2)
	RJMP _0x205
;     538 				 	
;     539 				 	case PLUS_I2C:  
_0xD6:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0xD7
;     540 				 		switch (Choix_Moteur)
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     541 				 		  { 
;     542 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0xDB
	RCALL SUBOPT_0x24
	BRNE _0xDC
;     543 				 		   					if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
	__GETB2SX 67
	CPI  R26,LOW(0xFF)
	BRSH _0xDD
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	RJMP _0xDE
_0xDD:
	LDI  R30,LOW(255)
	__PUTB1SX 67
_0xDE:
;     544 				 		   			else    
	RJMP _0xDF
_0xDC:
;     545 				 		   					if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
	__GETB2SX 67
	CPI  R26,LOW(0xFA)
	BRSH _0xE0
	__GETB1SX 67
	SUBI R30,-LOW(5)
	RJMP _0x206
_0xE0:
	LDI  R30,LOW(255)
_0x206:
	__PUTB1SX 67
_0xDF:
;     546 				 		   	break;
	RJMP _0xDA
;     547 				 		   	case Moteur2: if (Finesse==1)
_0xDB:
	CPI  R30,LOW(0x1)
	BRNE _0xDA
	RCALL SUBOPT_0x24
	BRNE _0xE3
;     548 				 		   					if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
	__GETB2SX 65
	CPI  R26,LOW(0xFF)
	BRSH _0xE4
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x26
	RJMP _0xE5
_0xE4:
	LDI  R30,LOW(255)
	__PUTB1SX 65
_0xE5:
;     549 				 		   			else    
	RJMP _0xE6
_0xE3:
;     550 				 		   					if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
	__GETB2SX 65
	CPI  R26,LOW(0xFA)
	BRSH _0xE7
	__GETB1SX 65
	SUBI R30,-LOW(5)
	RJMP _0x207
_0xE7:
	LDI  R30,LOW(255)
_0x207:
	__PUTB1SX 65
_0xE6:
;     551 				 		   	break;
;     552 				 		  }
_0xDA:
;     553 				 	break;
	RJMP _0xD5
;     554 				 	case MOINS_I2C:   
_0xD7:
	CPI  R30,LOW(0x8)
	BREQ PC+2
	RJMP _0xE9
;     555 				 	    switch (Choix_Moteur)
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     556 				 		  { 
;     557 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0xED
	RCALL SUBOPT_0x24
	BRNE _0xEE
;     558 				 		   					if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
	__GETB2SX 67
	RCALL SUBOPT_0x22
	BRSH _0xEF
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x28
	RJMP _0xF0
_0xEF:
	CLR  R30
	__PUTB1SX 67
_0xF0:
;     559 				 		   			else    
	RJMP _0xF1
_0xEE:
;     560 				 		   					if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0; 
	__GETB2SX 67
	RCALL SUBOPT_0x29
	BRSH _0xF2
	__GETB1SX 67
	SUBI R30,LOW(5)
	RJMP _0x208
_0xF2:
	CLR  R30
_0x208:
	__PUTB1SX 67
_0xF1:
;     561 				 		   	break;
	RJMP _0xEC
;     562 				 		   	case Moteur2: if (Finesse==1)
_0xED:
	CPI  R30,LOW(0x1)
	BRNE _0xEC
	RCALL SUBOPT_0x24
	BRNE _0xF5
;     563 				 		   					if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
	__GETB2SX 65
	RCALL SUBOPT_0x22
	BRSH _0xF6
	RCALL SUBOPT_0x27
	RCALL SUBOPT_0x28
	RJMP _0xF7
_0xF6:
	CLR  R30
	__PUTB1SX 65
_0xF7:
;     564 				 		   			else    
	RJMP _0xF8
_0xF5:
;     565 				 		   					if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
	__GETB2SX 65
	RCALL SUBOPT_0x29
	BRSH _0xF9
	__GETB1SX 65
	SUBI R30,LOW(5)
	RJMP _0x209
_0xF9:
	CLR  R30
_0x209:
	__PUTB1SX 65
_0xF8:
;     566 				 			break;
;     567 				 		  }
_0xEC:
;     568 				 	break;
	RJMP _0xD5
;     569 				 	
;     570 				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1;
_0xE9:
	CPI  R30,LOW(0x2)
	BRNE _0xFB
	RCALL SUBOPT_0x24
	BRNE _0xFC
	LDI  R30,LOW(5)
	RJMP _0x20A
_0xFC:
	LDI  R30,LOW(1)
_0x20A:
	__PUTB1SX 68
;     571 				 	break; 
	RJMP _0xD5
;     572 				 	
;     573 				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; 
_0xFB:
	CPI  R30,LOW(0x4)
	BRNE _0xFE
	RCALL SUBOPT_0x24
	BRNE _0xFF
	LDI  R30,LOW(5)
	RJMP _0x20B
_0xFF:
	LDI  R30,LOW(1)
_0x20B:
	__PUTB1SX 68
;     574 				 	break; 
	RJMP _0xD5
;     575 				 	
;     576 				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; 
_0xFE:
	CPI  R30,LOW(0x20)
	BRNE _0x101
	SBRS R2,0
	RJMP _0x102
	CLT
	BLD  R2,0
	RJMP _0x103
_0x102:
	SET
	BLD  R2,0
_0x103:
;     577 				 	break; 
	RJMP _0xD5
;     578 				 	
;     579 				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2; 
_0x101:
	CPI  R30,LOW(0x10)
	BRNE _0x105
	__GETB1SX 67
	__PUTB1SX 86
	__GETB1SX 65
	__PUTB1SX 83
;     580 				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	RCALL SUBOPT_0x12
;     581 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
	RCALL SUBOPT_0x13
;     582 				    break;
	RJMP _0xD5
;     583 				     
;     584 					default: Menu = Reglage_Mode0_MD23;
_0x105:
	LDI  R30,LOW(4)
_0x205:
	MOV  R5,R30
;     585 				}  
_0xD5:
;     586 			  Menu_1 = Reglage_Mode0_MD23;   
	LDI  R30,LOW(4)
	MOV  R6,R30
;     587 			break;
	RJMP _0xA2
;     588 // ----------------------------------------------------------------------------------------------------------------------------	        
;     589 		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];  
_0xCF:
	CPI  R30,LOW(0xB)
	BREQ PC+2
	RJMP _0x106
	LDD  R21,Y+40
;     590 			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23)) 
	CP   R5,R6
	BRNE _0x108
	__CPWRR 18,19,16,17
	BRNE _0x108
	CP   R21,R20
	BREQ _0x107
_0x108:
;     591 			  {	
;     592 				sprintf(Buffer_for_LCD_Line0,"2.1 Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;   
	RCALL SUBOPT_0xC
	__POINTW1FN _155,58
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 18,19
	RCALL __CWD1
	RCALL __PUTPARD1
	__GETW1R 18,19
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,42
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x1F
	LDI  R24,8
	RCALL SUBOPT_0x23
;     593 				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
	RCALL SUBOPT_0xE
	LDS  R30,_Ligne1PlusMoins
	LDS  R31,_Ligne1PlusMoins+1
	RCALL SUBOPT_0x2A
;     594 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     595 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     596 				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
	__MOVEWRR 16,17,18,19
	MOV  R20,R21
;     597 			  }	
;     598        		              
;     599 			switch (BP_I2C)
_0x107:
	RCALL SUBOPT_0x21
;     600 				{
;     601 					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
	BRNE _0x10D
	LDI  R30,LOW(1)
	RJMP _0x20C
;     602 					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break; 
_0x10D:
	CPI  R30,LOW(0x1)
	BRNE _0x10E
	__CPWRN 18,19,16
	BRGE _0x10F
	__ADDWRN 18,19,1
	RJMP _0x110
_0x10F:
	__GETWRN 18,19,0
_0x110:
	RJMP _0x10C
;     603 					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break; 
_0x10E:
	CPI  R30,LOW(0x8)
	BRNE _0x111
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x112
	__SUBWRN 18,19,1
	RJMP _0x113
_0x112:
	__GETWRN 18,19,16
_0x113:
	RJMP _0x10C
;     604 					case FlecheH_I2C: Menu = Info_Batt;  break; 
_0x111:
	CPI  R30,LOW(0x2)
	BRNE _0x114
	LDI  R30,LOW(9)
	RJMP _0x20C
;     605 					case FlecheB_I2C: Menu = Info_Vers;  break; 
_0x114:
	CPI  R30,LOW(0x4)
	BRNE _0x116
	LDI  R30,LOW(10)
	RJMP _0x20C
;     606 					default: Menu=Info_All;
_0x116:
	LDI  R30,LOW(11)
_0x20C:
	MOV  R5,R30
;     607 				}  
_0x10C:
;     608        		 	
;     609 			Menu_1 = Info_All;		   
	LDI  R30,LOW(11)
	MOV  R6,R30
;     610 		break;       
	RJMP _0xA2
;     611 // ----------------------------------------------------------------------------------------------------------------------------	        
;     612 		case Info_Vers:	Version = Table_Registers_MD23[14];  
_0x106:
	CPI  R30,LOW(0xA)
	BRNE _0x117
	LDD  R30,Y+48
	STD  Y+58,R30
;     613 			if ((Menu_1 != Menu)||(Version_1 != Version)) 
	CP   R5,R6
	BRNE _0x119
	LDD  R26,Y+59
	CP   R30,R26
	BREQ _0x118
_0x119:
;     614    			  {	
;     615 				sprintf(Buffer_for_LCD_Line0,"2.2 Version=%-u",Version);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,74
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+62
	RCALL SUBOPT_0x1F
	LDI  R24,4
	RCALL SUBOPT_0x20
;     616 				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0x2B
;     617 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     618 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     619 				Version_1 = Version;
	LDD  R30,Y+58
	STD  Y+59,R30
;     620 			  }	
;     621        		              
;     622 			switch (BP_I2C)
_0x118:
	RCALL SUBOPT_0x21
;     623 				{
;     624 					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
	BRNE _0x11E
	LDI  R30,LOW(1)
	RJMP _0x20D
;     625 					case FlecheH_I2C: Menu = Info_All;  break; 
_0x11E:
	CPI  R30,LOW(0x2)
	BRNE _0x11F
	LDI  R30,LOW(11)
	RJMP _0x20D
;     626 					case FlecheB_I2C: Menu = Info_Batt;  break; 
_0x11F:
	CPI  R30,LOW(0x4)
	BRNE _0x121
	LDI  R30,LOW(9)
	RJMP _0x20D
;     627 					default: Menu=Info_Vers;
_0x121:
	LDI  R30,LOW(10)
_0x20D:
	MOV  R5,R30
;     628 				}  
;     629        		 	
;     630 			Menu_1 = Info_Vers;		   
	LDI  R30,LOW(10)
	MOV  R6,R30
;     631 		break;     
	RJMP _0xA2
;     632 // ----------------------------------------------------------------------------------------------------------------------------       
;     633 		case Info_Batt:  	Ubatt = Table_Registers_MD23[11];  
_0x117:
	CPI  R30,LOW(0x9)
	BRNE _0x122
	LDD  R30,Y+45
	STD  Y+60,R30
;     634 			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt)) 
	CP   R5,R6
	BRNE _0x124
	LDD  R26,Y+61
	CP   R30,R26
	BREQ _0x123
_0x124:
;     635    			  {	
;     636 					sprintf(Buffer_for_LCD_Line0,"2.3 Ubatt=%-u.%-uV",Ubatt/10, Ubatt-10*(Ubatt/10));
	RCALL SUBOPT_0xC
	__POINTW1FN _155,90
	ST   -Y,R31
	ST   -Y,R30
	__GETB2SX 64
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x1F
	__GETB2SX 68
	RCALL SUBOPT_0x2C
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	__GETB2SX 68
	RCALL __SWAPB12
	SUB  R30,R26
	RCALL SUBOPT_0x1F
	LDI  R24,8
	RCALL SUBOPT_0x23
;     637 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x2B
;     638 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     639 					Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     640 					Ubatt_1 = Ubatt;
	LDD  R30,Y+60
	STD  Y+61,R30
;     641 			  }	
;     642        		              
;     643 			switch (BP_I2C)
_0x123:
	RCALL SUBOPT_0x21
;     644 				{
;     645 					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
	BRNE _0x129
	LDI  R30,LOW(1)
	RJMP _0x20E
;     646 					case FlecheH_I2C: Menu = Info_Vers;  break; 
_0x129:
	CPI  R30,LOW(0x2)
	BRNE _0x12A
	LDI  R30,LOW(10)
	RJMP _0x20E
;     647 					case FlecheB_I2C: Menu = Info_All;  break; 
_0x12A:
	CPI  R30,LOW(0x4)
	BRNE _0x12C
	LDI  R30,LOW(11)
	RJMP _0x20E
;     648 					default: Menu=Info_Batt;
_0x12C:
	LDI  R30,LOW(9)
_0x20E:
	MOV  R5,R30
;     649 				}  
;     650        		 	
;     651 			Menu_1 = Info_Batt;
	LDI  R30,LOW(9)
	MOV  R6,R30
;     652 		break;   
	RJMP _0xA2
;     653 // ----------------------------------------------------------------------------------------------------------------------------       
;     654 		case Menu_Boussole:  	Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];  
_0x122:
	CPI  R30,LOW(0xC)
	BRNE _0xA2
	__GETB1SX 72
	STD  Y+57,R30
	__GETB1SX 73
	STD  Y+55,R30
;     655 			if ((Menu_1 != Menu)||(Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB)) 
	CP   R5,R6
	BRNE _0x12F
	LDD  R30,Y+57
	LDD  R26,Y+56
	CP   R30,R26
	BRNE _0x12F
	LDD  R30,Y+55
	LDD  R26,Y+54
	CP   R30,R26
	BREQ _0x12E
_0x12F:
;     656    			  {	
;     657    			  		//Direction = (int)(255*Direction_MSB) + Direction_LSB;
;     658 					sprintf(Buffer_for_LCD_Line0,"M=%-x L=%-x",Direction_MSB,Direction_LSB);
	RCALL SUBOPT_0xC
	__POINTW1FN _155,109
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+61
	RCALL SUBOPT_0x1F
	LDD  R30,Y+63
	RCALL SUBOPT_0x1F
	LDI  R24,8
	RCALL SUBOPT_0x23
;     659 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x2B
;     660 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     661 					Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     662 					Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB;
	LDD  R30,Y+57
	STD  Y+56,R30
	LDD  R30,Y+55
	STD  Y+54,R30
;     663 					delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x10
;     664 			  }	
;     665        		              
;     666 			switch (BP_I2C)
_0x12E:
	RCALL SUBOPT_0x21
;     667 				{
;     668 					case ECHAP_I2C : Menu=Choix_Menu_Boussole; break;  
	BRNE _0x135
	LDI  R30,LOW(3)
	RJMP _0x20F
;     669 					//case FlecheH_I2C: Menu = Info_Vers;  break; 
;     670 					//case FlecheB_I2C: Menu = Info_All;  break; 
;     671 					default: Menu=Menu_Boussole;
_0x135:
	LDI  R30,LOW(12)
_0x20F:
	MOV  R5,R30
;     672 				}  
;     673        		 	
;     674 			Menu_1 = Menu_Boussole;
	LDI  R30,LOW(12)
	MOV  R6,R30
;     675 		break;   
;     676 			
;     677     }// Fin du switch1  
_0xA2:
;     678  // ----------------------------------------------------------------------------------------------------------------------------
;     679        
;     680     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];  
	MOVW R30,R28
	SUBI R30,LOW(-(114))
	SBCI R31,HIGH(-(114))
	ADIW R30,1
	PUSH R31
	PUSH R30
	__GETB1SX 113
	COM  R30
	POP  R26
	POP  R27
	ST   X,R30
;     681 // ----------------------------------------------------------------------------------------------------------------------------
;     682 // ----------------------------------------  Champ Ecriture des rsultats  ----------------------------------------------------
;     683 // Ecriture sur les LED                              	
;     684     //TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
;     685 // ----------------------------------------------------------------------------------------------------------------------------  
;     686  // delay_ms(100);   // A utiliser pour visualiser les trames I2C
;     687   }; // Fin while(1)
	RJMP _0x9D
;     688       
;     689 } //Fin main  
	ADIW R28,63
	ADIW R28,55
_0x136:
	RJMP _0x136
;     690 
;     691 
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x2D
	SBIW R30,0
	BREQ _0x16D
	RCALL SUBOPT_0x2D
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x16E
_0x16D:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x16E:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x170:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x172
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x176
	CPI  R19,37
	BRNE _0x177
	LDI  R16,LOW(1)
	RJMP _0x178
_0x177:
	RCALL SUBOPT_0x2E
_0x178:
	RJMP _0x175
_0x176:
	CPI  R30,LOW(0x1)
	BRNE _0x179
	CPI  R19,37
	BRNE _0x17A
	RCALL SUBOPT_0x2E
	LDI  R16,LOW(0)
	RJMP _0x175
_0x17A:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x17B
	LDI  R17,LOW(1)
	RJMP _0x175
_0x17B:
	CPI  R19,43
	BRNE _0x17C
	LDI  R21,LOW(43)
	RJMP _0x175
_0x17C:
	CPI  R19,32
	BRNE _0x17D
	LDI  R21,LOW(32)
	RJMP _0x175
_0x17D:
	RJMP _0x17E
_0x179:
	CPI  R30,LOW(0x2)
	BRNE _0x17F
_0x17E:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x180
	ORI  R17,LOW(128)
	RJMP _0x175
_0x180:
	RJMP _0x181
_0x17F:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x175
_0x181:
	CPI  R19,48
	BRLO _0x184
	CPI  R19,58
	BRLO _0x185
_0x184:
	RJMP _0x183
_0x185:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x175
_0x183:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x189
	RCALL SUBOPT_0x2F
	LD   R30,X
	RCALL SUBOPT_0x30
	RJMP _0x18A
_0x189:
	CPI  R30,LOW(0x73)
	BRNE _0x18C
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x19
	MOV  R16,R30
	RJMP _0x18D
_0x18C:
	CPI  R30,LOW(0x70)
	BRNE _0x18F
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x18D:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x190
_0x18F:
	CPI  R30,LOW(0x64)
	BREQ _0x193
	CPI  R30,LOW(0x69)
	BRNE _0x194
_0x193:
	ORI  R17,LOW(4)
	RJMP _0x195
_0x194:
	CPI  R30,LOW(0x75)
	BRNE _0x196
_0x195:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x197
_0x196:
	CPI  R30,LOW(0x58)
	BRNE _0x199
	ORI  R17,LOW(8)
	RJMP _0x19A
_0x199:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x1C8
_0x19A:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x197:
	SBRS R17,2
	RJMP _0x19C
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x32
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x19D
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x19D:
	CPI  R21,0
	BREQ _0x19E
	SUBI R16,-LOW(1)
	RJMP _0x19F
_0x19E:
	ANDI R17,LOW(251)
_0x19F:
	RJMP _0x1A0
_0x19C:
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x32
_0x1A0:
_0x190:
	SBRC R17,0
	RJMP _0x1A1
_0x1A2:
	CP   R16,R20
	BRSH _0x1A4
	SBRS R17,7
	RJMP _0x1A5
	SBRS R17,2
	RJMP _0x1A6
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x1A7
_0x1A6:
	LDI  R19,LOW(48)
_0x1A7:
	RJMP _0x1A8
_0x1A5:
	LDI  R19,LOW(32)
_0x1A8:
	RCALL SUBOPT_0x2E
	SUBI R20,LOW(1)
	RJMP _0x1A2
_0x1A4:
_0x1A1:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x1A9
_0x1AA:
	CPI  R18,0
	BREQ _0x1AC
	SBRS R17,3
	RJMP _0x1AD
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x210
_0x1AD:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x210:
	ST   -Y,R30
	RCALL SUBOPT_0x33
	CPI  R20,0
	BREQ _0x1AF
	SUBI R20,LOW(1)
_0x1AF:
	SUBI R18,LOW(1)
	RJMP _0x1AA
_0x1AC:
	RJMP _0x1B0
_0x1A9:
_0x1B2:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x1B4
	SBRS R17,3
	RJMP _0x1B5
	SUBI R19,-LOW(7)
	RJMP _0x1B6
_0x1B5:
	SUBI R19,-LOW(39)
_0x1B6:
_0x1B4:
	SBRC R17,4
	RJMP _0x1B8
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x1BA
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x1B9
_0x1BA:
	ORI  R17,LOW(16)
	RJMP _0x1BC
_0x1B9:
	CP   R20,R18
	BRLO _0x1BE
	SBRS R17,0
	RJMP _0x1BF
_0x1BE:
	RJMP _0x1BD
_0x1BF:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x1C0
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x1BC:
	SBRS R17,2
	RJMP _0x1C1
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x33
	CPI  R20,0
	BREQ _0x1C2
	SUBI R20,LOW(1)
_0x1C2:
_0x1C1:
_0x1C0:
_0x1B8:
	RCALL SUBOPT_0x2E
	CPI  R20,0
	BREQ _0x1C3
	SUBI R20,LOW(1)
_0x1C3:
_0x1BD:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x1B3
	RJMP _0x1B2
_0x1B3:
_0x1B0:
	SBRS R17,0
	RJMP _0x1C4
_0x1C5:
	CPI  R20,0
	BREQ _0x1C7
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x30
	RJMP _0x1C5
_0x1C7:
_0x1C4:
_0x1C8:
_0x18A:
	LDI  R16,LOW(0)
_0x175:
	RJMP _0x170
_0x172:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x34
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x34
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x35
	ADIW R28,4
	RET
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1D0*2)
	LDI  R31,HIGH(_0x1D0*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0xE
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x1B
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R24,3
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1D2*2)
	LDI  R31,HIGH(_0x1D2*2)
	RCALL __INITLOCB
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x1D4
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x1D5
_0x1D4:
	RJMP _0x1D3
_0x1D5:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x1D9
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	STD  Y+2,R30
	RJMP _0x1D8
_0x1D9:
	CPI  R30,LOW(0x1)
	BRNE _0x1D8
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
	STD  Y+2,R30
_0x1D8:
_0x1D3:
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x15
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	SBIW R28,4
	RCALL __SAVELOCR2
	LDD  R30,Y+8
	CLR  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+9
	SUBI R30,-LOW(2)
	CLR  R31
	STD  Y+2,R30
	STD  Y+2+1,R31
	__GETWRN 16,17,0
_0x1DD:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x1DE
	RCALL SUBOPT_0x36
	CPI  R26,LOW(0x5B)
	BRNE _0x1DF
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(138)
	ST   X,R30
	RJMP _0x1E0
_0x1DF:
	RCALL SUBOPT_0x36
	CPI  R26,LOW(0x5D)
	BRNE _0x1E1
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(84)
	RJMP _0x211
_0x1E1:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X
	SUBI R30,-LOW(128)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
_0x211:
	ST   X,R30
_0x1E0:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	__ADDWRN 16,17,1
	RJMP _0x1DD
_0x1DE:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0x35
	RCALL __LOADLOCR2
	ADIW R28,10
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,20
	LDI  R24,19
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1E4*2)
	LDI  R31,HIGH(_0x1E4*2)
	RCALL __INITLOCB
	CLR  R30
	STD  Y+19,R30
_0x1E6:
	LDD  R26,Y+19
	CPI  R26,LOW(0x2)
	BRSH _0x1E7
	RCALL SUBOPT_0x17
	LDD  R30,Y+20
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x1B
	LDD  R30,Y+19
	SUBI R30,-LOW(1)
	STD  Y+19,R30
	RJMP _0x1E6
_0x1E7:
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x17
	RCALL _LCD_I2C_BATRON_gotoxy
	RCALL SUBOPT_0x39
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x39
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x1B
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R24,6
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1E9*2)
	LDI  R31,HIGH(_0x1E9*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x17
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x15
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,6
	RET
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R24,2
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1EE*2)
	LDI  R31,HIGH(_0x1EE*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	LDD  R17,Y+3
	MOV  R30,R7
	CPI  R30,0
	BRNE _0x1F2
	CPI  R17,0
	BRNE _0x1F3
	MOV  R16,R17
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	LDD  R17,Y+3
	CP   R17,R16
	BRNE _0x1F4
	LDI  R30,LOW(1)
	MOV  R7,R30
	CLR  R30
	RJMP _0x1FC
_0x1F4:
	LDI  R30,LOW(255)
	RJMP _0x1FC
	RJMP _0x1F6
_0x1F3:
	LDI  R30,LOW(255)
	RJMP _0x1FC
_0x1F6:
	RJMP _0x1F1
_0x1F2:
	CPI  R30,LOW(0x1)
	BRNE _0x1F1
	CPI  R17,0
	BREQ _0x1F8
	MOV  R16,R17
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	LDD  R17,Y+3
	CP   R17,R16
	BRNE _0x1F9
	CLR  R7
	MOV  R30,R17
	RJMP _0x1FC
_0x1F9:
	CLR  R30
	RJMP _0x1FC
	RJMP _0x1FB
_0x1F8:
	CLR  R30
_0x1FB:
_0x1F1:
_0x1FC:
	RCALL __LOADLOCR2
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES
SUBOPT_0xC:
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0xD:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0xE:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0xF:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Displ_2Lines_On_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x11:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	MOVW R30,R28
	SUBI R30,LOW(-(84))
	SBCI R31,HIGH(-(84))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	MOVW R30,R28
	SUBI R30,LOW(-(81))
	SBCI R31,HIGH(-(81))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x14:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _TWI_Get_Data_From_Transceiver

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(3)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x16:
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x17:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x19:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _strlen

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Built_Strng_Fram_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1B:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1C:
	__GETB1SX 70
	CPI  R30,LOW(0x40)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(2)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 66
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x1F:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x21:
	__GETB1SX 70
	CPI  R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x22:
	CLR  R30
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x23:
	RCALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x24:
	__GETB2SX 68
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	MOVW R26,R28
	SUBI R26,LOW(-(67))
	SBCI R27,HIGH(-(67))
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	SUBI R30,-LOW(1)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	MOVW R26,R28
	SUBI R26,LOW(-(65))
	SBCI R27,HIGH(-(65))
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	SUBI R30,LOW(1)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x29:
	LDI  R30,LOW(5)
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2A:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2B:
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2E:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2F:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x35:
	CLR  R30
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x36:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R26,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x37:
	ST   -Y,R30
	RJMP _LCD_I2C_BATRON_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x38:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x39:
	MOVW R30,R28
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3A:
	LDI  R30,LOW(1)
	RJMP SUBOPT_0x37

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3B:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3C:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3D:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x10

_strcpyf:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcpyf0:
	lpm  r0,z+
	st   x+,r0
	tst  r0
	brne __strcpyf0
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

