/********************************************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Robot solaire
Version : 4.0.0
Date    : 19/05/2010
Mise  jour: 19/05/2010
Author  : Philippe Mariano                            
Company : Lyce Pierre Emile Martin 18000 BOURGES                                
Comments: Fichier de la fiche guide 2
Mise en oeuvre du protocole I2C par l'interface TWI 
Commande d'un afficheur LCD Batron I2C (PCF2119x)
Lecture des BP et recopie sur les LED. 
Programme de test de la boussole HMC6352

File : twi4bsol.c
Target:  Robot S_ISI
Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************************************/

// =============================================================================================================================
// Partie dclarative du programme
// =============================================================================================================================
// Bibliothques et dfinitions
// =============================================================================================================================
#include <mega8535.h>      
// -----------------------------------------------------------------------------------------------------------------------------
// Bibliothque  rajouter manuellement   
// -----------------------------------------------------------------------------------------------------------------------------
#include <stdlib.h> 
#include <stdio.h>				// Fonction sprintf
#include <math.h>
#include <string.h>				// Fonctions de traitement des chanes de caractres  
#include <delay.h>				// Fonction temporisation   
// -----------------------------------------------------------------------------------------------------------------------------    
// Bibliothque dveloppes pour la carte SISI    
// -----------------------------------------------------------------------------------------------------------------------------
#include "HMC6352.h"			// Dfinition des registres de la boussole Honeywell HMC6352
#include "MD23.h"				// Dfinitions des registres de la carte moteur MD23  
#include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C 
#include "SISISOL.h"            // Gestion de l'IHM SISI 
// -----------------------------------------------------------------------------------------------------------------------------
// Redfinition des adresses (lecture / criture) de la boussole HMC6352 (0x42 par dfaut)
// -----------------------------------------------------------------------------------------------------------------------------
#define NEW_HMC6352_SLA_W 	0x44 // Ox42 est utilis par le PCF8574 reli aux LEDs sur l'IHM SISIV1 ! 
#define	NEW_HMC6352_SLA_R   0x45	
// -----------------------------------------------------------------------------------------------------------------------------
// Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
// -----------------------------------------------------------------------------------------------------------------------------
#define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
#include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
										// A remplacer par une bibliothque ! 
// Dclarations divers
// -----------------------------------------------------------------------------------------------------------------------------
#define	Moteur1			0
#define	Moteur2			1   
#define Empty			0
// =============================================================================================================================   

// =============================================================================================================================
// =============================================================================================================================
// Constantes en flash
// -----------------------------------------------------------------------------------------------------------------------------
// Structure pour l'affichage du nom des registres  (A terminer)
//flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
// -----------------------------------------------------------------------------------------------------------------------------
// Messages textuels prdfinis
// ATTENTION: imprativement 16 caractres 
// ----------------------------------------------------------------------------------------------------------------------------- 
flash char *Texte_Accueil_Ligne1 	= "   PPE Robsol   ";
flash char *Texte_Accueil_Ligne2 	= "   TWI4BSOL.c   ";
flash char *Ligne0MenuMode			= "1  Menu Mode    ";
flash char *Ligne0MenuInfos			= "2  Menu Infos   ";
flash char *Ligne0MenuBoussole		= "3 Menu Boussole ";
flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
flash char *Ligne1ChoixEntr			= "[Entr]          ";
flash char *Ligne1ChoixEchap		= "        [Echap] ";
flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
// =============================================================================================================================

// =============================================================================================================================
// =============================================================================================================================
// Prototypes des fonctions en cours de test
// ----------------------------------------------------------------------------------------------------------------------------- 
// ============================================================================================================================= 

// ============================================================================================================================= 
// =============================================================================================================================
// ---------------------------------------------- Declare your global variables here -------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// Type				Nom														Description  
// ----------------------------------------------------------------------------------------------------------------------------- 
// Etats du graphe des transitions "Menus"
// -----------------------------------------------------------------------------------------------------------------------------
enum TMenu {Choix_Menu_Mode, Choix_Menu_Infos, Choix_Mode_MD23, Choix_Menu_Boussole, Reglage_Mode0_MD23, Reglage_Mode1_MD23,  
Reglage_Mode2_MD23,Reglage_Mode3_MD23, Controle_Moteurs, Info_Batt, Info_Vers, Info_All, Menu_Boussole} Menu=Choix_Menu_Mode, 
Menu_1=Choix_Mode_MD23;
// -----------------------------------------------------------------------------------------------------------------------------					
bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0 
// =============================================================================================================================


// =============================================================================================================================
// =============================================================================================================================
// Partie excutive du programme 
// =============================================================================================================================
// =============================================================================================================================
void main(void)
{
// =============================================================================================================================
// ---------------------------------------------- Declare your local variables here -------------------------------------------- 
// =============================================================================================================================
// Messages pour les composants I2C 
// =============================================================================================================================
// 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 	   		Nom 				       						Description 
// ----------------------------------------------------------------------------------------------------------------------------- 
unsigned char Frame_I2C_LED_All_Off[]={Add_LED_I2C,0xff}; 		// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
unsigned char Frame_I2C_LED_Switching[]={Add_LED_I2C,0x00}; 	// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
																// or Off=1}. Initialisation = All On.
unsigned char Frame_I2C_BP_Read[]={Add_BP_I2C,0x00}; 			// Trame de lecture des BP {SLA+R=0x43, Data=Nul}      
// ============================================================================================================================= 
// 2) Messages pour le LCD I2C BATRON de la carte S_ISI
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 	   		Nom 				       						Description 
// ----------------------------------------------------------------------------------------------------------------------------- 
//unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
unsigned char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	// Trame de texte compose de: {SLA+W=0x76, cde=write to DDRAM ,  
						 	     								// le texte  afficher = 16 caractres max,  Nul }                  
                                                            	// Cette trame est remplie avec le tableau String_to_LCD
// =============================================================================================================================
// 3) Liste de messages prdfinis pour la carte MD23 
// ============================================================================================================================= 
// 30) Initialisation
unsigned char Reset_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur};

// 31) Mode
unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};

// 32) Vitesse des moteurs 
unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur dans le mode 0
unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur dans le mode 0
unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs}; 

// 33) Lecture des registres
unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		// Premire trame  envoyer { SLA_W=0xB0, N registre o commence
															// la lecture } 
// =============================================================================================================================
// 4) Liste des messages prdfinis pour la boussole HMC6352
// =============================================================================================================================
// Lecture de la direction (comprise entre 0 et 3599, code sur deux octets)
unsigned char Frame_I2C_W_Cde_HMC6352[] = {NEW_HMC6352_SLA_W,'A'}; 
unsigned char Frame_I2C_Read_Data_HMC6352[] = {NEW_HMC6352_SLA_R,Empty,Empty};  
// =============================================================================================================================
// Variables diverses
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 		Nom 				       Description 
// -----------------------------------------------------------------------------------------------------------------------------    
// 1) Gestion de la carte MD23
// -----------------------------------------------------------------------------------------------------------------------------
// Variables utilises dans la gestion de l'affichage:  limitent son rafrachissement
int Num_Reg_MD23_1=0, Num_Reg_MD23=0;                        // Numro du registre slectionn pour l'affichage   
unsigned char Vitesse_MD23_1, Vitesse_MD23, BP_I2C=0, Finesse_1=1, Finesse=1; 
unsigned char SpeedMot1, SpeedMot1_1, SpeedMot2, SpeedMot2_1; // Limite le rafrachissement de l'affichage
unsigned char Choix_Mode_1=1, Choix_Mode=0;                                                   		
unsigned char Ubatt_1=0, Ubatt=0;							// Tension alimentation carte MD23 
unsigned char Version_1=0, Version=0; 
// 2) Boussole HMC6352
unsigned char Direction_MSB, Direction_MSB_1, Direction_LSB, Direction_LSB_1; 
int Direction;
// -----------------------------------------------------------------------------------------------------------------------------
															// Reoit le contenu des registres de la carte MD23. Liste ci-dessous
//Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev, AccRate, Mode, Cde
unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 

// 2) Gestion du LCD BATRON
// -----------------------------------------------------------------------------------------------------------------------------
 char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];     // Reoivent les deux lignes de texte  envoyer  l'afficheur
															// (16 caractres max. + Nul)
// -----------------------------------------------------------------------------------------------------------------------------
// *****************************************************************************************************************************

// =============================================================================================================================
// ===================================================== Initialisations =======================================================
// =============================================================================================================================
TWI_Master_Initialise(); 									// Initialisation de l'interface TWI en mode Standby 
// -----------------------------------------------------------------------------------------------------------------------------
// Global enable interrupts
#asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI				
// -----------------------------------------------------------------------------------------------------------------------------
TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte S_ISI 	
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// Initialisation de l'afficheur I2C BATRON 
// -----------------------------------------------------------------------------------------------------------------------------
Init_LCD_I2C_BATRON();
// -----------------------------------------------------------------------------------------------------------------------------
// Affichage d'un message d'accueil
// -----------------------------------------------------------------------------------------------------------------------------
sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
delay_ms(4000); 
// -----------------------------------------------------------------------------------------------------------------------------
// Initialisation des registres de  la carte MD23
// -----------------------------------------------------------------------------------------------------------------------------
TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));			
TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));  

// =============================================================================================================================
// ================================================ Boucle principale ==========================================================
// =============================================================================================================================
while (1)
      { 
// ---------------------------------------------  Champ Lecture des donnes ---------------------------------------------------- 
// Lecture de l'tat des BP
// ---------------------------------------------------------------------------------------------------------------------------- 
// Lecture des BP pour affichage sur les LED
	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));    // Envoi de l'octet d'adresse des BP: SLA+R=0x43 
																		// Rcupration de l'octet reprsentatif de l'tat des BP	
	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read)); 
	
    BP_I2C = Lire_BP_I2C();														// Lecture des BP avec gestion anti-rebond
// ----------------------------------------------------------------------------------------------------------------------------    
// Lecture des registres de la carte MD23 
/*
   if (Menu != Reglage_Mode0_MD23)
   {                                                           // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W)); 
   	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture  
	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));  
   }
*/
// ---------------------------------------------------------------------------------------------------------------------------- 
// Prparation de l'opration de lecture des donnes: Ecriture de la commande 'A' 
TWI_Start_Transc_With_Data(Frame_I2C_W_Cde_HMC6352, sizeof(Frame_I2C_W_Cde_HMC6352));
// Lecture des donnes de la boussole
TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	
// --------------------------------------------------- Champ Traitement--------------------------------------------------------  
    switch(Menu)
    {// Dbut du switch1 
// -------------------------------------Dbut Menus droulants----------------------------------------------------------------- 
// Menus Niveau 1 -------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------------------
		case Choix_Menu_Mode : if (Menu_1 != Menu)
			{ 
				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
				LCD_I2C_BATRON_gotoxy(0,15); 						 	     
				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0)); 
				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line)); 
				Display_Arrow_0n_I2C_LCDBATRON();
			}
     			     	
			switch (BP_I2C)
				{                                  
					case ENTR_I2C: Menu = Choix_Mode_MD23;  break; // touche Enter
					case FlecheH_I2C: Menu = Choix_Menu_Boussole;  break; // touche flche haut
					case FlecheB_I2C: Menu = Choix_Menu_Infos;  break; // touche flche bas 
					default: Menu = Choix_Menu_Mode ;
				} 
     			      
			Menu_1 = Choix_Menu_Mode ;
		break;
// ----------------------------------------------------------------------------------------------------------------------------     
		case Choix_Menu_Infos: if (Menu_1 != Menu)
			{ 
				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
				Display_Arrow_0n_I2C_LCDBATRON();
			}
     			     	
			switch (BP_I2C)
				{                                  
					case ENTR_I2C: Menu = Info_All;  break; 
					case FlecheH_I2C: Menu = Choix_Menu_Mode;  break; 
					case FlecheB_I2C: Menu = Choix_Menu_Boussole;  break;  
					default: Menu = Choix_Menu_Infos ;
				}  
     			      
			Menu_1 = Choix_Menu_Infos ;
		break; 
// ---------------------------------------------------------------------------------------------------------------------------- 		
		case Choix_Menu_Boussole: if (Menu_1 != Menu)
			{ 
				sprintf(Buffer_for_LCD_Line0,Ligne0MenuBoussole);
				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
				Display_Arrow_0n_I2C_LCDBATRON();
			}
     			     	
			switch (BP_I2C)
				{                                  
					case ENTR_I2C: Menu = Menu_Boussole;  break; 
					case FlecheH_I2C: Menu = Choix_Menu_Infos;  break; 
					case FlecheB_I2C: Menu = Choix_Menu_Mode;  break;  
					default: Menu = Choix_Menu_Boussole ;
				}  
     			      
			Menu_1 = Choix_Menu_Boussole ;
		break; 
// ----------------------------------------------------------------------------------------------------------------------------
// Menus Niveau 2 -------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------------------------     
	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
	          {
	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	        	 Display_Arrow_0n_I2C_LCDBATRON();
	        	 Choix_Mode_1 = Choix_Mode;
	          }  
	          
	          switch (BP_I2C)
				{
					case ECHAP_I2C : Menu=Choix_Menu_Mode; break;  // touche ECHAP
					case FlecheH_I2C: if (Choix_Mode < 3) Choix_Mode = Choix_Mode + 1; else Choix_Mode=0;  break; // touche +
					case FlecheB_I2C: if (Choix_Mode > 0) Choix_Mode = Choix_Mode - 1; else Choix_Mode=3;  break; // touche -
					case ENTR_I2C: if (Choix_Mode == 0) {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Mode0_MD23;};	break; 
					 
					default: Menu=Choix_Mode_MD23;
				}  
       		 	
			  Menu_1 = Choix_Mode_MD23;
	        break;
// ----------------------------------------------------------------------------------------------------------------------------
            case Reglage_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
              {
                sprintf(Buffer_for_LCD_Line0,"1.%-u Mode%-u (+%-u)  ",Choix_Mode+1,Choix_Mode,Finesse);
                sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
                Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
                Display_Arrow_0n_I2C_LCDBATRON();
                SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
              }
              
              
              switch (BP_I2C)
				{
				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;  
				 	
				 	case PLUS_I2C:  
				 		switch (Choix_Moteur)
				 		  { 
				 		   	case Moteur1: if (Finesse==1)
				 		   					if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
				 		   			else    
				 		   					if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
				 		   	break;
				 		   	case Moteur2: if (Finesse==1)
				 		   					if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
				 		   			else    
				 		   					if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
				 		   	break;
				 		  }
				 	break;
				 	case MOINS_I2C:   
				 	    switch (Choix_Moteur)
				 		  { 
				 		   	case Moteur1: if (Finesse==1)
				 		   					if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
				 		   			else    
				 		   					if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0; 
				 		   	break;
				 		   	case Moteur2: if (Finesse==1)
				 		   					if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
				 		   			else    
				 		   					if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
				 			break;
				 		  }
				 	break;
				 	
				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1;
				 	break; 
				 	
				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; 
				 	break; 
				 	
				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; 
				 	break; 
				 	
				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2; 
				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
				    break;
				     
					default: Menu = Reglage_Mode0_MD23;
				}  
			  Menu_1 = Reglage_Mode0_MD23;   
			break;
// ----------------------------------------------------------------------------------------------------------------------------	        
		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];  
			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23)) 
			  {	
				sprintf(Buffer_for_LCD_Line0,"2.1 Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;   
				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
				Display_Arrow_0n_I2C_LCDBATRON();
				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
			  }	
       		              
			switch (BP_I2C)
				{
					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break; 
					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break; 
					case FlecheH_I2C: Menu = Info_Batt;  break; 
					case FlecheB_I2C: Menu = Info_Vers;  break; 
					default: Menu=Info_All;
				}  
       		 	
			Menu_1 = Info_All;		   
		break;       
// ----------------------------------------------------------------------------------------------------------------------------	        
		case Info_Vers:	Version = Table_Registers_MD23[14];  
			if ((Menu_1 != Menu)||(Version_1 != Version)) 
   			  {	
				sprintf(Buffer_for_LCD_Line0,"2.2 Version=%-u",Version);
				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
				Display_Arrow_0n_I2C_LCDBATRON();
				Version_1 = Version;
			  }	
       		              
			switch (BP_I2C)
				{
					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
					case FlecheH_I2C: Menu = Info_All;  break; 
					case FlecheB_I2C: Menu = Info_Batt;  break; 
					default: Menu=Info_Vers;
				}  
       		 	
			Menu_1 = Info_Vers;		   
		break;     
// ----------------------------------------------------------------------------------------------------------------------------       
		case Info_Batt:  	Ubatt = Table_Registers_MD23[11];  
			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt)) 
   			  {	
					sprintf(Buffer_for_LCD_Line0,"2.3 Ubatt=%-u.%-uV",Ubatt/10, Ubatt-10*(Ubatt/10));
					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
					Display_Arrow_0n_I2C_LCDBATRON();
					Ubatt_1 = Ubatt;
			  }	
       		              
			switch (BP_I2C)
				{
					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
					case FlecheH_I2C: Menu = Info_Vers;  break; 
					case FlecheB_I2C: Menu = Info_All;  break; 
					default: Menu=Info_Batt;
				}  
       		 	
			Menu_1 = Info_Batt;
		break;   
// ----------------------------------------------------------------------------------------------------------------------------       
		case Menu_Boussole:  	Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];  
			if ((Menu_1 != Menu)||(Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB)) 
   			  {	
   			  		//Direction = (int)(255*Direction_MSB) + Direction_LSB;
					sprintf(Buffer_for_LCD_Line0,"M=%-x L=%-x",Direction_MSB,Direction_LSB);
					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
					Display_Arrow_0n_I2C_LCDBATRON();
					Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB;
					delay_ms(500);
			  }	
       		              
			switch (BP_I2C)
				{
					case ECHAP_I2C : Menu=Choix_Menu_Boussole; break;  
					//case FlecheH_I2C: Menu = Info_Vers;  break; 
					//case FlecheB_I2C: Menu = Info_All;  break; 
					default: Menu=Menu_Boussole;
				}  
       		 	
			Menu_1 = Menu_Boussole;
		break;   
			
    }// Fin du switch1  
 // ----------------------------------------------------------------------------------------------------------------------------
       
    Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];  
// ----------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------  Champ Ecriture des rsultats  ----------------------------------------------------
// Ecriture sur les LED                              	
    //TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
// ----------------------------------------------------------------------------------------------------------------------------  
 // delay_ms(100);   // A utiliser pour visualiser les trames I2C
  }; // Fin while(1)
      
} //Fin main  


