;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 186 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "twi5sd21.vec"
	.INCLUDE "twi5sd21.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x11A)
	LDI  R29,HIGH(0x11A)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x11A
;       1 /********************************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : ROBOT BIPED
;      10 Version : 1.0.1
;      11 Date    : 13/06/2010
;      12 Mise  jour: 17/06/2010
;      13 Author  : Philippe Mariano                            
;      14 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      15 Comments: 
;      16 Mise en oeuvre du protocole I2C par l'interface TWI 
;      17 - Commande des LEDs. 
;      18 - Test de la carte SD21 (Commande de quatre servomoteurs
;      19 plac aux positions 1, .., 4 de la carte
;      20 
;      21 File : twi5SD21.c
;      22 Target: Cartes SISI et SD21  
;      23 Chip type           : ATmega8535
;      24 Program type        : Application
;      25 Clock frequency     : 8,000000 MHz
;      26 Memory model        : Small
;      27 External SRAM size  : 0
;      28 Data Stack size     : 128
;      29 *********************************************************************/
;      30 
;      31 // =============================================================================================================================
;      32 // =============================================================================================================================
;      33 // Partie dclarative du programme
;      34 // =============================================================================================================================
;      35 // Bibliothques et dfinitions
;      36 // =============================================================================================================================
;      37 #include <mega8535.h>      
;      38 // -----------------------------------------------------------------------------------------------------------------------------
;      39 // Bibliothque  rajouter manuellement   
;      40 // -----------------------------------------------------------------------------------------------------------------------------
;      41 #include <stdlib.h>  
;      42 #include <delay.h>				// Fonctions de temporisation   
;      43 // -----------------------------------------------------------------------------------------------------------------------------    
;      44 // Bibliothque dveloppes pour la carte SISI  placer dans le rpertoire du projet   
;      45 // -----------------------------------------------------------------------------------------------------------------------------
;      46 #include "SD21.h"				// Dfinitions des registres de la carte servo SD21   
;      47 #include "SISISOL.h"            // Gestion de l'IHM SISI  
;      48 // -----------------------------------------------------------------------------------------------------------------------------
;      49 // Alias pour la trame de commande des Servos 
;      50 // -----------------------------------------------------------------------------------------------------------------------------
;      51 #define NumServo			  Frame_I2C_Servo[1]
;      52 #define RegSpeedValue	      Frame_I2C_Servo[2] 
;      53 #define RegPosLByte			  Frame_I2C_Servo[3] 
;      54 #define RegPosHByte			  Frame_I2C_Servo[4]
;      55 // -----------------------------------------------------------------------------------------------------------------------------
;      56 // Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
;      57 // -----------------------------------------------------------------------------------------------------------------------------
;      58 #define TWI_BUFFER_SIZE   		20 		// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
;      59 #include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
;      60 /***********************************************************************
;      61 Project : PPE Robot(s)
;      62 Version : 1
;      63 Date    : 12/08/2009
;      64 Author  : MNO
;      65 File : twi_f.c
;      66 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      67 et dcrites dans la note d'application AVR315, adaptes au
;      68 cross compilateur CVAVR.
;      69 Fichier  inclure en en tte d'une application ncessitant une interface
;      70 2 fil I2C.
;      71 Evolution:  remplacer par une bibliothque
;      72 ***********************************************************************/
;      73 
;      74 
;      75 #include <TWI_Master_CVAVR.h>  
;      76 
;      77 // Declare your global variables here 
;      78 //-----------------------------------------------------------------------------------------------------------------------------
;      79 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      80 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      81 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      82  
;      83 union TWI_STR                      					// Status byte holding flags.
;      84 {
;      85     unsigned char all;
;      86     unsigned char lastTransOK:1;      
;      87     unsigned char unusedBits:7; 
;      88 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      89 //-----------------------------------------------------------------------------------------------------------------------------
;      90 
;      91 //-----------------------------------------------------------------------------------------------------------------------------
;      92 // Fonctions du drivers TWI
;      93 //-----------------------------------------------------------------------------------------------------------------------------
;      94 void TWI_Master_Initialise(void)
;      95 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      96   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      97 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      98   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      99   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     100   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;     101                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;     102                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;     103                                          		// 0<<TWWC); 
;     104 } 
	RET
;     105 //-----------------------------------------------------------------------------------------------------------------------------
;     106 unsigned char TWI_Transceiver_Busy(void)
;     107 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;     108   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;     109 }
;     110 //-----------------------------------------------------------------------------------------------------------------------------
;     111 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;     112 {
_TWI_Start_Transc_With_Data:
;     113   unsigned char temp;
;     114                                                 // Adapte pour CVAVR
;     115   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x14:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x14
;     116 
;     117   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;     118   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x0
	STS  _TWI_buf_G1,R30
;     119   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x0
	ANDI R30,LOW(0x1)
	BRNE _0x17
;     120   {												// If it is a write operation, then also copy data.
;     121     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x19:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	BRSH _0x1A
;     122       TWI_buf[ temp ] = msg[ temp ];
	LD   R30,Y
	RCALL SUBOPT_0x1
	PUSH R31
	PUSH R30
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x19
_0x1A:
;     123   }
;     124   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x17:
	CLR  R30
	STS  _TWI_statusReg,R30
;     125   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     126   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     127                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     128                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     129                                       			// (0<<TWWC);
;     130 } 
	ADIW R28,4
	RET
;     131 //-----------------------------------------------------------------------------------------------------------------------------
;     132 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     133 {
;     134   unsigned char i;
;     135           
;     136   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
;     137 
;     138   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
;     139   {                                             
;     140     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
;     141     {
;     142       msg[ i ] = TWI_buf[ i ];
;     143     }
;     144   }
;     145   return( TWI_statusReg.lastTransOK );                                   
;     146 }  
;     147 //-----------------------------------------------------------------------------------------------------------------------------
;     148 
;     149 // ----------------------------------------------------------------------------------------------------------------------------
;     150 // Interruption TWI
;     151 // ----------------------------------------------------------------------------------------------------------------------------
;     152 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     153 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     154 												// __interrupt void TWI_ISR(void)
;     155   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     156   
;     157   switch (TWSR)
	IN   R30,0x1
;     158   {
;     159     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x28
;     160     
;     161     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x29
_0x28:
;     162       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     163       				
;     164     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x2A
_0x29:
	CPI  R30,LOW(0x18)
	BRNE _0x2B
_0x2A:
;     165     
;     166     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x2C
_0x2B:
	CPI  R30,LOW(0x28)
	BRNE _0x2D
_0x2C:
;     167       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x2E
;     168       {
;     169         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x2
	LD   R30,Z
	OUT  0x3,R30
;     170         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x4E
;     171         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     172                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     173                						  			// (0<<TWWC); 
;     174       }
;     175       else                    					// Send STOP after last byte
_0x2E:
;     176       {
;     177         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x3
;     178          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     179         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x4E:
	OUT  0x36,R30
;     180         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     181                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     182                                				  	// (0<<TWWC);
;     183       }
;     184     break;
	RJMP _0x26
;     185       
;     186     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x2D:
	CPI  R30,LOW(0x50)
	BRNE _0x30
;     187       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x2
	MOVW R26,R30
	RCALL SUBOPT_0x4
;     188       
;     189     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x31
_0x30:
	CPI  R30,LOW(0x40)
	BRNE _0x32
_0x31:
;     190       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x33
;     191       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     192         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x4F
;     193         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     194                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     195                                   				// (0<<TWWC);  
;     196       } else                    				// Send NACK after next reception
_0x33:
;     197       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     198         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x4F:
	OUT  0x36,R30
;     199         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     200                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     201                                 			  	// (0<<TWWC); 
;     202       }    
;     203     break; 
	RJMP _0x26
;     204       
;     205     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x32:
	CPI  R30,LOW(0x58)
	BRNE _0x35
;     206       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0x4
;     207       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x3
;     208       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     209       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x50
;     210                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     211                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     212                               					// (0<<TWWC); 
;     213     break;  
;     214           
;     215     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x35:
	CPI  R30,LOW(0x38)
	BRNE _0x36
;     216     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     217       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x50
;     218                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     219                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     220                               					// (0<<TWWC);
;     221     break;
;     222       
;     223     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x36:
	CPI  R30,LOW(0x20)
	BREQ _0x38
;     224     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x39
_0x38:
;     225     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0x3A
_0x39:
	CPI  R30,LOW(0x30)
	BRNE _0x3B
_0x3A:
;     226 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     227     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0x3C
_0x3B:
	CPI  R30,0
	BRNE _0x3E
_0x3C:
;     228     
;     229     default:     
_0x3E:
;     230       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     231       											// Reset TWI Interface
;     232                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     233       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x50:
	OUT  0x36,R30
;     234                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     235                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     236                               					// (0<<TWWC);
;     237   }
_0x26:
;     238 } 
	RCALL __LOADISR
	RETI
;     239 
;     240 										// A faire vomuer vers une bibliothque !  
;     241 // =============================================================================================================================
;     242 #include "Table_Rob.c"                 // Table des valeurs des positions  envoyer aux servos
;     243 /***********************************************************************
;     244 Project : Robot(s) biped
;     245 Version : 1
;     246 Date    : 17/06/2010
;     247 Author  : Mariano - LEGENDRE
;     248 File : Table_Rob.c
;     249 Description : Table contenant les valeurs des positions 
;     250  envoyer aux servos
;     251 ***********************************************************************/
;     252 
;     253 
;     254 // =============================================================================================================================
;     255 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     256 // =============================================================================================================================
;     257 // Tables des valeurs "Servox" et "Position" places dans les trames Frame_I2C_Servo.
;     258 // Chaque table doit avoir le mme nombre de valeurs (max 65536)
;     259 
;     260 flash unsigned char Tab_Servo[]={
;     261 Servo1, 	/* N du servo dans la premire trame */
;     262 Servo2, 	/* N du servo dans la deuxime trame */
;     263 Servo3, 
;     264 Servo4 
;     265 /*  complter ... */
;     266 };  
;     267 
;     268 flash unsigned int Tab_Position[]={
;     269 800, 	/* Consigne de position du servo dans la premire trame */
;     270 1000,	/* Consigne de position du servo dans la deuxime trame */
;     271 1500,
;     272 2000
;     273 /*  complter ... */
;     274 };
;     275 // =============================================================================================================================
;     276 // =============================================================================================================================
;     277 // Fonctions dveloppes pour l'application
;     278 // -----------------------------------------------------------------------------------------------------------------------------
;     279 // Rcupration de l'octet de poids faible d'un entier
;     280 unsigned char LSBYTE(int value)
;     281 {
_LSBYTE:
;     282 	unsigned int LByte;
;     283 	LByte = (unsigned char)(value & 0x00FF);
	RCALL SUBOPT_0x5
;	value -> Y+2
;	LByte -> R16,R17
	ANDI R31,HIGH(0xFF)
	RCALL SUBOPT_0x6
;     284 	return LByte;
	RJMP _0x4D
;     285 } 
;     286 // -----------------------------------------------------------------------------------------------------------------------------
;     287 // Rcupration de l'octet de poids fort d'un entier
;     288 unsigned char MSBYTE(int value)
;     289 {
_MSBYTE:
;     290 	unsigned int MByte;
;     291 	MByte = (unsigned char)((value & 0xFF00)>>8);
	RCALL SUBOPT_0x5
;	value -> Y+2
;	MByte -> R16,R17
	ANDI R30,LOW(0xFF00)
	RCALL __ASRW8
	RCALL SUBOPT_0x6
;     292 	return MByte;
_0x4D:
	RCALL __LOADLOCR2
	ADIW R28,4
	RET
;     293 }  
;     294 // =============================================================================================================================  
;     295 
;     296 
;     297 // =============================================================================================================================
;     298 // =============================================================================================================================
;     299 // Partie excutive du programme 
;     300 // =============================================================================================================================
;     301 // =============================================================================================================================
;     302 void main(void)
;     303 {
_main:
;     304 // =============================================================================================================================
;     305 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     306 // =============================================================================================================================
;     307 unsigned char Vitesse;				// Vitesse de dplacement du servo          
;     308 unsigned int tempo;                 // Attente entre deux transmission : doit tre > 20ms 
;     309 unsigned int i;						// Variable de boucle 
;     310 
;     311 // -----------------------------------------------------------------------------------------------------------------------------
;     312 // Messages pour les composants I2C de la carte SISI
;     313 // =============================================================================================================================
;     314 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
;     315 // ----------------------------------------------------------------------------------------------------------------------------- 
;     316 // Type 	   		Nom 				       						Description 
;     317 // ----------------------------------------------------------------------------------------------------------------------------- 
;     318 unsigned char Frame_I2C_LED_Switching[]={Add_LED_I2C,0x00}; 	// Trame de commande des LEDs {SLA+W=0x40, Data : Led_On=0
;     319 																// or Off=1}. Initialisation = All On.  
;     320 // ============================================================================================================================= 
;     321 // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
;     322 // ----------------------------------------------------------------------------------------------------------------------------- 
;     323 // Type 	   		Nom 				       						Description 
;     324 // ----------------------------------------------------------------------------------------------------------------------------- 
;     325 // =============================================================================================================================
;     326 // 3) Messages prdfinis pour la carte SD21 
;     327 // ============================================================================================================================= 
;     328 // 30) Initialisation 
;     329 // -----------------------------------------------------------------------------------------------------------------------------
;     330 // -----------------------------------------------------------------------------------------------------------------------------
;     331 // 31) Trame de commande des servos
;     332 // ----------------------------------------------------------------------------------------------------------------------------- 
;     333 // Cette trame est compose de: {@SD21, NumServo, RegSpeedValue, RegPosLByte, RegPosHByte}
;     334 unsigned char Frame_I2C_Servo[]={SD21_ADD_BASE_W,Servo1,0,0xE8,0x03};		 
;     335 
;     336 // Dtail du contenu de la "trame I2C Servo" 
;     337 // @SD21			  SLA+W = 0xC2: Adresse de la carte SD21 en criture
;     338 // NumServo			  N du registre vitesse du servo  commander, dfinit dans SD21.h (Servo1 par dfaut)
;     339 // RegSpeedValue	  Valeur  placer dans le le registre vitesse (Vitesse maxi par dfaut)
;     340 // RegPosLByte		  Octet de poids faible du mot de commande de la position (Position mini par dfaut)
;     341 // RegPosHByte		  Octet de poids fort du mot de commande de la position 
;     342 // -----------------------------------------------------------------------------------------------------------------------------
;     343 // 32) Lecture des registres de la carte SD21
;     344 // -----------------------------------------------------------------------------------------------------------------------------
;     345 // ============================================================================================================================= 
;     346 // =============================================================================================================================
;     347 // Variables diverses
;     348 // ----------------------------------------------------------------------------------------------------------------------------- 
;     349 // Type 		Nom 				       Description 
;     350 // -----------------------------------------------------------------------------------------------------------------------------    
;     351 // 1) Gestion de la carte SD21
;     352 // -----------------------------------------------------------------------------------------------------------------------------
;     353 // -----------------------------------------------------------------------------------------------------------------------------
;     354 // 2) Gestion du LCD BATRON de la carte Sisi
;     355 // -----------------------------------------------------------------------------------------------------------------------------
;     356  // ----------------------------------------------------------------------------------------------------------------------------- 
;     357 // 3) Gestion des BP de la carte Sisi
;     358 // -----------------------------------------------------------------------------------------------------------------------------
;     359 // *****************************************************************************************************************************
;     360 
;     361 // =============================================================================================================================
;     362 // ===================================================== Initialisations =======================================================
;     363 // =============================================================================================================================
;     364 TWI_Master_Initialise(); 			// Initialisation de l'interface TWI en mode Standby                                        
	SBIW R28,7
	LDI  R24,7
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x42*2)
	LDI  R31,HIGH(_0x42*2)
	RCALL __INITLOCB
;	Vitesse -> R16
;	tempo -> R17,R18
;	i -> R19,R20
;	Frame_I2C_LED_Switching -> Y+5
;	Frame_I2C_Servo -> Y+0
	RCALL _TWI_Master_Initialise
;     365 // -----------------------------------------------------------------------------------------------------------------------------
;     366 // Global enable interrupts
;     367 #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI			
	sei
;     368 // -----------------------------------------------------------------------------------------------------------------------------
;     369 // -----------------------------------------------------------------------------------------------------------------------------
;     370 // Initialisation de l'afficheur I2C BATRON 
;     371 // -----------------------------------------------------------------------------------------------------------------------------
;     372 // -----------------------------------------------------------------------------------------------------------------------------
;     373 // Affichage d'un message d'accueil
;     374 // -----------------------------------------------------------------------------------------------------------------------------
;     375 // -----------------------------------------------------------------------------------------------------------------------------
;     376 // Initialisations des paramettres de la marche du robot !!!!!!!!!!!!!!!!!!!!
;     377 // ----------------------------------------------------------------------------------------------------------------------------- 
;     378 Vitesse = 0; 		// Vitesse servo = max		
	LDI  R16,LOW(0)
;     379 tempo = 1000;
	__GETWRN 17,18,1000
;     380 // Initialisation des registres de la carte SD21
;     381 // -----------------------------------------------------------------------------------------------------------------------------
;     382 // Position initial du servo1
;     383 RegSpeedValue = Vitesse; RegPosLByte= 0xE8; RegPosHByte=0x03;  					// 1000s = 03E8h
	MOVW R26,R28
	ADIW R26,2
	ST   X,R16
	LDI  R30,LOW(232)
	STD  Y+3,R30
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x7
;     384 TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));			// Vitesse, LSByte, MSByte                           
;     385 delay_ms(5000);                                                                                                                
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     386 // =============================================================================================================================
;     387 // ================================================ Boucle principale ==========================================================
;     388 // ============================================================================================================================= 
;     389 // Pour info
;     390 // 1000 = 3E8h	valeur min
;     391 // 1250 = 4E2h
;     392 // 1500 = 5DCh
;     393 // 1750 = 6D6h 
;     394 // 1950 = 7E9h et + ?
;     395 // -----------------------------------------------------------------------------------------------------------------------------
;     396 // Les valeurs n Servo + Position transmises  la carte SD21 par le bus I2C  doivent tre places dans les tableaux situs
;     397 // dans le fichier "Table_Rob.c"
;     398 // Le nom des servos est dclar dans le fichier sd21.h
;     399  
;     400 while (1)
_0x43:
;     401   { 
;     402    // Configuration des paramtres "Servox" [0<x<5] et "position" envoys aux servos 
;     403    for(i=0; i<sizeof(Tab_Servo); i++)
	__GETWRN 19,20,0
_0x47:
	__CPWRN 19,20,4
	BRSH _0x48
;     404    {
;     405     // Configuration de la trame "Frame_I2C_Servo" avec les valeurs contenues dans les tableaux situs dans 
;     406     // le fichier Table_Rob.c
;     407     NumServo = Tab_Servo[i]; RegPosLByte = LSBYTE(Tab_Position[i]);  RegPosHByte = MSBYTE(Tab_Position[i]); 
	LDI  R30,LOW(_Tab_Servo*2)
	LDI  R31,HIGH(_Tab_Servo*2)
	ADD  R30,R19
	ADC  R31,R20
	LPM  R30,Z
	STD  Y+1,R30
	RCALL SUBOPT_0x8
	RCALL _LSBYTE
	STD  Y+3,R30
	RCALL SUBOPT_0x8
	RCALL _MSBYTE
	RCALL SUBOPT_0x7
;     408      	
;     409 	// Envoi de la trame  "Frame_I2C_Servo"  la carte SD21
;     410 	TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));	      
;     411 	
;     412 	// Visualisation de la position des valeurs dans les tableaux sur les Leds de la carte Sisi
;     413 	Frame_I2C_LED_Switching[1] = i;
	__GETW1R 19,20
	STD  Y+6,R30
;     414 	TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
;     415 	delay_ms(tempo);   
	ST   -Y,R18
	ST   -Y,R17
	RCALL _delay_ms
;     416    } // fin du for      
	__ADDWRN 19,20,1
	RJMP _0x47
_0x48:
;     417    
;     418   } // fin du while  
	RJMP _0x43
;     419   
;     420 } // fin du main
	ADIW R28,7
_0x49:
	RJMP _0x49
;     421 

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	MOV  R30,R4
	INC  R4
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	RCALL __SAVELOCR2
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	CLR  R31
	__PUTW1R 16,17
	__GETW1R 16,17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	STD  Y+4,R30
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDI  R26,LOW(_Tab_Position*2)
	LDI  R27,HIGH(_Tab_Position*2)
	__GETW1R 19,20
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RCALL __GETW1PF
	ST   -Y,R31
	ST   -Y,R30
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ASRW8:
	MOV  R30,R31
	CLR  R31
	SBRC R30,7
	SER  R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

