/********************************************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : ROBOT BIPED
Version : 1.0.1
Date    : 13/06/2010
Mise  jour: 17/06/2010
Author  : Philippe Mariano                            
Company : Lyce Pierre Emile Martin 18000 BOURGES                                
Comments: 
Mise en oeuvre du protocole I2C par l'interface TWI 
- Commande des LEDs. 
- Test de la carte SD21 (Commande de quatre servomoteurs
plac aux positions 1, .., 4 de la carte

File : twi5SD21.c
Target: Cartes SISI et SD21  
Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************************************/

// =============================================================================================================================
// =============================================================================================================================
// Partie dclarative du programme
// =============================================================================================================================
// Bibliothques et dfinitions
// =============================================================================================================================
#include <mega8535.h>      
// -----------------------------------------------------------------------------------------------------------------------------
// Bibliothque  rajouter manuellement   
// -----------------------------------------------------------------------------------------------------------------------------
#include <stdlib.h>  
#include <delay.h>				// Fonctions de temporisation   
// -----------------------------------------------------------------------------------------------------------------------------    
// Bibliothque dveloppes pour la carte SISI  placer dans le rpertoire du projet   
// -----------------------------------------------------------------------------------------------------------------------------
#include "SD21.h"				// Dfinitions des registres de la carte servo SD21   
#include "SISISOL.h"            // Gestion de l'IHM SISI  
// -----------------------------------------------------------------------------------------------------------------------------
// Alias pour la trame de commande des Servos 
// -----------------------------------------------------------------------------------------------------------------------------
#define NumServo			  Frame_I2C_Servo[1]
#define RegSpeedValue	      Frame_I2C_Servo[2] 
#define RegPosLByte			  Frame_I2C_Servo[3] 
#define RegPosHByte			  Frame_I2C_Servo[4]
// -----------------------------------------------------------------------------------------------------------------------------
// Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
// -----------------------------------------------------------------------------------------------------------------------------
#define TWI_BUFFER_SIZE   		20 		// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
#include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
										// A faire vomuer vers une bibliothque !  
// =============================================================================================================================
#include "Table_Rob.c"                 // Table des valeurs des positions  envoyer aux servos
// =============================================================================================================================
// =============================================================================================================================
// Fonctions dveloppes pour l'application
// -----------------------------------------------------------------------------------------------------------------------------
// Rcupration de l'octet de poids faible d'un entier
unsigned char LSBYTE(int value)
{
	unsigned int LByte;
	LByte = (unsigned char)(value & 0x00FF);
	return LByte;
} 
// -----------------------------------------------------------------------------------------------------------------------------
// Rcupration de l'octet de poids fort d'un entier
unsigned char MSBYTE(int value)
{
	unsigned int MByte;
	MByte = (unsigned char)((value & 0xFF00)>>8);
	return MByte;
}  
// =============================================================================================================================  


// =============================================================================================================================
// =============================================================================================================================
// Partie excutive du programme 
// =============================================================================================================================
// =============================================================================================================================
void main(void)
{
// =============================================================================================================================
// ---------------------------------------------- Declare your local variables here -------------------------------------------- 
// =============================================================================================================================
unsigned char Vitesse;				// Vitesse de dplacement du servo          
unsigned int tempo;                 // Attente entre deux transmission : doit tre > 20ms 
unsigned int i;						// Variable de boucle 

// -----------------------------------------------------------------------------------------------------------------------------
// Messages pour les composants I2C de la carte SISI
// =============================================================================================================================
// 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 	   		Nom 				       						Description 
// ----------------------------------------------------------------------------------------------------------------------------- 
unsigned char Frame_I2C_LED_Switching[]={Add_LED_I2C,0x00}; 	// Trame de commande des LEDs {SLA+W=0x40, Data : Led_On=0
																// or Off=1}. Initialisation = All On.  
// ============================================================================================================================= 
// 2) Messages pour le LCD I2C BATRON de la carte S_ISI
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 	   		Nom 				       						Description 
// ----------------------------------------------------------------------------------------------------------------------------- 
// =============================================================================================================================
// 3) Messages prdfinis pour la carte SD21 
// ============================================================================================================================= 
// 30) Initialisation 
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// 31) Trame de commande des servos
// ----------------------------------------------------------------------------------------------------------------------------- 
// Cette trame est compose de: {@SD21, NumServo, RegSpeedValue, RegPosLByte, RegPosHByte}
unsigned char Frame_I2C_Servo[]={SD21_ADD_BASE_W,Servo1,0,0xE8,0x03};		 

// Dtail du contenu de la "trame I2C Servo" 
// @SD21			  SLA+W = 0xC2: Adresse de la carte SD21 en criture
// NumServo			  N du registre vitesse du servo  commander, dfinit dans SD21.h (Servo1 par dfaut)
// RegSpeedValue	  Valeur  placer dans le le registre vitesse (Vitesse maxi par dfaut)
// RegPosLByte		  Octet de poids faible du mot de commande de la position (Position mini par dfaut)
// RegPosHByte		  Octet de poids fort du mot de commande de la position 
// -----------------------------------------------------------------------------------------------------------------------------
// 32) Lecture des registres de la carte SD21
// -----------------------------------------------------------------------------------------------------------------------------
// ============================================================================================================================= 
// =============================================================================================================================
// Variables diverses
// ----------------------------------------------------------------------------------------------------------------------------- 
// Type 		Nom 				       Description 
// -----------------------------------------------------------------------------------------------------------------------------    
// 1) Gestion de la carte SD21
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// 2) Gestion du LCD BATRON de la carte Sisi
// -----------------------------------------------------------------------------------------------------------------------------
 // ----------------------------------------------------------------------------------------------------------------------------- 
// 3) Gestion des BP de la carte Sisi
// -----------------------------------------------------------------------------------------------------------------------------
// *****************************************************************************************************************************

// =============================================================================================================================
// ===================================================== Initialisations =======================================================
// =============================================================================================================================
TWI_Master_Initialise(); 			// Initialisation de l'interface TWI en mode Standby                                        
// -----------------------------------------------------------------------------------------------------------------------------
// Global enable interrupts
#asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI			
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// Initialisation de l'afficheur I2C BATRON 
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// Affichage d'un message d'accueil
// -----------------------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------------------------
// Initialisations des paramettres de la marche du robot !!!!!!!!!!!!!!!!!!!!
// ----------------------------------------------------------------------------------------------------------------------------- 
Vitesse = 0; 		// Vitesse servo = max		
tempo = 1000;
// Initialisation des registres de la carte SD21
// -----------------------------------------------------------------------------------------------------------------------------
// Position initial du servo1
RegSpeedValue = Vitesse; RegPosLByte= 0xE8; RegPosHByte=0x03;  					// 1000s = 03E8h
TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));			// Vitesse, LSByte, MSByte                           
delay_ms(5000);                                                                                                                
// =============================================================================================================================
// ================================================ Boucle principale ==========================================================
// ============================================================================================================================= 
// Pour info
// 1000 = 3E8h	valeur min
// 1250 = 4E2h
// 1500 = 5DCh
// 1750 = 6D6h 
// 1950 = 7E9h et + ?
// -----------------------------------------------------------------------------------------------------------------------------
// Les valeurs n Servo + Position transmises  la carte SD21 par le bus I2C  doivent tre places dans les tableaux situs
// dans le fichier "Table_Rob.c"
// Le nom des servos est dclar dans le fichier sd21.h
 
while (1)
  { 
   // Configuration des paramtres "Servox" [0<x<5] et "position" envoys aux servos 
   for(i=0; i<sizeof(Tab_Servo); i++)
   {
    // Configuration de la trame "Frame_I2C_Servo" avec les valeurs contenues dans les tableaux situs dans 
    // le fichier Table_Rob.c
    NumServo = Tab_Servo[i]; RegPosLByte = LSBYTE(Tab_Position[i]);  RegPosHByte = MSBYTE(Tab_Position[i]); 
     	
	// Envoi de la trame  "Frame_I2C_Servo"  la carte SD21
	TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));	      
	
	// Visualisation de la position des valeurs dans les tableaux sur les Leds de la carte Sisi
	Frame_I2C_LED_Switching[1] = i;
	TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
	delay_ms(tempo);   
   } // fin du for      
   
  } // fin du while  
  
} // fin du main

