
;CodeVisionAVR C Compiler V2.04.5b Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _twi_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x3:
	.DB  0xF8

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _TWI_state_G000
	.DW  _0x3*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*==============================================================================
;Nom du fichier: DriverTWICV2.c
;Auteur: Philippe MARIANO
;
;Rle: DRIVER TWI
;Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;et dcrites dans la note d'application AVR315, adaptes au
;cross compilateur CVAVR V2.
;
;Cr le 23/01/2010
;Dernire rvision le 14/11/2010
;
;Cross compilateur utilis: CodeVisionAVR V2
;Composant cible : Atmel 8 bits (ATMega8535)
;
;Remarque !!!!!!!!!!!:
;Ce fichier est destin  un projet CVAVR utilisant la carte SISI
;Il doit tre plac dans le rpertoire du projet avec le fichier DriverTWICV2.h
;================================================================================*/
;
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include "DriverTWICV2.h"
;
;// Declare your global variables here
;//-----------------------------------------------------------------------------------------------------------------------------
;static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.
;static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
;static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE

	.DSEG
;
;union TWI_STR                      					// Status byte holding flags.
;{
;    unsigned char all;
;    unsigned char lastTransOK:1;
;    unsigned char unusedBits:7;
;} TWI_statusReg ={0};
;//-----------------------------------------------------------------------------------------------------------------------------
;
;//-----------------------------------------------------------------------------------------------------------------------------
;// Fonctions du drivers TWI
;//-----------------------------------------------------------------------------------------------------------------------------
;void TWI_Master_Initialise(void)
; 0000 002B {                                               // --------------------- Adapte pour CVAVR V2 -----------------------

	.CSEG
_TWI_Master_Initialise:
; 0000 002C   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
; 0000 002D // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
; 0000 002E   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
; 0000 002F   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 0030   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
; 0000 0031                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
; 0000 0032                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
; 0000 0033                                          		// 0<<TWWC);
; 0000 0034 }
	RET
;//-----------------------------------------------------------------------------------------------------------------------------
;unsigned char TWI_Transceiver_Busy(void)
; 0000 0037 {                                               // --------------------- Adapte pour CVAVR V2 -----------------------
_TWI_Transceiver_Busy:
; 0000 0038   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
; 0000 0039 }
;//-----------------------------------------------------------------------------------------------------------------------------
;void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
; 0000 003C {
_TWI_Start_Transc_With_Data:
; 0000 003D   unsigned char temp;
; 0000 003E                                                 // --------------------- Adapte pour CVAVR V2 -----------------------
; 0000 003F   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	ST   -Y,R17
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> R17
_0x4:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x4
; 0000 0040 
; 0000 0041   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G000,R30
; 0000 0042   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	STS  _TWI_buf_G000,R30
; 0000 0043   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	ANDI R30,LOW(0x1)
	BRNE _0x7
; 0000 0044   {												// If it is a write operation, then also copy data.
; 0000 0045     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R17,LOW(1)
_0x9:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0xA
; 0000 0046       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x0
	MOVW R0,R30
	RCALL SUBOPT_0x1
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x9
_0xA:
; 0000 0047 }
; 0000 0048   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x7:
	LDI  R30,LOW(0)
	STS  _TWI_statusReg,R30
; 0000 0049   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G000,R30
; 0000 004A   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
; 0000 004B                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
; 0000 004C                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
; 0000 004D                                       			// (0<<TWWC);
; 0000 004E }
	RJMP _0x2000001
;//-----------------------------------------------------------------------------------------------------------------------------
;unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
; 0000 0051 {
_TWI_Get_Data_From_Transceiver:
; 0000 0052   unsigned char i;                              // --------------------- Adapte pour CVAVR V2 -----------------------
; 0000 0053 
; 0000 0054   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	ST   -Y,R17
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> R17
_0xB:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0xB
; 0000 0055 
; 0000 0056   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	BREQ _0xE
; 0000 0057   {
; 0000 0058     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	LDI  R17,LOW(0)
_0x10:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x11
; 0000 0059     {
; 0000 005A       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x0
	LD   R30,Z
	ST   X,R30
; 0000 005B     }
	SUBI R17,-1
	RJMP _0x10
_0x11:
; 0000 005C   }
; 0000 005D   return( TWI_statusReg.lastTransOK );
_0xE:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
_0x2000001:
	LDD  R17,Y+0
	ADIW R28,4
	RET
; 0000 005E }
;//-----------------------------------------------------------------------------------------------------------------------------
;
;// ----------------------------------------------------------------------------------------------------------------------------
;// Interruption TWI
;// ----------------------------------------------------------------------------------------------------------------------------
;interrupt [TWI] void twi_isr(void)      		// --------------------- Adapte pour CVAVR V2 -----------------------
; 0000 0065 {												// #pragma vector=TWI_vect
_twi_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0066 												// __interrupt void TWI_ISR(void)
; 0000 0067   static unsigned char TWI_bufPtr;
; 0000 0068 
; 0000 0069   switch (TWSR)
	IN   R30,0x1
; 0000 006A   {
; 0000 006B     case TWI_START:             				// START has been transmitted
	CPI  R30,LOW(0x8)
	BREQ _0x16
; 0000 006C 
; 0000 006D     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x17
_0x16:
; 0000 006E       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	LDI  R30,LOW(0)
	STS  _TWI_bufPtr_S0000004000,R30
; 0000 006F 
; 0000 0070     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received
	RJMP _0x18
_0x17:
	CPI  R30,LOW(0x18)
	BRNE _0x19
_0x18:
; 0000 0071 
; 0000 0072     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x1A
_0x19:
	CPI  R30,LOW(0x28)
	BRNE _0x1B
_0x1A:
; 0000 0073       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G000
	LDS  R26,_TWI_bufPtr_S0000004000
	CP   R26,R30
	BRSH _0x1C
; 0000 0074       {
; 0000 0075         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x2
	LD   R30,Z
	OUT  0x3,R30
; 0000 0076         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x2D
; 0000 0077         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
; 0000 0078                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|
; 0000 0079                						  			// (0<<TWWC);
; 0000 007A       }
; 0000 007B       else                    					// Send STOP after last byte
_0x1C:
; 0000 007C       {
; 0000 007D         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x3
; 0000 007E          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 007F         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x2D:
	OUT  0x36,R30
; 0000 0080         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
; 0000 0081                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
; 0000 0082                                				  	// (0<<TWWC);
; 0000 0083       }
; 0000 0084     break;
	RJMP _0x14
; 0000 0085 
; 0000 0086     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x1B:
	CPI  R30,LOW(0x50)
	BRNE _0x1E
; 0000 0087       TWI_buf[TWI_bufPtr++] = TWDR;
	RCALL SUBOPT_0x2
	MOVW R26,R30
	IN   R30,0x3
	ST   X,R30
; 0000 0088 
; 0000 0089     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x1F
_0x1E:
	CPI  R30,LOW(0x40)
	BRNE _0x20
_0x1F:
; 0000 008A       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G000
	SUBI R30,LOW(1)
	LDS  R26,_TWI_bufPtr_S0000004000
	CP   R26,R30
	BRSH _0x21
; 0000 008B       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 008C         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x2E
; 0000 008D         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
; 0000 008E                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
; 0000 008F                                   				// (0<<TWWC);
; 0000 0090       } else                    				// Send NACK after next reception
_0x21:
; 0000 0091       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 0092         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x2E:
	OUT  0x36,R30
; 0000 0093         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
; 0000 0094                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
; 0000 0095                                 			  	// (0<<TWWC);
; 0000 0096       }
; 0000 0097     break;
	RJMP _0x14
; 0000 0098 
; 0000 0099     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x20:
	CPI  R30,LOW(0x58)
	BRNE _0x23
; 0000 009A       TWI_buf[TWI_bufPtr] = TWDR;
	LDS  R26,_TWI_bufPtr_S0000004000
	LDI  R27,0
	SUBI R26,LOW(-_TWI_buf_G000)
	SBCI R27,HIGH(-_TWI_buf_G000)
	IN   R30,0x3
	ST   X,R30
; 0000 009B       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully.
	RCALL SUBOPT_0x3
; 0000 009C       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 009D       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x2F
; 0000 009E                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
; 0000 009F                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
; 0000 00A0                               					// (0<<TWWC);
; 0000 00A1     break;
; 0000 00A2 
; 0000 00A3     case TWI_ARB_LOST:          				// Arbitration lost
_0x23:
	CPI  R30,LOW(0x38)
	BRNE _0x24
; 0000 00A4     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 00A5       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x2F
; 0000 00A6                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
; 0000 00A7                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
; 0000 00A8                               					// (0<<TWWC);
; 0000 00A9     break;
; 0000 00AA 
; 0000 00AB     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0x24:
	CPI  R30,LOW(0x20)
	BREQ _0x26
; 0000 00AC     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received
_0x26:
; 0000 00AD     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
_0x27:
_0x28:
; 0000 00AE //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
; 0000 00AF     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition
; 0000 00B0 
; 0000 00B1     default:
; 0000 00B2       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G000,R30
; 0000 00B3       											// Reset TWI Interface
; 0000 00B4                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
; 0000 00B5       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x2F:
	OUT  0x36,R30
; 0000 00B6                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
; 0000 00B7                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
; 0000 00B8                               					// (0<<TWWC);
; 0000 00B9   }
_0x14:
; 0000 00BA }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;/****************************************************************
;Project : PPE Robot Solaire
;Version : 1
;// --------------------------------------------------------------
;Fichier source : MainTXWI2V2.c
;Date de  cration : 05/07/2009
;Mise  jour le : 14/11/2010
;// --------------------------------------------------------------
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin 18000 BOURGES
;// --------------------------------------------------------------
;Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
;(Adaptation de la note d'application AVR315 d'ATMEL)
;Transfert de l'tat des BP sur les LEDs de la carte (PCF8574)
;// --------------------------------------------------------------
;Cross compilateur: CVAVR 2.04.5b
;// --------------------------------------------------------------
;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 512
;****************************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;// =============================================================================================================================
;// Bibliothques  rajouter
;// -----------------------------------------------------------------------------------------------------------------------------
;#include <delay.h>
;#include "DriverTWICV2.h"    // Fonctions du drivers TWI adaptes pour CVAVR
;
;// ----------------------------------------------------------------------------------------------------------
;// Boucle principale
;// ----------------------------------------------------------------------------------------------------------
;void main(void)
; 0001 0025 {

	.CSEG
_main:
; 0001 0026 // -----------------------------------------------------------------------------------------------------------------------------
; 0001 0027 // -----------------------------------------------------------------------------------------------------------------------------
; 0001 0028 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
; 0001 0029 // -----------------------------------------------------------------------------------------------------------------------------
; 0001 002A // Type             Nom                                                     Description
; 0001 002B // -----------------------------------------------------------------------------------------------------------------------------
; 0001 002C char Frame_I2C_LED_Switching[]={0x40,0x00};           // Trame de commande des LED {addLed + W (0x40), data = Led on=0}
; 0001 002D char Frame_I2C_LED_All_Off[]={0x40,0xff};             // Trame d'extinction des LED {addLed + W (ox40), data = all Led off}
; 0001 002E char Frame_I2C_BP_Read[]={0x43,0x00};                 // Trame de lecture des BP {addBP + R (0x43), data=nothing}
; 0001 002F // =============================================================================================================================
; 0001 0030 
; 0001 0031 // =============================================================================================================================
; 0001 0032 // Initialisation
; 0001 0033 // -----------------------------------------------------------------------------------------------------------------------------
; 0001 0034 TWI_Master_Initialise(); 	                          // Initialisation de l'interface TWI en mode Standby
	SBIW R28,6
	LDI  R30,LOW(67)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	LDI  R30,LOW(64)
	STD  Y+2,R30
	LDI  R30,LOW(255)
	STD  Y+3,R30
	LDI  R30,LOW(64)
	STD  Y+4,R30
	LDI  R30,LOW(0)
	STD  Y+5,R30
;	Frame_I2C_LED_Switching -> Y+4
;	Frame_I2C_LED_All_Off -> Y+2
;	Frame_I2C_BP_Read -> Y+0
	RCALL _TWI_Master_Initialise
; 0001 0035 // -----------------------------------------------------------------------------------------------------------------------------
; 0001 0036 // Global enable interrupts
; 0001 0037 #asm("sei")
	sei
; 0001 0038 // -----------------------------------------------------------------------------------------------------------------------------
; 0001 0039 // Extinction des LEDs de la carte S_ISI
; 0001 003A TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off));
	MOVW R30,R28
	ADIW R30,2
	RCALL SUBOPT_0x4
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0001 003B // -----------------------------------------------------------------------------------------------------------------------------
; 0001 003C 
; 0001 003D while (1)
_0x20003:
; 0001 003E       {
; 0001 003F // -----------------------------------------  Champ Lecture des donnes ---------------------------------------------------------
; 0001 0040 // Lecture de l'tat des BP
; 0001 0041         TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);      	// Envoi de l'octet d'adresse des BP + bit RW=lecture(0x43)
	MOVW R30,R28
	RCALL SUBOPT_0x4
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0001 0042         TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));// TWI_Get_Data_From_Transceiver(Donnee_BP,2);
	MOVW R30,R28
	RCALL SUBOPT_0x4
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
; 0001 0043 // -----------------------------------------  Champ Traitement ------------------------------------------------------------------
; 0001 0044         Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	LDD  R30,Y+1
	COM  R30
	STD  Y+5,R30
; 0001 0045 // -----------------------------------------  Champ Ecriture des rsultats  -----------------------------------------------------
; 0001 0046 // Ecriture sur les LED
; 0001 0047         TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  // Les LED affichent l'tat des BP
	MOVW R30,R28
	ADIW R30,4
	RCALL SUBOPT_0x4
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
; 0001 0048         delay_ms(200);					// Lecture des BP toutes les 200ms
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x4
	RCALL _delay_ms
; 0001 0049       };
	RJMP _0x20003
; 0001 004A }
_0x20006:
	RJMP _0x20006
;// =============================================================================================================================
;// *****************************************************************************************************************************
;
;
;

	.DSEG
_TWI_msgSize_G000:
	.BYTE 0x1
_TWI_buf_G000:
	.BYTE 0x14
_TWI_state_G000:
	.BYTE 0x1
_TWI_statusReg:
	.BYTE 0x1
_TWI_bufPtr_S0000004000:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G000)
	SBCI R31,HIGH(-_TWI_buf_G000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x2:
	LDS  R30,_TWI_bufPtr_S0000004000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S0000004000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G000)
	SBCI R31,HIGH(-_TWI_buf_G000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
