
;CodeVisionAVR C Compiler V2.04.5b Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Texte_Accueil_Ligne1=R4
	.DEF _Texte_Accueil_Ligne2=R6
	.DEF _TexteTestBpsurLed=R8
	.DEF _Ligne1ChoixEchap=R10
	.DEF _BpPlusSurD0=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _twi_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  LOW(_0x0*2+85),HIGH(_0x0*2+85)
_0x4:
	.DB  LOW(_0x0*2+102),HIGH(_0x0*2+102)
_0x5:
	.DB  LOW(_0x0*2+119),HIGH(_0x0*2+119)
_0x6:
	.DB  LOW(_0x0*2+136),HIGH(_0x0*2+136)
_0x7:
	.DB  LOW(_0x0*2+153),HIGH(_0x0*2+153)
_0x8:
	.DB  LOW(_0x0*2+170),HIGH(_0x0*2+170)
_0x9:
	.DB  LOW(_0x0*2+187),HIGH(_0x0*2+187)
_0x1F:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+17),HIGH(_0x0*2+17),LOW(_0x0*2+34),HIGH(_0x0*2+34),LOW(_0x0*2+51),HIGH(_0x0*2+51)
	.DB  LOW(_0x0*2+68),HIGH(_0x0*2+68)
_0x0:
	.DB  0x20,0x20,0x20,0x50,0x50,0x45,0x20,0x52
	.DB  0x6F,0x62,0x73,0x6F,0x6C,0x20,0x20,0x20
	.DB  0x0,0x20,0x54,0x57,0x49,0x32,0x56,0x32
	.DB  0x42,0x41,0x54,0x62,0x69,0x73,0x2E,0x63
	.DB  0x20,0x0,0x52,0x65,0x63,0x6F,0x70,0x69
	.DB  0x65,0x20,0x42,0x70,0x2D,0x3E,0x4C,0x65
	.DB  0x64,0x20,0x0,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0,0x2B,0x20,0x2D,0x3E
	.DB  0x20,0x44,0x30,0x20,0x5B,0x45,0x63,0x68
	.DB  0x61,0x70,0x5D,0x20,0x0,0x46,0x48,0x2D
	.DB  0x3E,0x20,0x44,0x31,0x20,0x5B,0x45,0x63
	.DB  0x68,0x61,0x70,0x5D,0x20,0x0,0x46,0x42
	.DB  0x2D,0x3E,0x20,0x44,0x32,0x20,0x5B,0x45
	.DB  0x63,0x68,0x61,0x70,0x5D,0x20,0x0,0x2D
	.DB  0x20,0x2D,0x3E,0x20,0x44,0x33,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x70,0x5D,0x20,0x0
	.DB  0x53,0x45,0x54,0x2D,0x3E,0x44,0x34,0x20
	.DB  0x5B,0x45,0x63,0x68,0x61,0x70,0x5D,0x20
	.DB  0x0,0x4F,0x6B,0x2D,0x3E,0x20,0x44,0x35
	.DB  0x20,0x5B,0x45,0x63,0x68,0x61,0x70,0x5D
	.DB  0x20,0x0,0x45,0x4E,0x54,0x2D,0x3E,0x44
	.DB  0x36,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x5D,0x20,0x0,0x45,0x43,0x48,0x2D,0x3E
	.DB  0x44,0x37,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0
_0x2040003:
	.DB  0xF8
_0x2060003:
	.DB  0x76,0x0,0x34,0xD,0x6,0x35,0x4,0x10
	.DB  0x42,0x9F,0x34,0x83,0x2
_0x2060013:
	.DB  0x76,0x40,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0x0
_0x2080003:
	.DB  0x1

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  _BpFlecheHSurD1
	.DW  _0x3*2

	.DW  0x02
	.DW  _BpFlecheHSurD2
	.DW  _0x4*2

	.DW  0x02
	.DW  _BpMoinsSurD3
	.DW  _0x5*2

	.DW  0x02
	.DW  _BpSetSurD4
	.DW  _0x6*2

	.DW  0x02
	.DW  _BpOkSurD5
	.DW  _0x7*2

	.DW  0x02
	.DW  _BpEntrSurD6
	.DW  _0x8*2

	.DW  0x02
	.DW  _BpEchSurD7
	.DW  _0x9*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x1F*2

	.DW  0x01
	.DW  _TWI_state_G102
	.DW  _0x2040003*2

	.DW  0x01
	.DW  _Etat_BP_I2C_S1040000000
	.DW  _0x2080003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/****************************************************************
;Project : PPE Robot Solaire
;Version : 1
;// --------------------------------------------------------------
;Fichier source : TWI2V2BATRONbis.c
;Date de  cration : 05/07/2009
;Mise  jour le : 14/11/2010
;// --------------------------------------------------------------
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin 18000 BOURGES
;// --------------------------------------------------------------
;Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
;(Adaptation de la note d'application AVR315 d'ATMEL)
;Transfert de l'tat des BP sur les LEDs de la carte (PCF8574)
;Affichage du nom du BP actionn
;// --------------------------------------------------------------
;Cross compilateur: CVAVR 2.04.5b
;// --------------------------------------------------------------
;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 128
;****************************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;// =============================================================================================================================
;// Bibliothques  rajouter
;// -----------------------------------------------------------------------------------------------------------------------------
;#include <string.h>				// Fonction de traitement des chanes de caractres
;#include <delay.h>
;#include <stdio.h>				// Fonction sprintf
;#include "DriverTWICV2.h"       // Fonctions du drivers TWI adaptes pour CVAVR
;                                // ATTENTION: Vrifier que la taille du buffer est adapte au message (20 par dfaut)
;#include "LCDBATRON.h"          // Fonctions de l'afficheur I2C LCD
;#include "SISISOL.h"            // Fonction LIRE_BP_I2C()
;// =============================================================================================================================
;// Constantes
;// -----------------------------------------------------------------------------------------------------------------------------
;// Messages textuels prdfinis
;// -----------------------------------------------------------------------------------------------------------------------------
;flash char *Texte_Accueil_Ligne1    = "   PPE Robsol   ";
;flash char *Texte_Accueil_Ligne2    = " TWI2V2BATbis.c ";
;flash char *TexteTestBpsurLed	    = "Recopie Bp->Led ";
;flash char *Ligne1ChoixEchap		= "        [Echap] ";
;flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
;flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";

	.DSEG
;flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
;flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
;flash char *BpSetSurD4				= "SET->D4 [Echap] ";
;flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
;flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
;flash char *BpEchSurD7				= "ECH->D7 [Echap] ";
;// -----------------------------------------------------------------------------------------------------------------------------
;// =============================================================================================================================
;
;// =============================================================================================================================
;// Prototypes des fonctions en cours de test
;// -----------------------------------------------------------------------------------------------------------------------------
;// =============================================================================================================================
;
;// *****************************************************************************************************************************
;// *****************************************************************************************************************************
;// Programme principal
;// *****************************************************************************************************************************
;// *****************************************************************************************************************************
;void main(void)
; 0000 0045 {

	.CSEG
_main:
; 0000 0046 // =============================================================================================================================
; 0000 0047 // Declare your local variables here
; 0000 0048 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0049 // Divers variables
; 0000 004A // -----------------------------------------------------------------------------------------------------------------------------
; 0000 004B // Type 		    Nom 				                                    Description
; 0000 004C // -----------------------------------------------------------------------------------------------------------------------------
; 0000 004D bit BP_I2C=0, BP_I2C_1 = 1;
; 0000 004E // -----------------------------------------------------------------------------------------------------------------------------
; 0000 004F // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0050 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
; 0000 0051 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0052 // Type 		    Nom 				                                    Description
; 0000 0053 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0054 char Frame_I2C_LED_Switching[]={Add_LED_I2C_W,0x00}; 	// Trame de commande des LED {addLed + W (0x40), data = Led on=0}
; 0000 0055 char Frame_I2C_LED_All_Off[]={Add_LED_I2C_W,0xff}; 	    // Trame d'extinction des LED {addLed + W (ox40), data = all Led off}
; 0000 0056 char Frame_I2C_BP_Read[]={Add_BP_I2C_R,0x00}; 		    // Trame de lecture des BP {addBP + R (0x43), data=nothing}
; 0000 0057 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0058 // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
; 0000 0059 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 005A // Type 		    Nom 				                                    Description
; 0000 005B // -----------------------------------------------------------------------------------------------------------------------------
; 0000 005C // -----------------------------------------------------------------------------------------------------------------------------
; 0000 005D char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];// Reoivent les deux lignes de texte  envoyer  l'afficheur
; 0000 005E                                                         // (16 caractres max. + Nul)
; 0000 005F // =============================================================================================================================
; 0000 0060 
; 0000 0061 // =============================================================================================================================
; 0000 0062 // Initialisation
; 0000 0063 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0064 TWI_Master_Initialise(); 	                                  // Initialisation de l'interface TWI en mode Standby
	SBIW R28,40
	LDI  R30,LOW(67)
	STD  Y+34,R30
	LDI  R30,LOW(0)
	STD  Y+35,R30
	LDI  R30,LOW(64)
	STD  Y+36,R30
	LDI  R30,LOW(255)
	STD  Y+37,R30
	LDI  R30,LOW(64)
	STD  Y+38,R30
	LDI  R30,LOW(0)
	STD  Y+39,R30
;	BP_I2C -> R15.0
;	BP_I2C_1 -> R15.1
;	Frame_I2C_LED_Switching -> Y+38
;	Frame_I2C_LED_All_Off -> Y+36
;	Frame_I2C_BP_Read -> Y+34
;	Buffer_for_LCD_Line0 -> Y+17
;	Buffer_for_LCD_Line1 -> Y+0
	LDI  R30,LOW(2)
	MOV  R15,R30
	RCALL _TWI_Master_Initialise
; 0000 0065 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0066 // Global enable interrupts
; 0000 0067 #asm("sei")
	sei
; 0000 0068 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0069 // Extinction des LEDs de la carte S_ISI
; 0000 006A TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off));
	MOVW R30,R28
	ADIW R30,36
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	RCALL _TWI_Start_Transc_With_Data
; 0000 006B // -----------------------------------------------------------------------------------------------------------------------------
; 0000 006C // Initialisation de l'afficheur BATRON
; 0000 006D Init_LCD_I2C_BATRON();
	RCALL _Init_LCD_I2C_BATRON
; 0000 006E // -----------------------------------------------------------------------------------------------------------------------------
; 0000 006F // Affichage d'un message d'accueil
; 0000 0070 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0071 sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	RCALL SUBOPT_0x2
	ST   -Y,R5
	ST   -Y,R4
	RCALL SUBOPT_0x3
; 0000 0072 sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	RCALL SUBOPT_0x4
	ST   -Y,R7
	ST   -Y,R6
	RCALL SUBOPT_0x3
; 0000 0073 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
; 0000 0074 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x6
; 0000 0075 // =============================================================================================================================
; 0000 0076 
; 0000 0077 // =============================================================================================================================
; 0000 0078 // Boucle principale
; 0000 0079 // =============================================================================================================================
; 0000 007A while (1)
_0xA:
; 0000 007B       {
; 0000 007C // -----------------------------------------  Champ Lecture des donnes ---------------------------------------------------------
; 0000 007D // Lecture de l'tat des BP
; 0000 007E         TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);      	// Envoi de l'octet d'adresse des BP + bit RW=lecture(0x43)
	MOVW R30,R28
	ADIW R30,34
	RCALL SUBOPT_0x0
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x7
; 0000 007F         TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));   	// TWI_Get_Data_From_Transceiver(Donnee_BP,2);
	MOVW R30,R28
	ADIW R30,34
	RCALL SUBOPT_0x8
	RCALL _TWI_Get_Data_From_Transceiver
; 0000 0080         BP_I2C = Lire_BP_I2C();														// Lecture des BP avec gestion anti-rebond
	RCALL _Lire_BP_I2C
	RCALL __BSTB1
	BLD  R15,0
; 0000 0081 // -----------------------------------------  Champ Traitement ------------------------------------------------------------------
; 0000 0082         Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	LDD  R30,Y+35
	COM  R30
	STD  Y+39,R30
; 0000 0083 
; 0000 0084          if ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF))
	LDI  R26,0
	SBRC R15,0
	LDI  R26,1
	LDI  R30,0
	SBRC R15,1
	LDI  R30,1
	CP   R30,R26
	BREQ _0xE
	RJMP _0xF
_0xE:
	RJMP _0xD
_0xF:
; 0000 0085 				{
; 0000 0086 				 sprintf(Buffer_for_LCD_Line0,TexteTestBpsurLed);
	RCALL SUBOPT_0x2
	ST   -Y,R9
	ST   -Y,R8
	RCALL SUBOPT_0x3
; 0000 0087 
; 0000 0088 				 switch (BP_I2C)
	LDI  R30,0
	SBRC R15,0
	LDI  R30,1
; 0000 0089 				  {
; 0000 008A 				 	case ENTR_I2C : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
	CPI  R30,LOW(0x40)
	BRNE _0x13
	RCALL SUBOPT_0x4
	LDS  R30,_BpEntrSurD6
	LDS  R31,_BpEntrSurD6+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 008B 				 	case FlecheH_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
_0x13:
	CPI  R30,LOW(0x2)
	BRNE _0x14
	RCALL SUBOPT_0x4
	LDS  R30,_BpFlecheHSurD1
	LDS  R31,_BpFlecheHSurD1+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 008C 				 	case FlecheB_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
_0x14:
	CPI  R30,LOW(0x4)
	BRNE _0x15
	RCALL SUBOPT_0x4
	LDS  R30,_BpFlecheHSurD2
	LDS  R31,_BpFlecheHSurD2+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 008D 				 	case ECHAP_I2C : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
_0x15:
	CPI  R30,LOW(0x80)
	BRNE _0x16
	RCALL SUBOPT_0x4
	LDS  R30,_BpEchSurD7
	LDS  R31,_BpEchSurD7+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 008E 				 	case OK_I2C : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
_0x16:
	CPI  R30,LOW(0x20)
	BRNE _0x17
	RCALL SUBOPT_0x4
	LDS  R30,_BpOkSurD5
	LDS  R31,_BpOkSurD5+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 008F 				 	case MOINS_I2C: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
_0x17:
	CPI  R30,LOW(0x8)
	BRNE _0x18
	RCALL SUBOPT_0x4
	LDS  R30,_BpMoinsSurD3
	LDS  R31,_BpMoinsSurD3+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 0090 				 	case PLUS_I2C: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
_0x18:
	CPI  R30,LOW(0x1)
	BRNE _0x19
	RCALL SUBOPT_0x4
	ST   -Y,R13
	ST   -Y,R12
	RJMP _0x1E
; 0000 0091 				 	case SET_I2C: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
_0x19:
	CPI  R30,LOW(0x10)
	BRNE _0x1A
	RCALL SUBOPT_0x4
	LDS  R30,_BpSetSurD4
	LDS  R31,_BpSetSurD4+1
	RCALL SUBOPT_0x0
	RJMP _0x1E
; 0000 0092 				 	case NULL : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
_0x1A:
	CPI  R30,0
	BRNE _0x12
	RCALL SUBOPT_0x4
	ST   -Y,R11
	ST   -Y,R10
_0x1E:
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 0093 				  }
_0x12:
; 0000 0094 
; 0000 0095 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
; 0000 0096 					BP_I2C_1 = BP_I2C;
	BST  R15,0
	BLD  R15,1
; 0000 0097 			   	 }
; 0000 0098 
; 0000 0099         		if (BP_I2C == ECHAP_I2C)
_0xD:
; 0000 009A         		  {
; 0000 009B         			Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
; 0000 009C                     // Les LED affichent l'tat des BP
; 0000 009D         			TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
; 0000 009E         			delay_ms(1000);
; 0000 009F         		  }
; 0000 00A0 
; 0000 00A1 // -----------------------------------------  Champ Ecriture des rsultats  -----------------------------------------------------
; 0000 00A2 // Ecriture sur les LED
; 0000 00A3         TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  // Les LED affichent l'tat des BP
	MOVW R30,R28
	ADIW R30,38
	RCALL SUBOPT_0x8
	RCALL _TWI_Start_Transc_With_Data
; 0000 00A4         delay_ms(200);					// Lecture des BP toutes les 200ms
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x6
; 0000 00A5       };
	RJMP _0xA
; 0000 00A6 }
_0x1D:
	RJMP _0x1D
;// =============================================================================================================================
;// *****************************************************************************************************************************
;

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x9
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	RCALL SUBOPT_0x9
	ADIW R26,2
	RCALL SUBOPT_0xB
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x9
	RCALL __GETW1P
	TST  R31
	BRMI _0x2020014
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xB
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	RCALL SUBOPT_0x9
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	RCALL __LOADLOCR2
	RJMP _0x20C0003
__print_G101:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	RCALL SUBOPT_0xC
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	RCALL SUBOPT_0xC
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xD
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0xF
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	RCALL SUBOPT_0x13
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	RCALL SUBOPT_0x13
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x14
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x14
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x14
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	RCALL SUBOPT_0xC
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	RCALL SUBOPT_0x15
	LPM  R18,Z+
	RCALL SUBOPT_0x13
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	RCALL SUBOPT_0xC
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	RCALL SUBOPT_0x15
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	RCALL SUBOPT_0x15
	ADIW R30,2
	RCALL SUBOPT_0x13
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x14
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0xF
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	RCALL SUBOPT_0xC
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0xF
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x16
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0004
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x13
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x0
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	RCALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x0
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0004:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
_TWI_Master_Initialise:
	LDI  R30,LOW(32)
	OUT  0x0,R30
	LDI  R30,LOW(255)
	OUT  0x3,R30
	LDI  R30,LOW(4)
	OUT  0x36,R30
	RET
_TWI_Transceiver_Busy:
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
_TWI_Start_Transc_With_Data:
	ST   -Y,R17
_0x2040007:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2040007
	LDD  R30,Y+1
	STS  _TWI_msgSize_G102,R30
	RCALL SUBOPT_0x9
	LD   R30,X
	STS  _TWI_buf_G102,R30
	RCALL SUBOPT_0x9
	LD   R30,X
	ANDI R30,LOW(0x1)
	BRNE _0x204000A
	LDI  R17,LOW(1)
_0x204000C:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x204000D
	RCALL SUBOPT_0x17
	MOVW R0,R30
	RCALL SUBOPT_0x18
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x204000C
_0x204000D:
_0x204000A:
	LDI  R30,LOW(0)
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(248)
	STS  _TWI_state_G102,R30
	LDI  R30,LOW(165)
	OUT  0x36,R30
	LDD  R17,Y+0
	RJMP _0x20C0002
_TWI_Get_Data_From_Transceiver:
	ST   -Y,R17
_0x2040011:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2040011
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	BREQ _0x2040014
	LDI  R17,LOW(0)
_0x2040016:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x2040017
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x17
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x2040016
_0x2040017:
_0x2040014:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	LDD  R17,Y+0
	RJMP _0x20C0002
_twi_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	IN   R30,0x1
	CPI  R30,LOW(0x8)
	BREQ _0x204001C
	CPI  R30,LOW(0x10)
	BRNE _0x204001D
_0x204001C:
	LDI  R30,LOW(0)
	STS  _TWI_bufPtr_S1020006000,R30
	RJMP _0x204001E
_0x204001D:
	CPI  R30,LOW(0x18)
	BRNE _0x204001F
_0x204001E:
	RJMP _0x2040020
_0x204001F:
	CPI  R30,LOW(0x28)
	BRNE _0x2040021
_0x2040020:
	LDS  R30,_TWI_msgSize_G102
	LDS  R26,_TWI_bufPtr_S1020006000
	CP   R26,R30
	BRSH _0x2040022
	RCALL SUBOPT_0x19
	LD   R30,Z
	OUT  0x3,R30
	LDI  R30,LOW(133)
	RJMP _0x2040033
_0x2040022:
	RCALL SUBOPT_0x1A
_0x2040033:
	OUT  0x36,R30
	RJMP _0x204001A
_0x2040021:
	CPI  R30,LOW(0x50)
	BRNE _0x2040024
	RCALL SUBOPT_0x19
	MOVW R26,R30
	IN   R30,0x3
	ST   X,R30
	RJMP _0x2040025
_0x2040024:
	CPI  R30,LOW(0x40)
	BRNE _0x2040026
_0x2040025:
	LDS  R30,_TWI_msgSize_G102
	SUBI R30,LOW(1)
	LDS  R26,_TWI_bufPtr_S1020006000
	CP   R26,R30
	BRSH _0x2040027
	LDI  R30,LOW(197)
	RJMP _0x2040034
_0x2040027:
	LDI  R30,LOW(133)
_0x2040034:
	OUT  0x36,R30
	RJMP _0x204001A
_0x2040026:
	CPI  R30,LOW(0x58)
	BRNE _0x2040029
	LDS  R26,_TWI_bufPtr_S1020006000
	LDI  R27,0
	SUBI R26,LOW(-_TWI_buf_G102)
	SBCI R27,HIGH(-_TWI_buf_G102)
	IN   R30,0x3
	ST   X,R30
	RCALL SUBOPT_0x1A
	RJMP _0x2040035
_0x2040029:
	CPI  R30,LOW(0x38)
	BRNE _0x204002A
	LDI  R30,LOW(165)
	RJMP _0x2040035
_0x204002A:
	CPI  R30,LOW(0x20)
	BREQ _0x204002C
_0x204002C:
_0x204002D:
_0x204002E:
	IN   R30,0x1
	STS  _TWI_state_G102,R30
	LDI  R30,LOW(4)
_0x2040035:
	OUT  0x36,R30
_0x204001A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI

	.CSEG
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x2060003*2)
	LDI  R31,HIGH(_0x2060003*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0x4
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x7
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x2060005
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x2060006
_0x2060005:
	RJMP _0x2060004
_0x2060006:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x206000A
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	RJMP _0x2060017
_0x206000A:
	CPI  R30,LOW(0x1)
	BRNE _0x2060009
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
_0x2060017:
	STD  Y+2,R30
_0x2060009:
_0x2060004:
	RCALL SUBOPT_0x4
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x7
_0x20C0003:
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	RCALL __SAVELOCR6
	__GETWRS 18,19,8
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,2
	MOVW R20,R30
	__GETWRN 16,17,0
_0x206000D:
	RCALL SUBOPT_0x15
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x206000E
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5B)
	BRNE _0x206000F
	MOVW R26,R20
	LDI  R30,LOW(138)
	RJMP _0x2060018
_0x206000F:
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5D)
	BRNE _0x2060011
	MOVW R26,R20
	LDI  R30,LOW(84)
	RJMP _0x2060018
_0x2060011:
	MOVW R26,R18
	LD   R30,X
	SUBI R30,-LOW(128)
	MOVW R26,R20
_0x2060018:
	ST   X,R30
	__ADDWRN 18,19,1
	__ADDWRN 20,21,1
	__ADDWRN 16,17,1
	RJMP _0x206000D
_0x206000E:
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR6
	ADIW R28,12
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,19
	LDI  R24,19
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x2060013*2)
	LDI  R31,HIGH(_0x2060013*2)
	RCALL __INITLOCB
	ST   -Y,R17
	LDI  R17,LOW(0)
_0x2060015:
	CPI  R17,2
	BRSH _0x2060016
	RCALL SUBOPT_0x1B
	ST   -Y,R17
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	SUBI R17,-1
	RJMP _0x2060015
_0x2060016:
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x1C
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x0
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1B
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL SUBOPT_0x1C
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x0
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x1E
	LDD  R17,Y+0
	ADIW R28,24
	RET

	.CSEG
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R30,LOW(67)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x1F
	RCALL _TWI_Start_Transc_With_Data
	RCALL SUBOPT_0x1F
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	LDS  R30,_Etat_BP_I2C_S1040000000
	LDS  R31,_Etat_BP_I2C_S1040000000+1
	SBIW R30,0
	BRNE _0x2080007
	CPI  R16,0
	BRNE _0x2080008
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x1F
	RCALL _TWI_Start_Transc_With_Data
	RCALL SUBOPT_0x1F
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x2080009
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _Etat_BP_I2C_S1040000000,R30
	STS  _Etat_BP_I2C_S1040000000+1,R31
	LDI  R30,LOW(0)
	RJMP _0x20C0001
_0x2080009:
	LDI  R30,LOW(255)
	RJMP _0x20C0001
_0x2080008:
	LDI  R30,LOW(255)
	RJMP _0x20C0001
_0x2080007:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2080006
	CPI  R16,0
	BREQ _0x208000D
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x1F
	RCALL _TWI_Start_Transc_With_Data
	RCALL SUBOPT_0x1F
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x208000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_I2C_S1040000000,R30
	STS  _Etat_BP_I2C_S1040000000+1,R30
	MOV  R30,R16
	RJMP _0x20C0001
_0x208000E:
	LDI  R30,LOW(0)
	RJMP _0x20C0001
_0x208000D:
	LDI  R30,LOW(0)
_0x2080006:
_0x20C0001:
	RCALL __LOADLOCR2
_0x20C0002:
	ADIW R28,4
	RET

	.CSEG

	.DSEG
_BpFlecheHSurD1:
	.BYTE 0x2
_BpFlecheHSurD2:
	.BYTE 0x2
_BpMoinsSurD3:
	.BYTE 0x2
_BpSetSurD4:
	.BYTE 0x2
_BpOkSurD5:
	.BYTE 0x2
_BpEntrSurD6:
	.BYTE 0x2
_BpEchSurD7:
	.BYTE 0x2
_TWI_msgSize_G102:
	.BYTE 0x1
_TWI_buf_G102:
	.BYTE 0x14
_TWI_state_G102:
	.BYTE 0x1
_TWI_statusReg:
	.BYTE 0x1
_TWI_bufPtr_S1020006000:
	.BYTE 0x1
_Etat_BP_I2C_S1040000000:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 66 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	MOVW R30,R28
	ADIW R30,17
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x4:
	MOVW R30,R28
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	MOVW R30,R28
	ADIW R30,2
	RCALL SUBOPT_0x0
	RJMP _Displ_2Lines_On_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8:
	RCALL SUBOPT_0x0
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xC:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x0
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xF:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	RCALL SUBOPT_0x0
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	RCALL SUBOPT_0xD
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x17:
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G102)
	SBCI R31,HIGH(-_TWI_buf_G102)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x9
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x19:
	LDS  R30,_TWI_bufPtr_S1020006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1020006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G102)
	SBCI R31,HIGH(-_TWI_buf_G102)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1C:
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1D:
	MOVW R30,R28
	ADIW R30,3
	RCALL SUBOPT_0x0
	RCALL _strlen
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1E:
	RCALL SUBOPT_0x0
	RCALL _strlen
	RCALL SUBOPT_0x0
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	RCALL SUBOPT_0x0
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1F:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x6


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__BSTB1:
	CLT
	TST  R30
	BREQ PC+2
	SET
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
