
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void TWI_Master_Initialise(void);

unsigned char TWI_Transceiver_Busy(void);

unsigned char TWI_Get_State_Info( void );

void TWI_Start_Transc_With_Data( unsigned char *message, unsigned char messageSize );

void TWI_Start_Transceiver( void );

unsigned char TWI_Get_Data_From_Transceiver( unsigned char *message, unsigned char messageSize );

interrupt [18] void twi_isr(void);

#pragma used-

#pragma library DriverTWICV2.lib

#pragma used+

void Init_LCD_I2C_BATRON(void);

void LCD_I2C_BATRON_gotoxy(unsigned char x, unsigned char y);

void Built_Strng_Fram_I2C_LCDBATRON(unsigned char *FrameI2C, unsigned char *Tstring, int Tstringsize);

void Displ_2Lines_On_I2C_LCDBATRON(unsigned char *Buffer_for_LCD_Line0, unsigned char *Buffer_for_LCD_Line1);

void Display_Arrow_0n_I2C_LCDBATRON(void);

#pragma used-

#pragma library LCDBATRON.lib

unsigned char Lire_BP_I2C(void);

#pragma used-

#pragma library SISISOL.lib

flash char *Texte_Accueil_Ligne1    = "   PPE Robsol   ";
flash char *Texte_Accueil_Ligne2    = " TWI2V2BATbis.c ";
flash char *TexteTestBpsurLed	    = "Recopie Bp->Led ";
flash char *Ligne1ChoixEchap		= "        [Echap] ";
flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
flash char *BpSetSurD4				= "SET->D4 [Echap] ";
flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
flash char *BpEchSurD7				= "ECH->D7 [Echap] ";

void main(void)
{

bit BP_I2C=0, BP_I2C_1 = 1;

char Frame_I2C_LED_Switching[]={0x40    ,0x00}; 	
char Frame_I2C_LED_All_Off[]={0x40    ,0xff}; 	    
char Frame_I2C_BP_Read[]={0x43  	,0x00}; 		    

char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];

TWI_Master_Initialise(); 	                                  

#asm("sei")

TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off));

Init_LCD_I2C_BATRON();

sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
delay_ms(4000);

while (1)
{

TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);      	
TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));   	
BP_I2C = Lire_BP_I2C();														

Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];

if ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF))
{
sprintf(Buffer_for_LCD_Line0,TexteTestBpsurLed);

switch (BP_I2C)
{
case 64 : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
case 2 : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
case 4 : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
case 128 : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
case 32 : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
case 8: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
case 1: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
case 16: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
}

Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
BP_I2C_1 = BP_I2C;
}

if (BP_I2C == 128)
{
Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];

TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
delay_ms(1000);
}

TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  
delay_ms(200);					
};
}

