
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float ftrunc(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

void TWI_Master_Initialise(void);

unsigned char TWI_Transceiver_Busy(void);

unsigned char TWI_Get_State_Info( void );

void TWI_Start_Transc_With_Data( unsigned char *message, unsigned char messageSize );

void TWI_Start_Transceiver( void );

unsigned char TWI_Get_Data_From_Transceiver( unsigned char *message, unsigned char messageSize );

interrupt [18] void twi_isr(void);

#pragma used-

#pragma library DriverTWICV2.lib

#pragma used+

unsigned char LSBYTE(int value);

unsigned char MSBYTE(int value);

#pragma used-

#pragma library Stdmno.lib

#pragma used+

void Init_LCD_I2C_BATRON(void);

void LCD_I2C_BATRON_gotoxy(unsigned char x, unsigned char y);

void Built_Strng_Fram_I2C_LCDBATRON(unsigned char *FrameI2C, unsigned char *Tstring, int Tstringsize);

void Displ_2Lines_On_I2C_LCDBATRON(unsigned char *Buffer_for_LCD_Line0, unsigned char *Buffer_for_LCD_Line1);

void Display_Arrow_0n_I2C_LCDBATRON(void);

#pragma used-

#pragma library LCDBATRON.lib

unsigned char Lire_BP_I2C(void);

#pragma used-

#pragma library SISISOL.lib

flash unsigned char Tab_Servo[]={
0		, 	
3		, 	
6		, 
9		 

};  

flash unsigned int Tab_Position[]={
800, 	
1000,	
1500,
2000

};

flash char *Texte_Accueil_Ligne1 	= "   Test SISI    ";
flash char *Texte_Accueil_Ligne2 	= "  [TWI141210]   ";
flash char *TexteMenuLedBp			= "1 Test BP->Led  ";
flash char *TexteMenuMD23			= "2 Test MD23     ";
flash char *TexteMenuSD21			= "3 Test SD21     ";
flash char *Ligne0MenuMode			= "21 Choix Modes  ";
flash char *Ligne0MenuInfos			= "22 Aff Infos    ";
flash char *TexteTestSD21           = "Cde Servo 1->4  ";
flash char *TexteTest1BpsurLed	    = "Recopie Bp->Led ";
flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
flash char *Ligne1ChoixEntr			= "[Entr]          ";
flash char *Ligne1ChoixEchap		= "        [Echap] ";
flash char *Ligne1ChoixEchap5s		= "    [Echap 5s!] ";
flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
flash char *BpSetSurD4				= "SET->D4 [Echap] ";
flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
flash char *BpEchSurD7				= "ECH->D7 [Echap] ";

enum TMenu {Menu1_LED_BP, Menu2_MD23, Menu3_SD21, Copie_BP_Sur_Led, Menu21_Mode_MD23, Menu22_Infos_MD23, Choix_Mode_MD23,
Reglage_Valeurs_Mode0_MD23, Reglage_Mode1_MD23, Reglage_Mode2_MD23,Reglage_Mode3_MD23, Controle_Moteurs, Info_TensionBatt,
Info_Version, Info_All, Test_SD21} Menu=Menu1_LED_BP, Menu_1=Menu2_MD23;

bit Choix_Moteur=0;			

void main(void)
{

char Frame_I2C_LED_All_Off[]={0x40    ,0xff}; 		
char Frame_I2C_LED_Switching[]={0x40    ,0x00}; 	

char Frame_I2C_BP_Read[]={0x43  	,0x00}; 			

char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	

unsigned char Reset_MD23[]={0xB0    ,16	    , 32};

unsigned char Mode0_MD23[]={0xB0    ,15	    ,0	    };

unsigned char Speed1[]={0xB0    ,0  	    , 128};		
unsigned char Speed2[]={0xB0    ,1	    , 128};  
unsigned char Time_OUT_Desable[]={0xB0    ,16	    , 50};

unsigned char Read_Reg_MD23_W[]= {0xB0    ,0};		    

unsigned char Frame_I2C_Servo[]={0xC2    ,0		,0,0xE8,0x03};		 

int Num_Reg_MD23_1=0, Num_Reg_MD23=0;                        		        
unsigned char Vitesse_MD23 = 0,Vitesse_MD23_1 = 1, BP_I2C=0, BP_I2C_1 = 1,  Finesse=5, Finesse_1=1;
unsigned char SpeedMot1=128, SpeedMot1_1=128, SpeedMot2=128, SpeedMot2_1=128; 
unsigned char Choix_Mode_1=1, Choix_Mode=0;
unsigned char Ubatt_1=0, Ubatt=0;									        
unsigned char Version_1=0, Version=0;

unsigned char Table_Registers_MD23[]={0xB1    ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];       

unsigned char Vitesse = 5;				    
unsigned int tempo = 1000;                  
unsigned int i = 0;						    

TWI_Master_Initialise(); 									    

#asm("sei")							

TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); 

Init_LCD_I2C_BATRON();

sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
delay_ms(4000);

TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));
TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));

while (1)
{

TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);            

TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));

BP_I2C = Lire_BP_I2C();

if (Menu != Reglage_Valeurs_Mode0_MD23)
{                                                           
TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		
TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));
}

switch(Menu)
{

case Menu1_LED_BP : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuLedBp);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Copie_BP_Sur_Led;  break;     
case 2: Menu = Menu3_SD21;  break;        
case 4: Menu = Menu2_MD23;  break;        
default: Menu = Menu1_LED_BP;
}

Menu_1 = Menu1_LED_BP;

break;

case Menu2_MD23 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuMD23);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Menu21_Mode_MD23;  break;     
case 2: Menu = Menu1_LED_BP;  break;      
case 4: Menu = Menu3_SD21;  break;        
default: Menu = Menu2_MD23 ;
}

Menu_1 = Menu2_MD23 ;

break;

case Menu3_SD21 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuSD21);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Test_SD21;  break;           
case 2: Menu = Menu2_MD23;  break;        
case 4: Menu = Menu1_LED_BP;  break;      
default: Menu = Menu3_SD21 ;
}

Menu_1 = Menu3_SD21 ;

break;

case Menu21_Mode_MD23 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
LCD_I2C_BATRON_gotoxy(0,15);
Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0));
TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
Display_Arrow_0n_I2C_LCDBATRON();
}

switch (BP_I2C)
{
case 64: Menu = Choix_Mode_MD23;  break;         
case 2: Menu = Menu22_Infos_MD23;  break;    
case 4: Menu = Menu22_Infos_MD23;  break;    
case 128 : Menu = Menu2_MD23; break;             
default: Menu = Menu21_Mode_MD23 ;
}

Menu_1 = Menu21_Mode_MD23;
break;

case Menu22_Infos_MD23: if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}

switch (BP_I2C)
{
case 64: Menu = Info_All;  break;
case 2: Menu = Menu21_Mode_MD23;  break;
case 4: Menu = Menu21_Mode_MD23;  break;
case 128 : Menu = Menu2_MD23; break;              
default: Menu = Menu22_Infos_MD23 ;
}

Menu_1 = Menu22_Infos_MD23 ;
break;

case Copie_BP_Sur_Led : if ((Menu_1 != Menu) || ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF)))
{
sprintf(Buffer_for_LCD_Line0,TexteTest1BpsurLed);

switch (BP_I2C)
{
case 64 : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
case 2 : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
case 4 : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
case 128 : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
case 32 : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
case 8: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
case 1: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
case 16: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
}

Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
BP_I2C_1 = BP_I2C;
}

if (BP_I2C == 128)
{
Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	
delay_ms(1000);
Menu = Menu1_LED_BP;
}
else  Menu = Copie_BP_Sur_Led;

Menu_1 = Copie_BP_Sur_Led;
break;

case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
{
sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Choix_Mode_1 = Choix_Mode;
}

switch (BP_I2C)
{
case 128 : Menu=Menu21_Mode_MD23; break;  
case 2: if (Choix_Mode < 3) Choix_Mode = Choix_Mode + 1; else Choix_Mode=0;  break;
case 4: if (Choix_Mode > 0) Choix_Mode = Choix_Mode - 1; else Choix_Mode=3;  break;
case 64: if (Choix_Mode == 0) {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Valeurs_Mode0_MD23;};	break;

default: Menu=Choix_Mode_MD23;
}

Menu_1 = Choix_Mode_MD23;
break;

case Reglage_Valeurs_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
{
sprintf(Buffer_for_LCD_Line0,"1.%-u Mode%-u (+%-u)  ",Choix_Mode+1,Choix_Mode,Finesse);
sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
}

switch (BP_I2C)
{
case 128 :  Menu=Choix_Mode_MD23; break;

case 1:
switch (Choix_Moteur)
{
case 0: if (Finesse==1)
if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
else
if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
break;
case 1: if (Finesse==1)
if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
else
if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
break;
}
break;

case 8:
switch (Choix_Moteur)
{
case 0: if (Finesse==1)
if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
else
if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0;
break;
case 1: if (Finesse==1)
if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
else
if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
break;
}
break;

case 2: if (Finesse==1) Finesse = 5; else Finesse = 1; break;

case 4: if (Finesse==1) Finesse = 5; else Finesse = 1; break;

case 32: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; break;

case 16:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2;
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
break;

default: Menu = Reglage_Valeurs_Mode0_MD23;
}
Menu_1 = Reglage_Valeurs_Mode0_MD23;
break;

case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];
if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23))
{
sprintf(Buffer_for_LCD_Line0,"2.2.1 Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;
strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
}

switch (BP_I2C)
{
case 128 : Menu=Menu22_Infos_MD23; break;
case 1: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break;
case 8: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break;
case 2: Menu = Info_TensionBatt;  break;
case 4: Menu = Info_Version;  break;
default: Menu=Info_All;
}

Menu_1 = Info_All;
break;

case Info_Version:	Version = Table_Registers_MD23[14];
if ((Menu_1 != Menu)||(Version_1 != Version))
{
sprintf(Buffer_for_LCD_Line0,"2.2.2 Version=%-u",Version);
strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Version_1 = Version;
}

switch (BP_I2C)
{
case 128 : Menu=Menu22_Infos_MD23; break;
case 2: Menu = Info_All;  break;
case 4: Menu = Info_TensionBatt;  break;
default: Menu=Info_Version;
}

Menu_1 = Info_Version;
break;

case Info_TensionBatt:  	Ubatt = Table_Registers_MD23[11];
if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt))
{
sprintf(Buffer_for_LCD_Line0,"2.2.3 Ubatt=%-u.%-uV",Ubatt/10, Ubatt-10*(Ubatt/10));
strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
}

switch (BP_I2C)
{
case 128 : Menu=Menu22_Infos_MD23; break;
case 2: Menu = Info_Version;  break;
case 4: Menu = Info_All;  break;
default: Menu=Info_TensionBatt;
}

Menu_1 = Info_TensionBatt;
break;

case Test_SD21 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteTestSD21);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap5s);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
}  

Frame_I2C_Servo[2]  = Vitesse; Frame_I2C_Servo[3] = 0xE8; Frame_I2C_Servo[4]=0x03;  					
TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));			

while (BP_I2C != 128) 
{ 

for(i=0; i<sizeof(Tab_Servo); i++)
{

Frame_I2C_Servo[1] = Tab_Servo[i]; Frame_I2C_Servo[3]  = LSBYTE(Tab_Position[i]);  Frame_I2C_Servo[4] = MSBYTE(Tab_Position[i]); 

TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));	      

Frame_I2C_LED_Switching[1] = ~(i+1);
TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
delay_ms(tempo);   
} 

BP_I2C = Lire_BP_I2C(); 
} 

Frame_I2C_Servo[2]  = 0; TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));

Menu = Menu3_SD21 ; Menu_1 = Test_SD21 ;

break;  

}

Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];

TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  	

}; 

} 

