
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Texte_Accueil_Ligne1=R4
	.DEF _Texte_Accueil_Ligne2=R6
	.DEF _TexteMenuLedBp=R8
	.DEF _TexteMenuMD23=R10
	.DEF _TexteMenuSD21=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _twi_isr
	JMP  0x00

_Tab_Servo:
	.DB  0x0,0x3,0x6,0x9
_Tab_Position:
	.DB  0x20,0x3,0xE8,0x3,0xDC,0x5,0xD0,0x7
_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  LOW(_0x0*2+85),HIGH(_0x0*2+85)
_0x4:
	.DB  LOW(_0x0*2+102),HIGH(_0x0*2+102)
_0x5:
	.DB  LOW(_0x0*2+119),HIGH(_0x0*2+119)
_0x6:
	.DB  LOW(_0x0*2+136),HIGH(_0x0*2+136)
_0x7:
	.DB  LOW(_0x0*2+153),HIGH(_0x0*2+153)
_0x8:
	.DB  LOW(_0x0*2+170),HIGH(_0x0*2+170)
_0x9:
	.DB  LOW(_0x0*2+187),HIGH(_0x0*2+187)
_0xA:
	.DB  LOW(_0x0*2+204),HIGH(_0x0*2+204)
_0xB:
	.DB  LOW(_0x0*2+221),HIGH(_0x0*2+221)
_0xC:
	.DB  LOW(_0x0*2+238),HIGH(_0x0*2+238)
_0xD:
	.DB  LOW(_0x0*2+255),HIGH(_0x0*2+255)
_0xE:
	.DB  LOW(_0x0*2+272),HIGH(_0x0*2+272)
_0xF:
	.DB  LOW(_0x0*2+289),HIGH(_0x0*2+289)
_0x10:
	.DB  LOW(_0x0*2+306),HIGH(_0x0*2+306)
_0x11:
	.DB  LOW(_0x0*2+323),HIGH(_0x0*2+323)
_0x12:
	.DB  LOW(_0x0*2+340),HIGH(_0x0*2+340)
_0x13:
	.DB  LOW(_0x0*2+357),HIGH(_0x0*2+357)
_0x14:
	.DB  LOW(_0x0*2+374),HIGH(_0x0*2+374)
_0x15:
	.DB  LOW(_0x0*2+391),HIGH(_0x0*2+391)
_0x16:
	.DB  0x1
_0x17:
	.DB  0x0,0x0,0xE8,0x3,0x5,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xB1
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x80,0x80,0x80,0x80,0x1
	.DB  0x5,0x1,0x0,0xC2,0x0,0x0,0xE8,0x3
	.DB  0xB0,0x0,0xB0,0x10,0x32,0xB0,0x1,0x80
	.DB  0xB0,0x0,0x80,0xB0,0xF,0x0,0xB0,0x10
	.DB  0x20,0x76,0x40,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x43,0x0,0x40,0x0
	.DB  0x40,0xFF
_0x123:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+17),HIGH(_0x0*2+17),LOW(_0x0*2+34),HIGH(_0x0*2+34),LOW(_0x0*2+51),HIGH(_0x0*2+51)
	.DB  LOW(_0x0*2+68),HIGH(_0x0*2+68)
_0x0:
	.DB  0x20,0x20,0x20,0x54,0x65,0x73,0x74,0x20
	.DB  0x53,0x49,0x53,0x49,0x20,0x20,0x20,0x20
	.DB  0x0,0x20,0x5B,0x54,0x57,0x49,0x20,0x30
	.DB  0x35,0x2F,0x30,0x31,0x2F,0x31,0x31,0x5D
	.DB  0x20,0x0,0x5B,0x31,0x5D,0x54,0x65,0x73
	.DB  0x74,0x20,0x42,0x50,0x2D,0x3E,0x4C,0x65
	.DB  0x64,0x20,0x0,0x5B,0x32,0x5D,0x54,0x65
	.DB  0x73,0x74,0x20,0x4D,0x44,0x32,0x33,0x20
	.DB  0x20,0x20,0x20,0x0,0x5B,0x33,0x5D,0x54
	.DB  0x65,0x73,0x74,0x20,0x53,0x44,0x32,0x31
	.DB  0x20,0x20,0x20,0x20,0x0,0x5B,0x32,0x30
	.DB  0x5D,0x43,0x68,0x6F,0x69,0x78,0x20,0x4D
	.DB  0x6F,0x64,0x65,0x73,0x20,0x0,0x5B,0x32
	.DB  0x31,0x5D,0x41,0x66,0x66,0x20,0x49,0x6E
	.DB  0x66,0x6F,0x73,0x20,0x20,0x20,0x0,0x5B
	.DB  0x32,0x32,0x5D,0x43,0x68,0x6F,0x69,0x78
	.DB  0x20,0x44,0x65,0x70,0x6C,0x2E,0x20,0x0
	.DB  0x43,0x64,0x65,0x20,0x53,0x65,0x72,0x76
	.DB  0x6F,0x20,0x31,0x2D,0x3E,0x34,0x20,0x20
	.DB  0x0,0x52,0x65,0x63,0x6F,0x70,0x69,0x65
	.DB  0x20,0x42,0x70,0x2D,0x3E,0x4C,0x65,0x64
	.DB  0x20,0x0,0x5B,0x2B,0x2F,0x2D,0x5D,0x20
	.DB  0x20,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x5D,0x20,0x0,0x5B,0x45,0x6E,0x74,0x72
	.DB  0x5D,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x0,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x5B,0x45,0x63,0x68
	.DB  0x61,0x70,0x5D,0x20,0x0,0x20,0x20,0x20
	.DB  0x20,0x5B,0x45,0x63,0x68,0x61,0x70,0x20
	.DB  0x35,0x73,0x21,0x5D,0x20,0x0,0x5B,0x45
	.DB  0x6E,0x74,0x72,0x5D,0x20,0x20,0x5B,0x45
	.DB  0x63,0x68,0x61,0x70,0x5D,0x20,0x0,0x5B
	.DB  0x53,0x45,0x54,0x5D,0x20,0x20,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x70,0x5D,0x20,0x0
	.DB  0x2B,0x20,0x2D,0x3E,0x20,0x44,0x30,0x20
	.DB  0x5B,0x45,0x63,0x68,0x61,0x70,0x5D,0x20
	.DB  0x0,0x46,0x48,0x2D,0x3E,0x20,0x44,0x31
	.DB  0x20,0x5B,0x45,0x63,0x68,0x61,0x70,0x5D
	.DB  0x20,0x0,0x46,0x42,0x2D,0x3E,0x20,0x44
	.DB  0x32,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x5D,0x20,0x0,0x2D,0x20,0x2D,0x3E,0x20
	.DB  0x44,0x33,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0,0x53,0x45,0x54,0x2D
	.DB  0x3E,0x44,0x34,0x20,0x5B,0x45,0x63,0x68
	.DB  0x61,0x70,0x5D,0x20,0x0,0x4F,0x6B,0x2D
	.DB  0x3E,0x20,0x44,0x35,0x20,0x5B,0x45,0x63
	.DB  0x68,0x61,0x70,0x5D,0x20,0x0,0x45,0x4E
	.DB  0x54,0x2D,0x3E,0x44,0x36,0x20,0x5B,0x45
	.DB  0x63,0x68,0x61,0x70,0x5D,0x20,0x0,0x45
	.DB  0x43,0x48,0x2D,0x3E,0x44,0x37,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x70,0x5D,0x20,0x0
	.DB  0x43,0x68,0x6F,0x69,0x78,0x3A,0x20,0x4D
	.DB  0x6F,0x64,0x65,0x25,0x2D,0x75,0x20,0x20
	.DB  0x20,0x20,0x0,0x5B,0x32,0x30,0x30,0x5D
	.DB  0x4D,0x6F,0x64,0x65,0x25,0x2D,0x75,0x20
	.DB  0x28,0x2B,0x25,0x2D,0x75,0x29,0x20,0x0
	.DB  0x53,0x4D,0x31,0x3D,0x25,0x2D,0x75,0x20
	.DB  0x53,0x4D,0x32,0x3D,0x25,0x2D,0x75,0x0
	.DB  0x5B,0x32,0x31,0x30,0x5D,0x20,0x52,0x65
	.DB  0x67,0x25,0x2D,0x75,0x3D,0x20,0x25,0x2D
	.DB  0x75,0x0,0x5B,0x32,0x31,0x31,0x5D,0x20
	.DB  0x56,0x65,0x72,0x73,0x2E,0x3D,0x25,0x2D
	.DB  0x75,0x20,0x20,0x0,0x5B,0x32,0x31,0x32
	.DB  0x5D,0x55,0x62,0x61,0x74,0x3D,0x25,0x2D
	.DB  0x75,0x2E,0x25,0x2D,0x75,0x56,0x20,0x0
	.DB  0x5B,0x32,0x32,0x30,0x5D,0x4C,0x69,0x67
	.DB  0x2E,0x20,0x64,0x72,0x6F,0x69,0x74,0x65
	.DB  0x0,0x5B,0x32,0x32,0x31,0x5D,0x56,0x69
	.DB  0x72,0x61,0x67,0x65,0x20,0x39,0x30,0xB0
	.DB  0x20,0x0,0x45,0x6E,0x63,0x31,0x3D,0x0
	.DB  0x45,0x6E,0x63,0x32,0x3D,0x0,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x5D,0x0
_0x2000060:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2080003:
	.DB  0xF8
_0x20C0003:
	.DB  0x76,0x0,0x34,0xD,0x6,0x35,0x4,0x10
	.DB  0x42,0x9F,0x34,0x83,0x2
_0x20C0013:
	.DB  0x76,0x40,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0x0
_0x20E0003:
	.DB  0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  _Ligne0MenuMode
	.DW  _0x3*2

	.DW  0x02
	.DW  _Ligne0MenuInfos
	.DW  _0x4*2

	.DW  0x02
	.DW  _Ligne0MenuDeplacements
	.DW  _0x5*2

	.DW  0x02
	.DW  _TexteTestSD21
	.DW  _0x6*2

	.DW  0x02
	.DW  _TexteTest1BpsurLed
	.DW  _0x7*2

	.DW  0x02
	.DW  _Ligne1PlusMoins
	.DW  _0x8*2

	.DW  0x02
	.DW  _Ligne1ChoixEntr
	.DW  _0x9*2

	.DW  0x02
	.DW  _Ligne1ChoixEchap
	.DW  _0xA*2

	.DW  0x02
	.DW  _Ligne1ChoixEchap5s
	.DW  _0xB*2

	.DW  0x02
	.DW  _Ligne1ChoixEchapOk
	.DW  _0xC*2

	.DW  0x02
	.DW  _Ligne1ChoixEchapSET
	.DW  _0xD*2

	.DW  0x02
	.DW  _BpPlusSurD0
	.DW  _0xE*2

	.DW  0x02
	.DW  _BpFlecheHSurD1
	.DW  _0xF*2

	.DW  0x02
	.DW  _BpFlecheHSurD2
	.DW  _0x10*2

	.DW  0x02
	.DW  _BpMoinsSurD3
	.DW  _0x11*2

	.DW  0x02
	.DW  _BpSetSurD4
	.DW  _0x12*2

	.DW  0x02
	.DW  _BpOkSurD5
	.DW  _0x13*2

	.DW  0x02
	.DW  _BpEntrSurD6
	.DW  _0x14*2

	.DW  0x02
	.DW  _BpEchSurD7
	.DW  _0x15*2

	.DW  0x01
	.DW  _Menu_1
	.DW  _0x16*2

	.DW  0x06
	.DW  _0xFB
	.DW  _0x0*2+554

	.DW  0x08
	.DW  _0xFB+6
	.DW  _0x0*2+566

	.DW  0x0A
	.DW  0x04
	.DW  _0x123*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x2000060*2

	.DW  0x01
	.DW  _TWI_state_G104
	.DW  _0x2080003*2

	.DW  0x01
	.DW  _Etat_BP_I2C_S1070000000
	.DW  _0x20E0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/****************************************************************
;Project : PPE Robot Solaire
;Version : 1.1.0
;// --------------------------------------------------------------
;Fichier source : mainTestSISIV2.c
;Date de  cration : 06/01/2010
;Mise  jour le : 04/01/2011
;// --------------------------------------------------------------
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin 18000 BOURGES
;// --------------------------------------------------------------
;Comments:
;- Mise en oeuvre du protocole I2C sur l'interface TWI
;(Adaptation de la note d'application AVR315 d'ATMEL)
;- Commande d'un afficheur LCD Batron I2C (PCF2119x)
;- Lecture des BP et recopie sur les LED.
;- Test de la carte MD23(Reglage et commande des moteurs en
;Mode0, lecture et affichage des registres, test de dplacements)
;- Test de la carte SD21
;// --------------------------------------------------------------
;Cross compilateur: CVAVR 2.04.08a
;// --------------------------------------------------------------
;Chip type           : ATmega32
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 512
;****************************************************************/
;
;// =============================================================================================================================
;// Partie dclarative du programme
;// =============================================================================================================================
;// Bibliothques et dfinitions
;// =============================================================================================================================
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;// -----------------------------------------------------------------------------------------------------------------------------
;// Bibliothques CVAVR ( rajouter manuellement)
;// -----------------------------------------------------------------------------------------------------------------------------
;#include <stdlib.h>
;#include <stdio.h>				// Fonction sprintf
;#include <math.h>
;#include <string.h>				// Fonctions de traitement des chanes de caractres
;#include <delay.h>				// Fonction temporisation
;// -----------------------------------------------------------------------------------------------------------------------------
;// Bibliothques dveloppes pour la carte SISI ( rajouter manuellement)
;// -----------------------------------------------------------------------------------------------------------------------------
;#include "DriverTWICV2.h"       // Fonctions du drivers TWI adaptes pour CVAVR
;                                // ATTENTION: Vrifier que la taille du buffer est adapte au message (20 par dfaut)
;#include <stdmno.h>             // Fonctions LSBYTE et MSBYTE
;#include "MD23.h"				// Dfinitions des registres de la carte moteur MD23
;#include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C
;#include "SISISOL.h"            // Gestion de l'IHM SISI
;#include "SD21.h"				// Dfinitions des registres de la carte servo SD21
;#include "TableRob.h"           // Dclaration des tables de valeurs envoyes aux servos
;
;// -----------------------------------------------------------------------------------------------------------------------------
;// Dclarations divers
;// -----------------------------------------------------------------------------------------------------------------------------
;// Alias pour la trame de commande des Servos connects  la carte SD21
;// -----------------------------------------------------------------------------------------------------------------------------
;#define NumServo			  Frame_I2C_Servo[1]
;#define RegSpeedValue	      Frame_I2C_Servo[2]
;#define RegPosLByte			  Frame_I2C_Servo[3]
;#define RegPosHByte			  Frame_I2C_Servo[4]
;// -----------------------------------------------------------------------------------------------------------------------------
;// Alias pour la trame de commande des moteurs connects  de la carte MD23 - 25
;// -----------------------------------------------------------------------------------------------------------------------------
;#define	Moteur1			        0
;#define	Moteur2			        1
;// =============================================================================================================================
;
;// =============================================================================================================================
;// =============================================================================================================================
;// Constantes en flash
;// -----------------------------------------------------------------------------------------------------------------------------
;// Structure pour l'affichage du nom des registres  (A terminer)
;// flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
;// -----------------------------------------------------------------------------------------------------------------------------
;// Messages textuels prdfinis
;// ATTENTION: imprativement 16 caractres
;// -----------------------------------------------------------------------------------------------------------------------------
;flash char *Texte_Accueil_Ligne1 	= "   Test SISI    ";
;flash char *Texte_Accueil_Ligne2 	= " [TWI 05/01/11] ";
;flash char *TexteMenuLedBp			= "[1]Test BP->Led ";
;flash char *TexteMenuMD23			= "[2]Test MD23    ";
;flash char *TexteMenuSD21			= "[3]Test SD21    ";
;flash char *Ligne0MenuMode			= "[20]Choix Modes ";

	.DSEG
;flash char *Ligne0MenuInfos			= "[21]Aff Infos   ";
;flash char *Ligne0MenuDeplacements  = "[22]Choix Depl. ";
;flash char *TexteTestSD21           = "Cde Servo 1->4  ";
;flash char *TexteTest1BpsurLed	    = "Recopie Bp->Led ";
;flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
;flash char *Ligne1ChoixEntr			= "[Entr]          ";
;flash char *Ligne1ChoixEchap		= "        [Echap] ";
;flash char *Ligne1ChoixEchap5s		= "    [Echap 5s!] ";
;flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
;flash char *Ligne1ChoixEchapSET		= "[SET]   [Echap] ";
;flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
;flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
;flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
;flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
;flash char *BpSetSurD4				= "SET->D4 [Echap] ";
;flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
;flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
;flash char *BpEchSurD7				= "ECH->D7 [Echap] ";
;
;// =============================================================================================================================
;
;// =============================================================================================================================
;// =============================================================================================================================
;// Prototypes des fonctions en cours de test
;// -----------------------------------------------------------------------------------------------------------------------------
;// =============================================================================================================================
;
;// =============================================================================================================================
;// =============================================================================================================================
;// ------------------------------------------ Declare your global variables here -----------------------------------------------
;// -----------------------------------------------------------------------------------------------------------------------------
;// Type				Nom														Description
;// -----------------------------------------------------------------------------------------------------------------------------
;// Etats du graphe des transitions "Menus"
;// -----------------------------------------------------------------------------------------------------------------------------
;enum TMenu {Menu1_LED_BP, Menu2_MD23, Menu3_SD21, Copie_BP_Sur_Led, Menu20_Mode_MD23, Menu21_Infos_MD23, Menu22_Deplacements,
;Choix_Mode_MD23, Selection_Deplacements, Reglage_Valeurs_Mode0_MD23, Reglage_Mode1_MD23, Reglage_Mode2_MD23,
;Reglage_Mode3_MD23,Controle_Moteurs, Info_TensionBatt, Info_Version, Info_All, Test_SD21, Test_Deplacements}
;Menu=Menu1_LED_BP, Menu_1=Menu2_MD23;
;// -----------------------------------------------------------------------------------------------------------------------------
;bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0
;// =============================================================================================================================
;
;
;// =============================================================================================================================
;// =============================================================================================================================
;// Partie excutive du programme
;// =============================================================================================================================
;// =============================================================================================================================
;void main(void)
; 0000 008B {

	.CSEG
_main:
; 0000 008C // =============================================================================================================================
; 0000 008D // ---------------------------------------------- Declare your local variables here --------------------------------------------
; 0000 008E // =============================================================================================================================
; 0000 008F // Messages pour les composants I2C
; 0000 0090 // =============================================================================================================================
; 0000 0091 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
; 0000 0092 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0093 // Type 	   		Nom 				       						Description
; 0000 0094 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 0095 char Frame_I2C_LED_All_Off[]={Add_LED_I2C_W,0xff}; 		// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
; 0000 0096 char Frame_I2C_LED_Switching[]={Add_LED_I2C_W,0x00}; 	// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
; 0000 0097                                                         // or Off=1}. Initialisation = All On.
; 0000 0098 char Frame_I2C_BP_Read[]={Add_BP_I2C_R,0x00}; 			// Trame de lecture des BP {SLA+R=0x43, Data=Nul}
; 0000 0099 // =============================================================================================================================
; 0000 009A // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
; 0000 009B // -----------------------------------------------------------------------------------------------------------------------------
; 0000 009C // Type 	   		Nom 				       						Description
; 0000 009D // -----------------------------------------------------------------------------------------------------------------------------
; 0000 009E //unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
; 0000 009F char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	        // Trame de texte compose de: {SLA+W=0x76, cde=write to DDRAM ,
; 0000 00A0 						 	     								// le texte  afficher = 16 caractres max,  Nul }
; 0000 00A1                                                             	// Cette trame est remplie avec le tableau String_to_LCD
; 0000 00A2 // =============================================================================================================================
; 0000 00A3 // 3) Liste de messages prdfinis pour la carte MD23
; 0000 00A4 // =============================================================================================================================
; 0000 00A5 // 30) Initialisation
; 0000 00A6 unsigned char Reset_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur}; // Remise  zro des encodeurs
; 0000 00A7 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00A8 // 31) Mode
; 0000 00A9 unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};
; 0000 00AA // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00AB // 32) Vitesse des moteurs
; 0000 00AC unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur 1 dans le mode 0
; 0000 00AD unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur 2 dans le mode 0
; 0000 00AE unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs};
; 0000 00AF // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00B0 // 33) Lecture des registres
; 0000 00B1 unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		    // Premire trame  envoyer:
; 0000 00B2 															    // { SLA_W=0xB0, N registre o commence la lecture }
; 0000 00B3 // =============================================================================================================================
; 0000 00B4 // 4) Trame de commande des servos
; 0000 00B5 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00B6 // Cette trame est compose de: {@SD21, NumServo, RegSpeedValue, RegPosLByte, RegPosHByte}
; 0000 00B7 unsigned char Frame_I2C_Servo[]={SD21_ADD_BASE_W,Servo1,0,0xE8,0x03};
; 0000 00B8 
; 0000 00B9 // Dtail du contenu de la "trame I2C Servo"
; 0000 00BA // @SD21			  SLA+W = 0xC2: Adresse de la carte SD21 en criture
; 0000 00BB // NumServo			  N du registre vitesse du servo  commander, dfinit dans SD21.h (Servo1 par dfaut)
; 0000 00BC // RegSpeedValue	  Valeur  placer dans le le registre vitesse (Vitesse maxi par dfaut)
; 0000 00BD // RegPosLByte		  Octet de poids faible du mot de commande de la position (Position mini par dfaut)
; 0000 00BE // RegPosHByte		  Octet de poids fort du mot de commande de la position
; 0000 00BF // =============================================================================================================================
; 0000 00C0 // Variables diverses
; 0000 00C1 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C2 // Type 			Nom 				       			   				Description
; 0000 00C3 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C4 // 1) Gestion de la carte MD23
; 0000 00C5 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00C6 // Variables utilises dans la gestion de l'affichage sur le LCD:  limitent son rafrachissement!
; 0000 00C7 int Num_Reg_MD23_1=0, Num_Reg_MD23=0;
; 0000 00C8 unsigned char Vitesse_MD23 = 0,Vitesse_MD23_1 = 1, BP_I2C=0, BP_I2C_1 = 1,  Finesse=5, Finesse_1=1;
; 0000 00C9 unsigned char SpeedMot1=128, SpeedMot1_1=128, SpeedMot2=128, SpeedMot2_1=128;
; 0000 00CA signed char Choix_Mode_1=1, Choix_Mode=0;
; 0000 00CB unsigned char Ubatt_1=0, Ubatt=0;									        // Tension alimentation carte MD23/MD25
; 0000 00CC unsigned char Version_1=0, Version=0;                                       // Version du soft de la carte MD23/MD25
; 0000 00CD long int Codeur1 = 0, Codeur1_1 = 0;                                        // Reprsentatif de la valeur contenue dans
; 0000 00CE long int Codeur2 = 0;                                                       // les encodeurs (sur 24 bits)
; 0000 00CF unsigned char SelecDeplacement = 0, SelecDeplacement_1 = 0;
; 0000 00D0 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00D1 char AfficheDeplacement1[11];                                                // Dplacement pour affichage codeur 1
; 0000 00D2 char AfficheDeplacement2[11];                                                // Dplacement pour affichage codeur 2
; 0000 00D3 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00D4 // Reoit le contenu des registres de la carte MD23. Liste ci-dessous
; 0000 00D5 // Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev, AccRate, Mode, Cde
; 0000 00D6 unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
; 0000 00D7 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00D8 // 2) Gestion du LCD BATRON
; 0000 00D9 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00DA char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];       // Reoivent les deux lignes de texte  envoyer  l'afficheur
; 0000 00DB 															    // (16 caractres max. + Nul)
; 0000 00DC // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00DD // 3) Gestion de la carte SD21
; 0000 00DE // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00DF unsigned char Vitesse = 5;				    // Vitesse de dplacement du servo
; 0000 00E0 unsigned int tempo = 1000;                  // Attente entre deux transmission : doit tre > 20ms
; 0000 00E1 unsigned int i = 0;						    // Variable de boucle
; 0000 00E2 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00E3 // *****************************************************************************************************************************
; 0000 00E4 
; 0000 00E5 // =============================================================================================================================
; 0000 00E6 // ===================================================== Initialisations =======================================================
; 0000 00E7 // =============================================================================================================================
; 0000 00E8 // Initialisation de l'interface TWI en mode Standby
; 0000 00E9 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00EA TWI_Master_Initialise();
	SBIW R28,63
	SBIW R28,63
	SBIW R28,28
	LDI  R24,154
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x17*2)
	LDI  R31,HIGH(_0x17*2)
	CALL __INITLOCB
;	Frame_I2C_LED_All_Off -> Y+152
;	Frame_I2C_LED_Switching -> Y+150
;	Frame_I2C_BP_Read -> Y+148
;	Frame_I2C_Lcd_Line -> Y+129
;	Reset_MD23 -> Y+126
;	Mode0_MD23 -> Y+123
;	Speed1 -> Y+120
;	Speed2 -> Y+117
;	Time_OUT_Desable -> Y+114
;	Read_Reg_MD23_W -> Y+112
;	Frame_I2C_Servo -> Y+107
;	Num_Reg_MD23_1 -> R16,R17
;	Num_Reg_MD23 -> R18,R19
;	Vitesse_MD23 -> R21
;	Vitesse_MD23_1 -> R20
;	BP_I2C -> Y+106
;	BP_I2C_1 -> Y+105
;	Finesse -> Y+104
;	Finesse_1 -> Y+103
;	SpeedMot1 -> Y+102
;	SpeedMot1_1 -> Y+101
;	SpeedMot2 -> Y+100
;	SpeedMot2_1 -> Y+99
;	Choix_Mode_1 -> Y+98
;	Choix_Mode -> Y+97
;	Ubatt_1 -> Y+96
;	Ubatt -> Y+95
;	Version_1 -> Y+94
;	Version -> Y+93
;	Codeur1 -> Y+89
;	Codeur1_1 -> Y+85
;	Codeur2 -> Y+81
;	SelecDeplacement -> Y+80
;	SelecDeplacement_1 -> Y+79
;	AfficheDeplacement1 -> Y+68
;	AfficheDeplacement2 -> Y+57
;	Table_Registers_MD23 -> Y+39
;	Buffer_for_LCD_Line0 -> Y+22
;	Buffer_for_LCD_Line1 -> Y+5
;	Vitesse -> Y+4
;	tempo -> Y+2
;	i -> Y+0
	__GETWRN 16,17,0
	__GETWRN 18,19,0
	LDI  R21,0
	LDI  R20,1
	CALL _TWI_Master_Initialise
; 0000 00EB // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00EC // Global enable interrupts         // ATTENTION !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 00ED #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI
	sei
; 0000 00EE // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00EF TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte S_ISI
	MOVW R30,R28
	SUBI R30,LOW(-(152))
	SBCI R31,HIGH(-(152))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 00F0 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00F1 // Initialisation de l'afficheur I2C BATRON
; 0000 00F2 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00F3 Init_LCD_I2C_BATRON();
	CALL _Init_LCD_I2C_BATRON
; 0000 00F4 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00F5 // Affichage d'un message d'accueil
; 0000 00F6 // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00F7 sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R5
	ST   -Y,R4
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 00F8 sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R7
	ST   -Y,R6
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 00F9 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 00FA delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 00FB // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00FC // Initialisation des registres de  la carte MD23
; 0000 00FD // -----------------------------------------------------------------------------------------------------------------------------
; 0000 00FE TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(126))
	SBCI R31,HIGH(-(126))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 00FF TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
	MOVW R30,R28
	SUBI R30,LOW(-(114))
	SBCI R31,HIGH(-(114))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0100 TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(123))
	SBCI R31,HIGH(-(123))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0101 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(120))
	SBCI R31,HIGH(-(120))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0102 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(117))
	SBCI R31,HIGH(-(117))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0103 // =============================================================================================================================
; 0000 0104 
; 0000 0105 // =============================================================================================================================
; 0000 0106 // ================================================ Boucle principale ==========================================================
; 0000 0107 // =============================================================================================================================
; 0000 0108 while (1)
_0x18:
; 0000 0109       {
; 0000 010A // ============================================================================================================================
; 0000 010B // ---------------------------------------------  Champ Lecture des donnes ----------------------------------------------------
; 0000 010C // Lecture de l'tat des boutons-poussoir (BP)
; 0000 010D // ----------------------------------------------------------------------------------------------------------------------------
; 0000 010E // Lecture des BP pour affichage sur les LED
; 0000 010F 	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);            // Envoi de l'octet d'adresse des BP: SLA+R=0x43
	MOVW R30,R28
	SUBI R30,LOW(-(148))
	SBCI R31,HIGH(-(148))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0110 	                                                            // Rcupration de l'octet reprsentatif de l'tat des BP
; 0000 0111 	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));
	MOVW R30,R28
	SUBI R30,LOW(-(148))
	SBCI R31,HIGH(-(148))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 0112 // Lecture des BP avec gestion anti-rebond pour parcourir les menus
; 0000 0113     BP_I2C = Lire_BP_I2C();
	CALL _Lire_BP_I2C
	__PUTB1SX 106
; 0000 0114 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0115 // Lecture des registres de la carte MD23
; 0000 0116    if (Menu != Reglage_Valeurs_Mode0_MD23)
	LDS  R26,_Menu
	CPI  R26,LOW(0x9)
	BREQ _0x1B
; 0000 0117    {                                                           // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
; 0000 0118 	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
	MOVW R30,R28
	SUBI R30,LOW(-(112))
	SBCI R31,HIGH(-(112))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0119    	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture
	MOVW R30,R28
	ADIW R30,39
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 011A 	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));
	MOVW R30,R28
	ADIW R30,39
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 011B    }
; 0000 011C // ============================================================================================================================
; 0000 011D // --------------------------------------------------- Champ Traitement--------------------------------------------------------
; 0000 011E     switch(Menu)
_0x1B:
	LDS  R30,_Menu
; 0000 011F     {// Dbut du switch1
; 0000 0120 // -------------------------------------------------Dbut Menus droulants-----------------------------------------------------
; 0000 0121 // Menus Niveau 1 -------------------------------------------------------------------------------------------------------------
; 0000 0122 // ============================================================================================================================
; 0000 0123 // Menu [1] : Choix du test des Led et des BP (Recopie de l'tat des BP sur les LED)
; 0000 0124 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0125        case Menu1_LED_BP : if (Menu_1 != Menu)
	CPI  R30,0
	BREQ PC+3
	JMP _0x1F
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x20
; 0000 0126        		{
; 0000 0127                 sprintf(Buffer_for_LCD_Line0,TexteMenuLedBp);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R9
	ST   -Y,R8
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0128 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0129 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 012A 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 012B        		}
; 0000 012C        		switch (BP_I2C)
_0x20:
	__GETB1SX 106
; 0000 012D 				{
; 0000 012E 					case ENTR_I2C: Menu = Copie_BP_Sur_Led;  break;     // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x24
	LDI  R30,LOW(3)
	RJMP _0x10A
; 0000 012F 					case FlecheH_I2C: Menu = Menu3_SD21;  break;        // touche flche haut
_0x24:
	CPI  R30,LOW(0x2)
	BRNE _0x25
	LDI  R30,LOW(2)
	RJMP _0x10A
; 0000 0130 					case FlecheB_I2C: Menu = Menu2_MD23;  break;        // touche flche bas
_0x25:
	CPI  R30,LOW(0x4)
	BRNE _0x27
	LDI  R30,LOW(1)
	RJMP _0x10A
; 0000 0131 					default: Menu = Menu1_LED_BP;
_0x27:
	LDI  R30,LOW(0)
_0x10A:
	STS  _Menu,R30
; 0000 0132 				}
; 0000 0133 
; 0000 0134 			Menu_1 = Menu1_LED_BP;
	LDI  R30,LOW(0)
	JMP  _0x10B
; 0000 0135 
; 0000 0136        break;
; 0000 0137 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0138 // Menu [2] : Choix des test de la carte MD23/25
; 0000 0139 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 013A        case Menu2_MD23 : if (Menu_1 != Menu)
_0x1F:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x28
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x29
; 0000 013B        		{
; 0000 013C                 sprintf(Buffer_for_LCD_Line0,TexteMenuMD23);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R11
	ST   -Y,R10
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 013D 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 013E 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 013F 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0140        		}
; 0000 0141        		switch (BP_I2C)
_0x29:
	__GETB1SX 106
; 0000 0142 				{
; 0000 0143 					case ENTR_I2C: Menu = Menu20_Mode_MD23;  break;     // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x2D
	LDI  R30,LOW(4)
	RJMP _0x10C
; 0000 0144 					case FlecheH_I2C: Menu = Menu1_LED_BP;  break;      // touche flche haut
_0x2D:
	CPI  R30,LOW(0x2)
	BRNE _0x2E
	LDI  R30,LOW(0)
	RJMP _0x10C
; 0000 0145 					case FlecheB_I2C: Menu = Menu3_SD21;  break;        // touche flche bas
_0x2E:
	CPI  R30,LOW(0x4)
	BRNE _0x30
	LDI  R30,LOW(2)
	RJMP _0x10C
; 0000 0146 					default: Menu = Menu2_MD23 ;
_0x30:
	LDI  R30,LOW(1)
_0x10C:
	STS  _Menu,R30
; 0000 0147 				}
; 0000 0148 
; 0000 0149 			Menu_1 = Menu2_MD23 ;
	LDI  R30,LOW(1)
	JMP  _0x10B
; 0000 014A 
; 0000 014B        break;
; 0000 014C // ----------------------------------------------------------------------------------------------------------------------------
; 0000 014D // Menu [3] : Choix du test de la carte SD21
; 0000 014E // ----------------------------------------------------------------------------------------------------------------------------
; 0000 014F        case Menu3_SD21 : if (Menu_1 != Menu)
_0x28:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x31
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x32
; 0000 0150        		{
; 0000 0151                 sprintf(Buffer_for_LCD_Line0,TexteMenuSD21);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R13
	ST   -Y,R12
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0152 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0153 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0154 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0155        		}
; 0000 0156        		switch (BP_I2C)
_0x32:
	__GETB1SX 106
; 0000 0157 				{
; 0000 0158 					case ENTR_I2C: Menu = Test_SD21;  break;           // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x36
	LDI  R30,LOW(17)
	RJMP _0x10D
; 0000 0159 					case FlecheH_I2C: Menu = Menu2_MD23;  break;        // touche flche haut
_0x36:
	CPI  R30,LOW(0x2)
	BRNE _0x37
	LDI  R30,LOW(1)
	RJMP _0x10D
; 0000 015A 					case FlecheB_I2C: Menu = Menu1_LED_BP;  break;      // touche flche bas
_0x37:
	CPI  R30,LOW(0x4)
	BRNE _0x39
	LDI  R30,LOW(0)
	RJMP _0x10D
; 0000 015B 					default: Menu = Menu3_SD21 ;
_0x39:
	LDI  R30,LOW(2)
_0x10D:
	STS  _Menu,R30
; 0000 015C 				}
; 0000 015D 
; 0000 015E 			Menu_1 = Menu3_SD21 ;
	LDI  R30,LOW(2)
	JMP  _0x10B
; 0000 015F 
; 0000 0160        break;
; 0000 0161 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0162 // Fin des menus
; 0000 0163 // ============================================================================================================================
; 0000 0164 // Sous menus(Niveau 2) -------------------------------------------------------------------------------------------------------
; 0000 0165 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0166 // Sous menu [20]: Choix du mode de commande des moteurs de la carte MD23/25
; 0000 0167 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0168 		case Menu20_Mode_MD23 : if (Menu_1 != Menu)
_0x31:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x3A
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE PC+3
	JMP _0x3B
; 0000 0169 			{
; 0000 016A 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuMode
	LDS  R31,_Ligne0MenuMode+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 016B 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 016C 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 016D 				LCD_I2C_BATRON_gotoxy(0,15);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL _LCD_I2C_BATRON_gotoxy
; 0000 016E 				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0));
	MOVW R30,R28
	SUBI R30,LOW(-(129))
	SBCI R31,HIGH(-(129))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,26
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	CALL _Built_Strng_Fram_I2C_LCDBATRON
; 0000 016F 				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
	MOVW R30,R28
	SUBI R30,LOW(-(129))
	SBCI R31,HIGH(-(129))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(131))
	SBCI R31,HIGH(-(131))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0170 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0171 			}
; 0000 0172 
; 0000 0173 			switch (BP_I2C)
_0x3B:
	__GETB1SX 106
; 0000 0174 				{
; 0000 0175 					case ENTR_I2C: Menu = Choix_Mode_MD23;  break;         // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x3F
	LDI  R30,LOW(7)
	RJMP _0x10E
; 0000 0176 					case FlecheH_I2C: Menu = Menu22_Deplacements;  break;    // touche flche haut
_0x3F:
	CPI  R30,LOW(0x2)
	BRNE _0x40
	LDI  R30,LOW(6)
	RJMP _0x10E
; 0000 0177 					case FlecheB_I2C: Menu = Menu21_Infos_MD23;  break;    // touche flche bas
_0x40:
	CPI  R30,LOW(0x4)
	BRNE _0x41
	LDI  R30,LOW(5)
	RJMP _0x10E
; 0000 0178 					case ECHAP_I2C : Menu = Menu2_MD23; break;             // touche ECHAP
_0x41:
	CPI  R30,LOW(0x80)
	BRNE _0x43
	LDI  R30,LOW(1)
	RJMP _0x10E
; 0000 0179 					default: Menu = Menu20_Mode_MD23 ;
_0x43:
	LDI  R30,LOW(4)
_0x10E:
	STS  _Menu,R30
; 0000 017A 				}
; 0000 017B 
; 0000 017C 			Menu_1 = Menu20_Mode_MD23;
	LDI  R30,LOW(4)
	RJMP _0x10B
; 0000 017D 		break;
; 0000 017E // ----------------------------------------------------------------------------------------------------------------------------
; 0000 017F // Sous menu [21] : Choix de l'affichage du contenu des registres de la carte MD23/25
; 0000 0180 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0181 		case Menu21_Infos_MD23: if (Menu_1 != Menu)
_0x3A:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x44
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x45
; 0000 0182 			{
; 0000 0183 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuInfos
	LDS  R31,_Ligne0MenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0184 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0185 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0186 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0187 			}
; 0000 0188 
; 0000 0189 			switch (BP_I2C)
_0x45:
	__GETB1SX 106
; 0000 018A 				{
; 0000 018B 					case ENTR_I2C: Menu = Info_All;  break;
	CPI  R30,LOW(0x40)
	BRNE _0x49
	LDI  R30,LOW(16)
	RJMP _0x10F
; 0000 018C 					case FlecheH_I2C: Menu = Menu20_Mode_MD23;  break;
_0x49:
	CPI  R30,LOW(0x2)
	BRNE _0x4A
	LDI  R30,LOW(4)
	RJMP _0x10F
; 0000 018D 					case FlecheB_I2C: Menu =Menu22_Deplacements;  break;
_0x4A:
	CPI  R30,LOW(0x4)
	BRNE _0x4B
	LDI  R30,LOW(6)
	RJMP _0x10F
; 0000 018E 					case ECHAP_I2C : Menu = Menu2_MD23; break;              // touche ECHAP
_0x4B:
	CPI  R30,LOW(0x80)
	BRNE _0x4D
	LDI  R30,LOW(1)
	RJMP _0x10F
; 0000 018F 					default: Menu = Menu21_Infos_MD23 ;
_0x4D:
	LDI  R30,LOW(5)
_0x10F:
	STS  _Menu,R30
; 0000 0190 				}
; 0000 0191 
; 0000 0192 			Menu_1 = Menu21_Infos_MD23 ;
	LDI  R30,LOW(5)
	RJMP _0x10B
; 0000 0193 		break;
; 0000 0194 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0195 // Sous menu [22] : Choix d'un test de dplacement
; 0000 0196 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0197 		case Menu22_Deplacements: if (Menu_1 != Menu)
_0x44:
	CPI  R30,LOW(0x6)
	BREQ PC+3
	JMP _0x4E
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x4F
; 0000 0198 			{
; 0000 0199 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuDeplacements);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuDeplacements
	LDS  R31,_Ligne0MenuDeplacements+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 019A 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 019B 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 019C 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 019D 			}
; 0000 019E 
; 0000 019F 			switch (BP_I2C)
_0x4F:
	__GETB1SX 106
; 0000 01A0 				{
; 0000 01A1 					case ENTR_I2C: Menu = Selection_Deplacements;  break;
	CPI  R30,LOW(0x40)
	BRNE _0x53
	LDI  R30,LOW(8)
	RJMP _0x110
; 0000 01A2 					case FlecheH_I2C: Menu = Menu21_Infos_MD23;  break;
_0x53:
	CPI  R30,LOW(0x2)
	BRNE _0x54
	LDI  R30,LOW(5)
	RJMP _0x110
; 0000 01A3 					case FlecheB_I2C: Menu = Menu20_Mode_MD23;  break;
_0x54:
	CPI  R30,LOW(0x4)
	BRNE _0x55
	LDI  R30,LOW(4)
	RJMP _0x110
; 0000 01A4 					case ECHAP_I2C : Menu = Menu2_MD23; break;              // touche ECHAP
_0x55:
	CPI  R30,LOW(0x80)
	BRNE _0x57
	LDI  R30,LOW(1)
	RJMP _0x110
; 0000 01A5 					default: Menu = Menu22_Deplacements ;
_0x57:
	LDI  R30,LOW(6)
_0x110:
	STS  _Menu,R30
; 0000 01A6 				}
; 0000 01A7 
; 0000 01A8 			Menu_1 = Menu22_Deplacements ;
	LDI  R30,LOW(6)
	RJMP _0x10B
; 0000 01A9 		break;
; 0000 01AA // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01AB // Fin des sous menus
; 0000 01AC // ============================================================================================================================
; 0000 01AD // Tests ----------------------------------------------------------------------------------------------------------------------
; 0000 01AE // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01AF // Test associ  [1]: Affichage du nom du BP et de la LED  laquelle il est associ sur le LCD
; 0000 01B0 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01B1 			case Copie_BP_Sur_Led : if ((Menu_1 != Menu) || ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF)))
_0x4E:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x58
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x5A
	__GETB1SX 105
	__GETB2SX 106
	CP   R30,R26
	BREQ _0x5B
	CPI  R26,LOW(0xFF)
	BRNE _0x5A
_0x5B:
	RJMP _0x59
_0x5A:
; 0000 01B2 				{
; 0000 01B3 				 sprintf(Buffer_for_LCD_Line0,TexteTest1BpsurLed);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteTest1BpsurLed
	LDS  R31,_TexteTest1BpsurLed+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01B4 
; 0000 01B5 				 switch (BP_I2C)
	__GETB1SX 106
; 0000 01B6 				  {
; 0000 01B7 				 	case ENTR_I2C : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
	CPI  R30,LOW(0x40)
	BRNE _0x61
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpEntrSurD6
	LDS  R31,_BpEntrSurD6+1
	RJMP _0x111
; 0000 01B8 				 	case FlecheH_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
_0x61:
	CPI  R30,LOW(0x2)
	BRNE _0x62
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpFlecheHSurD1
	LDS  R31,_BpFlecheHSurD1+1
	RJMP _0x111
; 0000 01B9 				 	case FlecheB_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
_0x62:
	CPI  R30,LOW(0x4)
	BRNE _0x63
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpFlecheHSurD2
	LDS  R31,_BpFlecheHSurD2+1
	RJMP _0x111
; 0000 01BA 				 	case ECHAP_I2C : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
_0x63:
	CPI  R30,LOW(0x80)
	BRNE _0x64
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpEchSurD7
	LDS  R31,_BpEchSurD7+1
	RJMP _0x111
; 0000 01BB 				 	case OK_I2C : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
_0x64:
	CPI  R30,LOW(0x20)
	BRNE _0x65
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpOkSurD5
	LDS  R31,_BpOkSurD5+1
	RJMP _0x111
; 0000 01BC 				 	case MOINS_I2C: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
_0x65:
	CPI  R30,LOW(0x8)
	BRNE _0x66
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpMoinsSurD3
	LDS  R31,_BpMoinsSurD3+1
	RJMP _0x111
; 0000 01BD 				 	case PLUS_I2C: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
_0x66:
	CPI  R30,LOW(0x1)
	BRNE _0x67
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpPlusSurD0
	LDS  R31,_BpPlusSurD0+1
	RJMP _0x111
; 0000 01BE 				 	case SET_I2C: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
_0x67:
	CPI  R30,LOW(0x10)
	BRNE _0x68
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpSetSurD4
	LDS  R31,_BpSetSurD4+1
	RJMP _0x111
; 0000 01BF 				 	case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
_0x68:
	CPI  R30,0
	BRNE _0x60
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
_0x111:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01C0 				  }
_0x60:
; 0000 01C1 
; 0000 01C2 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01C3 					BP_I2C_1 = BP_I2C;
	__GETB1SX 106
	__PUTB1SX 105
; 0000 01C4 			   	 }
; 0000 01C5 
; 0000 01C6         		if (BP_I2C == ECHAP_I2C)
_0x59:
	__GETB2SX 106
	CPI  R26,LOW(0x80)
	BRNE _0x6A
; 0000 01C7         		  {
; 0000 01C8         			Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	MOVW R30,R28
	SUBI R30,LOW(-(150))
	SBCI R31,HIGH(-(150))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 149
	COM  R30
	ST   X,R30
; 0000 01C9         			TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(150))
	SBCI R31,HIGH(-(150))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 01CA         			delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01CB         			Menu = Menu1_LED_BP;
	LDI  R30,LOW(0)
	RJMP _0x112
; 0000 01CC         		  }
; 0000 01CD         		else  Menu = Copie_BP_Sur_Led;
_0x6A:
	LDI  R30,LOW(3)
_0x112:
	STS  _Menu,R30
; 0000 01CE 
; 0000 01CF 			    Menu_1 = Copie_BP_Sur_Led;
	LDI  R30,LOW(3)
	RJMP _0x10B
; 0000 01D0 			break;
; 0000 01D1 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01D2 // Gestion des rglage(s) associ(s) au sous-menu "[20] Choix_Modes" : Rglage du mode de commande des moteurs
; 0000 01D3 // (Le premier rglage est "[200] Mode 0"
; 0000 01D4 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01D5 	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
_0x58:
	CPI  R30,LOW(0x7)
	BREQ PC+3
	JMP _0x6C
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x6E
	__GETB1SX 97
	__GETB2SX 98
	CP   R30,R26
	BREQ _0x6D
_0x6E:
; 0000 01D6 	          {
; 0000 01D7 	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,408
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 101
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 01D8 	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01D9 	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01DA 	        	 Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01DB 	        	 Choix_Mode_1 = Choix_Mode;
	__GETB1SX 97
	__PUTB1SX 98
; 0000 01DC 	          }
; 0000 01DD 
; 0000 01DE 	          switch (BP_I2C)
_0x6D:
	__GETB1SX 106
; 0000 01DF 				{
; 0000 01E0 					case ECHAP_I2C : Menu=Menu20_Mode_MD23; break;  // touche ECHAP
	CPI  R30,LOW(0x80)
	BRNE _0x73
	LDI  R30,LOW(4)
	RJMP _0x113
; 0000 01E1 					case FlecheH_I2C: Choix_Mode = Choix_Mode - 1; if (Choix_Mode < 0) Choix_Mode=3;  break;
_0x73:
	CPI  R30,LOW(0x2)
	BRNE _0x74
	__GETB1SX 97
	SUBI R30,LOW(1)
	__PUTB1SX 97
	__GETB2SX 97
	CPI  R26,0
	BRGE _0x75
	LDI  R30,LOW(3)
	__PUTB1SX 97
_0x75:
	RJMP _0x72
; 0000 01E2 					case FlecheB_I2C:  Choix_Mode = Choix_Mode + 1; if (Choix_Mode > 3) Choix_Mode=0 ;  break;
_0x74:
	CPI  R30,LOW(0x4)
	BRNE _0x76
	__GETB1SX 97
	SUBI R30,-LOW(1)
	__PUTB1SX 97
	__GETB2SX 97
	CPI  R26,LOW(0x4)
	BRLT _0x77
	LDI  R30,LOW(0)
	__PUTB1SX 97
_0x77:
	RJMP _0x72
; 0000 01E3 					case ENTR_I2C: if (Choix_Mode == 0)
_0x76:
	CPI  R30,LOW(0x40)
	BRNE _0x7A
	__GETB1SX 97
	CPI  R30,0
	BRNE _0x79
; 0000 01E4                                         {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Valeurs_Mode0_MD23;}
	LDI  R30,LOW(128)
	__PUTB1SX 102
	__PUTB1SX 100
	LDI  R30,LOW(9)
	STS  _Menu,R30
; 0000 01E5                     break;
_0x79:
	RJMP _0x72
; 0000 01E6 
; 0000 01E7 					default: Menu=Choix_Mode_MD23;
_0x7A:
	LDI  R30,LOW(7)
_0x113:
	STS  _Menu,R30
; 0000 01E8 				}
_0x72:
; 0000 01E9 
; 0000 01EA 			  Menu_1 = Choix_Mode_MD23;
	LDI  R30,LOW(7)
	RJMP _0x10B
; 0000 01EB 	        break;
; 0000 01EC // ----------------------------------------------------------------------------------------------------------------------------
; 0000 01ED             case Reglage_Valeurs_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
_0x6C:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x7B
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x7D
	__GETB1SX 102
	__GETB2SX 101
	CP   R30,R26
	BRNE _0x7D
	__GETB1SX 100
	__GETB2SX 99
	CP   R30,R26
	BRNE _0x7D
	__GETB1SX 104
	__GETB2SX 103
	CP   R30,R26
	BRNE _0x7D
	RJMP _0x7C
_0x7D:
; 0000 01EE               {
; 0000 01EF                 sprintf(Buffer_for_LCD_Line0,"[200]Mode%-u (+%-u) ",Choix_Mode,Finesse);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,427
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 101
	CALL __CBD1
	CALL __PUTPARD1
	__GETB1SX 112
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 01F0                 sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,448
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 106
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB1SX 108
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 01F1                 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01F2                 Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01F3                 SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
	__GETB1SX 102
	__PUTB1SX 101
	__GETB1SX 100
	__PUTB1SX 99
	__GETB1SX 104
	__PUTB1SX 103
; 0000 01F4               }
; 0000 01F5 
; 0000 01F6 
; 0000 01F7               switch (BP_I2C)
_0x7C:
	__GETB1SX 106
; 0000 01F8 				{
; 0000 01F9 				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0x82
	LDI  R30,LOW(7)
	RJMP _0x114
; 0000 01FA 
; 0000 01FB 				 	case PLUS_I2C:
_0x82:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x83
; 0000 01FC 				 		switch (Choix_Moteur)
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
; 0000 01FD 				 		  {
; 0000 01FE 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0x87
	__GETB2SX 104
	CPI  R26,LOW(0x1)
	BRNE _0x88
; 0000 01FF 				 		   					    if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
	__GETB2SX 102
	CPI  R26,LOW(0xFF)
	BRSH _0x89
	MOVW R26,R28
	SUBI R26,LOW(-(102))
	SBCI R27,HIGH(-(102))
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RJMP _0x8A
_0x89:
	LDI  R30,LOW(255)
	__PUTB1SX 102
; 0000 0200 				 		   			      else // Finesse == 0
_0x8A:
	RJMP _0x8B
_0x88:
; 0000 0201 				 		   					    if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
	__GETB2SX 102
	CPI  R26,LOW(0xFA)
	BRSH _0x8C
	__GETB1SX 102
	SUBI R30,-LOW(5)
	RJMP _0x115
_0x8C:
	LDI  R30,LOW(255)
_0x115:
	__PUTB1SX 102
; 0000 0202 				 		   	break;
_0x8B:
	RJMP _0x86
; 0000 0203 				 		   	case Moteur2: if (Finesse==1)
_0x87:
	CPI  R30,LOW(0x1)
	BRNE _0x86
	__GETB2SX 104
	CPI  R26,LOW(0x1)
	BRNE _0x8F
; 0000 0204 				 		   					    if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
	__GETB2SX 100
	CPI  R26,LOW(0xFF)
	BRSH _0x90
	MOVW R26,R28
	SUBI R26,LOW(-(100))
	SBCI R27,HIGH(-(100))
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RJMP _0x91
_0x90:
	LDI  R30,LOW(255)
	__PUTB1SX 100
; 0000 0205 				 		   	              else // Finesse == 0
_0x91:
	RJMP _0x92
_0x8F:
; 0000 0206 				 		   					    if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
	__GETB2SX 100
	CPI  R26,LOW(0xFA)
	BRSH _0x93
	__GETB1SX 100
	SUBI R30,-LOW(5)
	RJMP _0x116
_0x93:
	LDI  R30,LOW(255)
_0x116:
	__PUTB1SX 100
; 0000 0207 				 		   	break;
_0x92:
; 0000 0208 				 		  }
_0x86:
; 0000 0209 				 	break;
	RJMP _0x81
; 0000 020A 
; 0000 020B 				 	case MOINS_I2C:
_0x83:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x95
; 0000 020C 				 	    switch (Choix_Moteur)
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
; 0000 020D 				 		  {
; 0000 020E 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0x99
	__GETB2SX 104
	CPI  R26,LOW(0x1)
	BRNE _0x9A
; 0000 020F 				 		   					    if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
	__GETB2SX 102
	CPI  R26,LOW(0x1)
	BRLO _0x9B
	MOVW R26,R28
	SUBI R26,LOW(-(102))
	SBCI R27,HIGH(-(102))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RJMP _0x9C
_0x9B:
	LDI  R30,LOW(0)
	__PUTB1SX 102
; 0000 0210 				 		   			      else  // Finesse == 0
_0x9C:
	RJMP _0x9D
_0x9A:
; 0000 0211 				 		   					    if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0;
	__GETB2SX 102
	CPI  R26,LOW(0x6)
	BRLO _0x9E
	__GETB1SX 102
	SUBI R30,LOW(5)
	RJMP _0x117
_0x9E:
	LDI  R30,LOW(0)
_0x117:
	__PUTB1SX 102
; 0000 0212 				 		   	break;
_0x9D:
	RJMP _0x98
; 0000 0213 				 		   	case Moteur2: if (Finesse==1)
_0x99:
	CPI  R30,LOW(0x1)
	BRNE _0x98
	__GETB2SX 104
	CPI  R26,LOW(0x1)
	BRNE _0xA1
; 0000 0214 				 		   					    if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
	__GETB2SX 100
	CPI  R26,LOW(0x1)
	BRLO _0xA2
	MOVW R26,R28
	SUBI R26,LOW(-(100))
	SBCI R27,HIGH(-(100))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RJMP _0xA3
_0xA2:
	LDI  R30,LOW(0)
	__PUTB1SX 100
; 0000 0215 				 		   			      else  // Finesse == 0
_0xA3:
	RJMP _0xA4
_0xA1:
; 0000 0216 				 		   					    if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
	__GETB2SX 100
	CPI  R26,LOW(0x6)
	BRLO _0xA5
	__GETB1SX 100
	SUBI R30,LOW(5)
	RJMP _0x118
_0xA5:
	LDI  R30,LOW(0)
_0x118:
	__PUTB1SX 100
; 0000 0217 				 			break;
_0xA4:
; 0000 0218 				 		  }
_0x98:
; 0000 0219 				 	break;
	RJMP _0x81
; 0000 021A 
; 0000 021B 				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; break;
_0x95:
	CPI  R30,LOW(0x2)
	BRNE _0xA7
	__GETB2SX 104
	CPI  R26,LOW(0x1)
	BRNE _0xA8
	LDI  R30,LOW(5)
	RJMP _0x119
_0xA8:
	LDI  R30,LOW(1)
_0x119:
	__PUTB1SX 104
	RJMP _0x81
; 0000 021C 
; 0000 021D 				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; break;
_0xA7:
	CPI  R30,LOW(0x4)
	BRNE _0xAA
	__GETB2SX 104
	CPI  R26,LOW(0x1)
	BRNE _0xAB
	LDI  R30,LOW(5)
	RJMP _0x11A
_0xAB:
	LDI  R30,LOW(1)
_0x11A:
	__PUTB1SX 104
	RJMP _0x81
; 0000 021E 
; 0000 021F 				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; break;
_0xAA:
	CPI  R30,LOW(0x20)
	BRNE _0xAD
	SBRS R2,0
	RJMP _0xAE
	CLT
	RJMP _0x11B
_0xAE:
	SET
_0x11B:
	BLD  R2,0
	RJMP _0x81
; 0000 0220 
; 0000 0221 				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2;
_0xAD:
	CPI  R30,LOW(0x10)
	BRNE _0xB1
	MOVW R30,R28
	SUBI R30,LOW(-(120))
	SBCI R31,HIGH(-(120))
	ADIW R30,2
	__GETB2SX 102
	STD  Z+0,R26
	MOVW R30,R28
	SUBI R30,LOW(-(117))
	SBCI R31,HIGH(-(117))
	ADIW R30,2
	__GETB2SX 100
	STD  Z+0,R26
; 0000 0222 				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(120))
	SBCI R31,HIGH(-(120))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0223 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(117))
	SBCI R31,HIGH(-(117))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0224 				    break;
	RJMP _0x81
; 0000 0225 
; 0000 0226 					default: Menu = Reglage_Valeurs_Mode0_MD23;
_0xB1:
	LDI  R30,LOW(9)
_0x114:
	STS  _Menu,R30
; 0000 0227 				}
_0x81:
; 0000 0228 			  Menu_1 = Reglage_Valeurs_Mode0_MD23;
	LDI  R30,LOW(9)
	RJMP _0x10B
; 0000 0229 			break;
; 0000 022A // ----------------------------------------------------------------------------------------------------------------------------
; 0000 022B // Gestion des affichages associ au sous-menu "[21] Affichage ..."  (Contenu des registres de la carte MD23 ou MD25)
; 0000 022C // ----------------------------------------------------------------------------------------------------------------------------
; 0000 022D // Affichage de tous les registres de la carte MD23/MD25 (associ  "[210] Affichage registres")
; 0000 022E 		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];
_0x7B:
	CPI  R30,LOW(0x10)
	BREQ PC+3
	JMP _0xB2
	LDD  R21,Y+45
; 0000 022F 			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xB4
	__CPWRR 18,19,16,17
	BRNE _0xB4
	CP   R21,R20
	BREQ _0xB3
_0xB4:
; 0000 0230 			  {
; 0000 0231 				sprintf(Buffer_for_LCD_Line0,"[210] Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,464
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R18
	CALL __CWD1
	CALL __PUTPARD1
	MOVW R30,R18
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,47
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 0232 				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1PlusMoins
	LDS  R31,_Ligne1PlusMoins+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 0233 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0234 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0235 				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
	MOVW R16,R18
	MOV  R20,R21
; 0000 0236 			  }
; 0000 0237 
; 0000 0238 			switch (BP_I2C)
_0xB3:
	__GETB1SX 106
; 0000 0239 				{
; 0000 023A 					case ECHAP_I2C : Menu=Menu21_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xB9
	LDI  R30,LOW(5)
	RJMP _0x11C
; 0000 023B 					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break;
_0xB9:
	CPI  R30,LOW(0x1)
	BRNE _0xBA
	__CPWRN 18,19,16
	BRGE _0xBB
	__ADDWRN 18,19,1
	RJMP _0xBC
_0xBB:
	__GETWRN 18,19,0
_0xBC:
	RJMP _0xB8
; 0000 023C 					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break;
_0xBA:
	CPI  R30,LOW(0x8)
	BRNE _0xBD
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0xBE
	__SUBWRN 18,19,1
	RJMP _0xBF
_0xBE:
	__GETWRN 18,19,16
_0xBF:
	RJMP _0xB8
; 0000 023D 					case FlecheH_I2C: Menu = Info_TensionBatt;  break;
_0xBD:
	CPI  R30,LOW(0x2)
	BRNE _0xC0
	LDI  R30,LOW(14)
	RJMP _0x11C
; 0000 023E 					case FlecheB_I2C: Menu = Info_Version;  break;
_0xC0:
	CPI  R30,LOW(0x4)
	BRNE _0xC2
	LDI  R30,LOW(15)
	RJMP _0x11C
; 0000 023F 					default: Menu=Info_All;
_0xC2:
	LDI  R30,LOW(16)
_0x11C:
	STS  _Menu,R30
; 0000 0240 				}
_0xB8:
; 0000 0241 
; 0000 0242 			Menu_1 = Info_All;
	LDI  R30,LOW(16)
	RJMP _0x10B
; 0000 0243 		break;
; 0000 0244 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0245 // Affichage de la version du logiciel implant dans la carte MD23 ou MD25 (associ  "[211] Affichage version soft")
; 0000 0246 		case Info_Version:	Version = Table_Registers_MD23[14];
_0xB2:
	CPI  R30,LOW(0xF)
	BREQ PC+3
	JMP _0xC3
	LDD  R30,Y+53
	__PUTB1SX 93
; 0000 0247 			if ((Menu_1 != Menu)||(Version_1 != Version))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xC5
	__GETB1SX 93
	__GETB2SX 94
	CP   R30,R26
	BREQ _0xC4
_0xC5:
; 0000 0248    			  {
; 0000 0249 				sprintf(Buffer_for_LCD_Line0,"[211] Vers.=%-u  ",Version);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,482
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 97
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 024A 				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 024B 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 024C 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 024D 				Version_1 = Version;
	__GETB1SX 93
	__PUTB1SX 94
; 0000 024E 			  }
; 0000 024F 
; 0000 0250 			switch (BP_I2C)
_0xC4:
	__GETB1SX 106
; 0000 0251 				{
; 0000 0252 					case ECHAP_I2C : Menu=Menu21_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xCA
	LDI  R30,LOW(5)
	RJMP _0x11D
; 0000 0253 					case FlecheH_I2C: Menu = Info_All;  break;
_0xCA:
	CPI  R30,LOW(0x2)
	BRNE _0xCB
	LDI  R30,LOW(16)
	RJMP _0x11D
; 0000 0254 					case FlecheB_I2C: Menu = Info_TensionBatt;  break;
_0xCB:
	CPI  R30,LOW(0x4)
	BRNE _0xCD
	LDI  R30,LOW(14)
	RJMP _0x11D
; 0000 0255 					default: Menu=Info_Version;
_0xCD:
	LDI  R30,LOW(15)
_0x11D:
	STS  _Menu,R30
; 0000 0256 				}
; 0000 0257 
; 0000 0258 			Menu_1 = Info_Version;
	LDI  R30,LOW(15)
	RJMP _0x10B
; 0000 0259 		break;
; 0000 025A // ----------------------------------------------------------------------------------------------------------------------------
; 0000 025B // Affichage de la tension d'alimentation de la carte MD23 ou MD25  (associ  "[212] Affichage tension batterie")
; 0000 025C 		case Info_TensionBatt:  	Ubatt = Table_Registers_MD23[11];
_0xC3:
	CPI  R30,LOW(0xE)
	BREQ PC+3
	JMP _0xCE
	LDD  R30,Y+50
	__PUTB1SX 95
; 0000 025D 			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xD0
	__GETB1SX 95
	__GETB2SX 96
	CP   R30,R26
	BRNE _0xD0
	RJMP _0xCF
_0xD0:
; 0000 025E    			  {
; 0000 025F 					sprintf(Buffer_for_LCD_Line0,"[212]Ubat=%-u.%-uV ",Ubatt/10, Ubatt-10*(Ubatt/10));
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,500
	ST   -Y,R31
	ST   -Y,R30
	__GETB2SX 99
	LDI  R30,LOW(10)
	CALL __DIVB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB2SX 103
	LDI  R30,LOW(10)
	CALL __DIVB21U
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	__GETB2SX 103
	CALL __SWAPB12
	SUB  R30,R26
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 0260 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 0261 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0262                     Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0263                     Ubatt_1 = Ubatt;
	__GETB1SX 95
	__PUTB1SX 96
; 0000 0264 			  }
; 0000 0265 
; 0000 0266 			switch (BP_I2C)
_0xCF:
	__GETB1SX 106
; 0000 0267 				{
; 0000 0268 					case ECHAP_I2C : Menu=Menu21_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xD5
	LDI  R30,LOW(5)
	RJMP _0x11E
; 0000 0269 					case FlecheH_I2C: Menu = Info_Version;  break;
_0xD5:
	CPI  R30,LOW(0x2)
	BRNE _0xD6
	LDI  R30,LOW(15)
	RJMP _0x11E
; 0000 026A 					case FlecheB_I2C: Menu = Info_All;  break;
_0xD6:
	CPI  R30,LOW(0x4)
	BRNE _0xD8
	LDI  R30,LOW(16)
	RJMP _0x11E
; 0000 026B 					default: Menu=Info_TensionBatt;
_0xD8:
	LDI  R30,LOW(14)
_0x11E:
	STS  _Menu,R30
; 0000 026C 				}
; 0000 026D 
; 0000 026E 			Menu_1 = Info_TensionBatt;
	LDI  R30,LOW(14)
	RJMP _0x10B
; 0000 026F 		break;
; 0000 0270 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0271 // Slection d'un type de dplacement associ au sous-menu "[22] Choix dplacement" ( La premire slection est "Ligne droite"
; 0000 0272 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0273 		case Selection_Deplacements:
_0xCE:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0xD9
; 0000 0274 			if ((Menu_1 != Menu)|| (SelecDeplacement_1 != SelecDeplacement))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xDB
	__GETB1SX 80
	__GETB2SX 79
	CP   R30,R26
	BREQ _0xDA
_0xDB:
; 0000 0275    			  {
; 0000 0276                     switch (SelecDeplacement)
	__GETB1SX 80
; 0000 0277                     {
; 0000 0278 					    case 0: sprintf(Buffer_for_LCD_Line0,"[220]Lig. droite"); break;
	CPI  R30,0
	BREQ _0x11F
; 0000 0279                         case 1: sprintf(Buffer_for_LCD_Line0,"[221]Virage 90 "); break;
	CPI  R30,LOW(0x1)
	BRNE _0xE2
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,537
	RJMP _0x120
; 0000 027A                         default: sprintf(Buffer_for_LCD_Line0,"[220]Lig. droite");
_0xE2:
_0x11F:
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,520
_0x120:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 027B                     }
; 0000 027C 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchapSET);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapSET
	LDS  R31,_Ligne1ChoixEchapSET+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 027D 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 027E                     Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 027F                     SelecDeplacement_1 = SelecDeplacement;
	__GETB1SX 80
	__PUTB1SX 79
; 0000 0280 			  }
; 0000 0281 
; 0000 0282 			switch (BP_I2C)
_0xDA:
	__GETB1SX 106
; 0000 0283 				{
; 0000 0284 					case ECHAP_I2C : Menu = Menu22_Deplacements; break;
	CPI  R30,LOW(0x80)
	BRNE _0xE6
	LDI  R30,LOW(6)
	RJMP _0x121
; 0000 0285 					case FlecheH_I2C: if (SelecDeplacement > 0) SelecDeplacement--; else SelecDeplacement=1;  break;
_0xE6:
	CPI  R30,LOW(0x2)
	BRNE _0xE7
	__GETB2SX 80
	CPI  R26,LOW(0x1)
	BRLO _0xE8
	MOVW R26,R28
	SUBI R26,LOW(-(80))
	SBCI R27,HIGH(-(80))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RJMP _0xE9
_0xE8:
	LDI  R30,LOW(1)
	__PUTB1SX 80
_0xE9:
	RJMP _0xE5
; 0000 0286 					case FlecheB_I2C: if (SelecDeplacement < 1) SelecDeplacement++; else SelecDeplacement=0;  break;
_0xE7:
	CPI  R30,LOW(0x4)
	BRNE _0xEA
	__GETB2SX 80
	CPI  R26,LOW(0x1)
	BRSH _0xEB
	MOVW R26,R28
	SUBI R26,LOW(-(80))
	SBCI R27,HIGH(-(80))
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RJMP _0xEC
_0xEB:
	LDI  R30,LOW(0)
	__PUTB1SX 80
_0xEC:
	RJMP _0xE5
; 0000 0287                     case SET_I2C:   switch (SelecDeplacement) // Rglage des vitesses (sera remplac par l'appel d'une fonction)
_0xEA:
	CPI  R30,LOW(0x10)
	BRNE _0xF4
	__GETB1SX 80
; 0000 0288                                     {                         // Seul le Mode 0 est gr !!!!!!!!!!!!!!!!!
; 0000 0289                                      case 0:    Speed1[2] = 133; Speed2[2] = 133; break;    // Dplacement en ligne droite
	CPI  R30,0
	BRNE _0xF1
	LDI  R30,LOW(133)
	__PUTB1SX 122
	RJMP _0x122
; 0000 028A                                      case 1:    Speed1[2] = 133; Speed2[2] = 138; break;    // Virage  90
_0xF1:
	CPI  R30,LOW(0x1)
	BRNE _0xF3
	LDI  R30,LOW(133)
	__PUTB1SX 122
	LDI  R30,LOW(138)
	RJMP _0x122
; 0000 028B                                      default :  Speed1[2] = 128; Speed2[2] = 128;           // Arrt des moteurs en mode 0
_0xF3:
	LDI  R30,LOW(128)
	__PUTB1SX 122
_0x122:
	__PUTB1SX 119
; 0000 028C                                     }
; 0000 028D 
; 0000 028E                                     // Transmission des vitesses  la carte MD23 ou MD25
; 0000 028F                                     TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(120))
	SBCI R31,HIGH(-(120))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0290 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(117))
	SBCI R31,HIGH(-(117))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0291                                     Menu = Test_Deplacements;
	LDI  R30,LOW(18)
	RJMP _0x121
; 0000 0292                     break;
; 0000 0293 					default: Menu = Selection_Deplacements;
_0xF4:
	LDI  R30,LOW(8)
_0x121:
	STS  _Menu,R30
; 0000 0294 				}
_0xE5:
; 0000 0295 
; 0000 0296 			Menu_1 = Selection_Deplacements;
	LDI  R30,LOW(8)
	RJMP _0x10B
; 0000 0297 		break;
; 0000 0298 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0299 // Gestion d'un dplacement (associ  "[220] Dplacement ligne droite" ou  "[221] Virage 90")
; 0000 029A 		case Test_Deplacements:
_0xD9:
	CPI  R30,LOW(0x12)
	BREQ PC+3
	JMP _0xF5
; 0000 029B             // Calcul du dplacement en nombre de priodes du codeur
; 0000 029C             Codeur1 = (long int)65536*Table_Registers_MD23[4] + (long int)256*Table_Registers_MD23[5] + Table_Registers_MD23[6];
	LDD  R30,Y+43
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x10000
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+44
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x100
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LDD  R30,Y+45
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__PUTD1SX 89
; 0000 029D             Codeur2 = (long int)65536*Table_Registers_MD23[8] + (long int)256*Table_Registers_MD23[9] + Table_Registers_MD23[10];
	LDD  R30,Y+47
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x10000
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x100
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LDD  R30,Y+49
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__PUTD1SX 81
; 0000 029E 
; 0000 029F             // Test si la distance prvue a t parcourue
; 0000 02A0             if (Codeur1 >= 3437)                                              // Si distance >= N soit(3600*distance(m)/Pi)
	__GETD2SX 89
	__CPD2N 0xD6D
	BRLT _0xF6
; 0000 02A1                 {                                                                  // Exemple: distance = 3m => N = 3437
; 0000 02A2                   Speed1[2] = 128; Speed2[2] = 128;                                // Arrt des moteurs
	LDI  R30,LOW(128)
	__PUTB1SX 122
	__PUTB1SX 119
; 0000 02A3 				  TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(120))
	SBCI R31,HIGH(-(120))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02A4 				  TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(117))
	SBCI R31,HIGH(-(117))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02A5 
; 0000 02A6                 }
; 0000 02A7             else {
	RJMP _0xF7
_0xF6:
; 0000 02A8 			        if ((Menu_1 != Menu) || (Codeur1_1 != Codeur1))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xF9
	__GETD1SX 89
	__GETD2SX 85
	CALL __CPD12
	BRNE _0xF9
	RJMP _0xF8
_0xF9:
; 0000 02A9    			        {
; 0000 02AA                         ltoa(Codeur1, AfficheDeplacement1);                      // Conversion du dplacement en une chane de
	__GETD1SX 89
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(72))
	SBCI R31,HIGH(-(72))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 02AB                         ltoa(Codeur2, AfficheDeplacement2);                      // caractres avant affichage sur le LCD
	__GETD1SX 81
	CALL __PUTPARD1
	MOVW R30,R28
	ADIW R30,61
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 02AC                         strcpy(Buffer_for_LCD_Line0,"Enc1=");
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0xFB,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpy
; 0000 02AD                         strcat(Buffer_for_LCD_Line0, AfficheDeplacement1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(70))
	SBCI R31,HIGH(-(70))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 02AE 					    strcpyf(Buffer_for_LCD_Line1,"Enc2=");
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,560
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 02AF                         strcat(Buffer_for_LCD_Line1, AfficheDeplacement2);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,59
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 02B0                         strcat(Buffer_for_LCD_Line1," [Echa]");
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0xFB,6
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 02B1 					    Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 02B2                         Codeur1_1 = Codeur1;
	__GETD1SX 89
	__PUTD1SX 85
; 0000 02B3 			        }
; 0000 02B4                  }
_0xF8:
_0xF7:
; 0000 02B5 
; 0000 02B6 			switch (BP_I2C)
	__GETB1SX 106
; 0000 02B7 				{
; 0000 02B8 					case ECHAP_I2C : Menu = Selection_Deplacements;
	CPI  R30,LOW(0x80)
	BRNE _0x100
	LDI  R30,LOW(8)
	STS  _Menu,R30
; 0000 02B9                                      Speed1[2] = 128; Speed2[2] = 128;                          // Arrt des moteurs
	LDI  R30,LOW(128)
	__PUTB1SX 122
	__PUTB1SX 119
; 0000 02BA 				                     TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(120))
	SBCI R31,HIGH(-(120))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02BB 				                     TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(117))
	SBCI R31,HIGH(-(117))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02BC                                      delay_ms(500); // Arrt complet des moteurs !
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 02BD                                      TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23)); // Remise  zro des encodeurs
	MOVW R30,R28
	SUBI R30,LOW(-(126))
	SBCI R31,HIGH(-(126))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02BE                     break;
	RJMP _0xFE
; 0000 02BF 					default: Menu = Test_Deplacements;
_0x100:
	LDI  R30,LOW(18)
	STS  _Menu,R30
; 0000 02C0 				}
_0xFE:
; 0000 02C1 
; 0000 02C2 			Menu_1 = Test_Deplacements;
	LDI  R30,LOW(18)
	RJMP _0x10B
; 0000 02C3 		break;
; 0000 02C4 // ============================================================================================================================
; 0000 02C5 // Commande de quatre servos relis  la carte SD21  associ au menu "[3] Test SD21"
; 0000 02C6 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 02C7         case Test_SD21 : if (Menu_1 != Menu)
_0xF5:
	CPI  R30,LOW(0x11)
	BREQ PC+3
	JMP _0x1E
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x102
; 0000 02C8        		{
; 0000 02C9                 sprintf(Buffer_for_LCD_Line0,TexteTestSD21);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteTestSD21
	LDS  R31,_TexteTestSD21+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02CA 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap5s);
	MOVW R30,R28
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap5s
	LDS  R31,_Ligne1ChoixEchap5s+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02CB 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,22
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 02CC        		}
; 0000 02CD 
; 0000 02CE             // Position initial du servo1
; 0000 02CF             RegSpeedValue = Vitesse; RegPosLByte= 0xE8; RegPosHByte=0x03;  					// 1000s = 03E8h
_0x102:
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ADIW R30,2
	LDD  R26,Y+4
	STD  Z+0,R26
	LDI  R30,LOW(232)
	__PUTB1SX 110
	LDI  R30,LOW(3)
	__PUTB1SX 111
; 0000 02D0             TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));			// Vitesse, LSByte, MSByte
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02D1             // =================================================================================================================
; 0000 02D2             // ================================================ Boucle  ========================================================
; 0000 02D3             // =================================================================================================================
; 0000 02D4             // Pour info
; 0000 02D5             // 1000 = 3E8h	valeur min
; 0000 02D6             // 1250 = 4E2h
; 0000 02D7             // 1500 = 5DCh
; 0000 02D8             // 1750 = 6D6h
; 0000 02D9             // 1950 = 7E9h et + ?
; 0000 02DA             // -----------------------------------------------------------------------------------------------------------------
; 0000 02DB             // Les valeurs "n Servo + Position" transmises  la carte SD21 par le bus I2C doivent tre places dans
; 0000 02DC             // les tableaux situs dans le fichier "TableRob.h"
; 0000 02DD             // Le nom des servos est dclar dans le fichier sd21.h
; 0000 02DE             // -----------------------------------------------------------------------------------------------------------------
; 0000 02DF 
; 0000 02E0             while (BP_I2C != ECHAP_I2C) // Test des servos tant que l'on n'appuie pas sur "ECHAP"
_0x103:
	__GETB2SX 106
	CPI  R26,LOW(0x80)
	BRNE PC+3
	JMP _0x105
; 0000 02E1             {
; 0000 02E2                 // Configuration des paramtres "Servox" [0<x<5] et "position" envoys aux servos
; 0000 02E3                 for(i=0; i<sizeof(Tab_Servo); i++)
	LDI  R30,LOW(0)
	STD  Y+0,R30
	STD  Y+0+1,R30
_0x107:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,4
	BRLO PC+3
	JMP _0x108
; 0000 02E4                 {
; 0000 02E5                 // Configuration de la trame "Frame_I2C_Servo" avec les valeurs contenues dans les tableaux situs dans
; 0000 02E6                 // le fichier TableRob.h
; 0000 02E7                 NumServo = Tab_Servo[i]; RegPosLByte = LSBYTE(Tab_Position[i]);  RegPosHByte = MSBYTE(Tab_Position[i]);
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ADIW R30,1
	MOVW R26,R30
	LD   R30,Y
	LDD  R31,Y+1
	SUBI R30,LOW(-_Tab_Servo*2)
	SBCI R31,HIGH(-_Tab_Servo*2)
	LPM  R30,Z
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ADIW R30,3
	PUSH R31
	PUSH R30
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R26,LOW(_Tab_Position*2)
	LDI  R27,HIGH(_Tab_Position*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	ST   -Y,R31
	ST   -Y,R30
	CALL _LSBYTE
	POP  R26
	POP  R27
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ADIW R30,4
	PUSH R31
	PUSH R30
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R26,LOW(_Tab_Position*2)
	LDI  R27,HIGH(_Tab_Position*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	ST   -Y,R31
	ST   -Y,R30
	CALL _MSBYTE
	POP  R26
	POP  R27
	ST   X,R30
; 0000 02E8 
; 0000 02E9 	            // Envoi de la trame  "Frame_I2C_Servo"  la carte SD21
; 0000 02EA 	            TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02EB 
; 0000 02EC 	            // Visualisation de la position des valeurs places dans les tableaux sur les Led de la carte Sisi
; 0000 02ED 	            Frame_I2C_LED_Switching[1] = ~(i+1);
	MOVW R30,R28
	SUBI R30,LOW(-(150))
	SBCI R31,HIGH(-(150))
	ADIW R30,1
	MOVW R26,R30
	LD   R30,Y
	SUBI R30,-LOW(1)
	COM  R30
	ST   X,R30
; 0000 02EE 	            TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
	MOVW R30,R28
	SUBI R30,LOW(-(150))
	SBCI R31,HIGH(-(150))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02EF 	            delay_ms(tempo);
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 02F0                 } // fin du for
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	RJMP _0x107
_0x108:
; 0000 02F1 
; 0000 02F2                 BP_I2C = Lire_BP_I2C();
	CALL _Lire_BP_I2C
	__PUTB1SX 106
; 0000 02F3             }
	RJMP _0x103
_0x105:
; 0000 02F4             // Servo maintenus dans leur dernire position
; 0000 02F5             RegSpeedValue = 0; TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));
	LDI  R30,LOW(0)
	__PUTB1SX 109
	MOVW R30,R28
	SUBI R30,LOW(-(107))
	SBCI R31,HIGH(-(107))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 02F6 
; 0000 02F7 			Menu = Menu3_SD21 ; Menu_1 = Test_SD21 ;
	LDI  R30,LOW(2)
	STS  _Menu,R30
	LDI  R30,LOW(17)
_0x10B:
	STS  _Menu_1,R30
; 0000 02F8 
; 0000 02F9        break;
; 0000 02FA // ============================================================================================================================
; 0000 02FB     }// Fin du switch1
_0x1E:
; 0000 02FC 
; 0000 02FD     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	MOVW R30,R28
	SUBI R30,LOW(-(150))
	SBCI R31,HIGH(-(150))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 149
	COM  R30
	ST   X,R30
; 0000 02FE // ----------------------------------------------------------------------------------------------------------------------------
; 0000 02FF // ----------------------------------------  Champ Ecriture des rsultats  ----------------------------------------------------
; 0000 0300 // Ecriture sur les LED
; 0000 0301     TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  	// Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(150))
	SBCI R31,HIGH(-(150))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0302 // ----------------------------------------------------------------------------------------------------------------------------
; 0000 0303 //delay_ms(100);   // A utiliser pour visualiser les trames I2C
; 0000 0304   }; // Fin while(1)
	JMP  _0x18
; 0000 0305 
; 0000 0306 } //Fin main
_0x109:
	RJMP _0x109

	.DSEG
_0xFB:
	.BYTE 0xE
;// ============================================================================================================================
;// ============================================================================================================================
;
;

	.CSEG
_ltoa:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R16,LOW(0)
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000003
	__GETD1S 8
	CALL __ANEGD1
	__PUTD1S 8
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(45)
	ST   X,R30
_0x2000003:
_0x2000005:
	__GETD1S 2
	__GETD2S 8
	CALL __DIVD21U
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2000008
	CPI  R16,0
	BRNE _0x2000008
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x2000007
_0x2000008:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R16,LOW(1)
_0x2000007:
	__GETD1S 2
	__GETD2S 8
	CALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	__GETD1N 0xA
	CALL __DIVD21U
	__PUTD1S 2
	CALL __CPD10
	BREQ _0x2000006
	RJMP _0x2000005
_0x2000006:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	JMP  _0x2120003

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2020014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	JMP  _0x2120004
__print_G101:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2120005
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2120005:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG

	.CSEG
_strcat:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcat0:
    ld   r22,x+
    tst  r22
    brne strcat0
    sbiw r26,1
strcat1:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcat1
    movw r30,r24
    ret
_strcpy:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpy0:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcpy0
    movw r30,r24
    ret
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
_TWI_Master_Initialise:
	LDI  R30,LOW(32)
	OUT  0x0,R30
	LDI  R30,LOW(255)
	OUT  0x3,R30
	LDI  R30,LOW(4)
	OUT  0x36,R30
	RET
_TWI_Transceiver_Busy:
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
_TWI_Start_Transc_With_Data:
	ST   -Y,R17
_0x2080007:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2080007
	LDD  R30,Y+1
	STS  _TWI_msgSize_G104,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	STS  _TWI_buf_G104,R30
	ANDI R30,LOW(0x1)
	BRNE _0x208000A
	LDI  R17,LOW(1)
_0x208000C:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x208000D
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	MOVW R0,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x208000C
_0x208000D:
_0x208000A:
	LDI  R30,LOW(0)
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(248)
	STS  _TWI_state_G104,R30
	LDI  R30,LOW(165)
	OUT  0x36,R30
	LDD  R17,Y+0
	RJMP _0x2120002
_TWI_Get_Data_From_Transceiver:
	ST   -Y,R17
_0x2080011:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2080011
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	BREQ _0x2080014
	LDI  R17,LOW(0)
_0x2080016:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x2080017
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x2080016
_0x2080017:
_0x2080014:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	LDD  R17,Y+0
	RJMP _0x2120002
_twi_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	IN   R30,0x1
	CPI  R30,LOW(0x8)
	BREQ _0x208001C
	CPI  R30,LOW(0x10)
	BRNE _0x208001D
_0x208001C:
	LDI  R30,LOW(0)
	STS  _TWI_bufPtr_S1040006000,R30
	RJMP _0x208001E
_0x208001D:
	CPI  R30,LOW(0x18)
	BRNE _0x208001F
_0x208001E:
	RJMP _0x2080020
_0x208001F:
	CPI  R30,LOW(0x28)
	BRNE _0x2080021
_0x2080020:
	LDS  R30,_TWI_msgSize_G104
	LDS  R26,_TWI_bufPtr_S1040006000
	CP   R26,R30
	BRSH _0x2080022
	LDS  R30,_TWI_bufPtr_S1040006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1040006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	LD   R30,Z
	OUT  0x3,R30
	LDI  R30,LOW(133)
	RJMP _0x2080033
_0x2080022:
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
_0x2080033:
	OUT  0x36,R30
	RJMP _0x208001A
_0x2080021:
	CPI  R30,LOW(0x50)
	BRNE _0x2080024
	LDS  R30,_TWI_bufPtr_S1040006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1040006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	MOVW R26,R30
	IN   R30,0x3
	ST   X,R30
	RJMP _0x2080025
_0x2080024:
	CPI  R30,LOW(0x40)
	BRNE _0x2080026
_0x2080025:
	LDS  R30,_TWI_msgSize_G104
	SUBI R30,LOW(1)
	LDS  R26,_TWI_bufPtr_S1040006000
	CP   R26,R30
	BRSH _0x2080027
	LDI  R30,LOW(197)
	RJMP _0x2080034
_0x2080027:
	LDI  R30,LOW(133)
_0x2080034:
	OUT  0x36,R30
	RJMP _0x208001A
_0x2080026:
	CPI  R30,LOW(0x58)
	BRNE _0x2080029
	LDS  R26,_TWI_bufPtr_S1040006000
	LDI  R27,0
	SUBI R26,LOW(-_TWI_buf_G104)
	SBCI R27,HIGH(-_TWI_buf_G104)
	IN   R30,0x3
	ST   X,R30
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RJMP _0x2080035
_0x2080029:
	CPI  R30,LOW(0x38)
	BRNE _0x208002A
	LDI  R30,LOW(165)
	RJMP _0x2080035
_0x208002A:
_0x208002C:
	IN   R30,0x1
	STS  _TWI_state_G104,R30
	LDI  R30,LOW(4)
_0x2080035:
	OUT  0x36,R30
_0x208001A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI

	.CSEG
_LSBYTE:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	MOV  R16,R30
	CLR  R17
	MOV  R30,R16
	RJMP _0x2120001
_MSBYTE:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ANDI R30,LOW(0xFF00)
	MOV  R30,R31
	LDI  R31,0
	MOV  R16,R30
	CLR  R17
	MOV  R30,R16
	RJMP _0x2120001

	.CSEG
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20C0003*2)
	LDI  R31,HIGH(_0x20C0003*2)
	CALL __INITLOCB
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x20C0005
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x20C0006
_0x20C0005:
	RJMP _0x20C0004
_0x20C0006:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x20C000A
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	RJMP _0x20C0017
_0x20C000A:
	CPI  R30,LOW(0x1)
	BRNE _0x20C0009
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
_0x20C0017:
	STD  Y+2,R30
_0x20C0009:
_0x20C0004:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
_0x2120004:
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	CALL __SAVELOCR6
	__GETWRS 18,19,8
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,2
	MOVW R20,R30
	__GETWRN 16,17,0
_0x20C000D:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x20C000E
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5B)
	BRNE _0x20C000F
	MOVW R26,R20
	LDI  R30,LOW(138)
	RJMP _0x20C0018
_0x20C000F:
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5D)
	BRNE _0x20C0011
	MOVW R26,R20
	LDI  R30,LOW(84)
	RJMP _0x20C0018
_0x20C0011:
	MOVW R26,R18
	LD   R30,X
	SUBI R30,-LOW(128)
	MOVW R26,R20
_0x20C0018:
	ST   X,R30
	__ADDWRN 18,19,1
	__ADDWRN 20,21,1
	__ADDWRN 16,17,1
	RJMP _0x20C000D
_0x20C000E:
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
	CALL __LOADLOCR6
_0x2120003:
	ADIW R28,12
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,19
	LDI  R24,19
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20C0013*2)
	LDI  R31,HIGH(_0x20C0013*2)
	CALL __INITLOCB
	ST   -Y,R17
	LDI  R17,LOW(0)
_0x20C0015:
	CPI  R17,2
	BRSH _0x20C0016
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	SUBI R17,-1
	RJMP _0x20C0015
_0x20C0016:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDD  R17,Y+0
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(64)
	STD  Y+1,R30
	LDI  R30,LOW(48)
	STD  Y+2,R30
	LDI  R30,LOW(118)
	STD  Y+3,R30
	LDI  R30,LOW(64)
	STD  Y+4,R30
	LDI  R30,LOW(18)
	STD  Y+5,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,6
	RET

	.CSEG
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R30,LOW(67)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	LDS  R30,_Etat_BP_I2C_S1070000000
	CPI  R30,0
	BRNE _0x20E0007
	CPI  R16,0
	BRNE _0x20E0008
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x20E0009
	LDI  R30,LOW(1)
	STS  _Etat_BP_I2C_S1070000000,R30
	LDI  R30,LOW(0)
	RJMP _0x2120001
_0x20E0009:
	LDI  R30,LOW(255)
	RJMP _0x2120001
_0x20E0008:
	LDI  R30,LOW(255)
	RJMP _0x2120001
_0x20E0007:
	CPI  R30,LOW(0x1)
	BRNE _0x20E0006
	CPI  R16,0
	BREQ _0x20E000D
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x20E000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_I2C_S1070000000,R30
	MOV  R30,R16
	RJMP _0x2120001
_0x20E000E:
	LDI  R30,LOW(0)
	RJMP _0x2120001
_0x20E000D:
	LDI  R30,LOW(0)
_0x20E0006:
_0x2120001:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2120002:
	ADIW R28,4
	RET

	.CSEG

	.DSEG
_Ligne0MenuMode:
	.BYTE 0x2
_Ligne0MenuInfos:
	.BYTE 0x2
_Ligne0MenuDeplacements:
	.BYTE 0x2
_TexteTestSD21:
	.BYTE 0x2
_TexteTest1BpsurLed:
	.BYTE 0x2
_Ligne1PlusMoins:
	.BYTE 0x2
_Ligne1ChoixEntr:
	.BYTE 0x2
_Ligne1ChoixEchap:
	.BYTE 0x2
_Ligne1ChoixEchap5s:
	.BYTE 0x2
_Ligne1ChoixEchapOk:
	.BYTE 0x2
_Ligne1ChoixEchapSET:
	.BYTE 0x2
_BpPlusSurD0:
	.BYTE 0x2
_BpFlecheHSurD1:
	.BYTE 0x2
_BpFlecheHSurD2:
	.BYTE 0x2
_BpMoinsSurD3:
	.BYTE 0x2
_BpSetSurD4:
	.BYTE 0x2
_BpOkSurD5:
	.BYTE 0x2
_BpEntrSurD6:
	.BYTE 0x2
_BpEchSurD7:
	.BYTE 0x2
_Menu:
	.BYTE 0x1
_Menu_1:
	.BYTE 0x1
__seed_G100:
	.BYTE 0x4
_TWI_msgSize_G104:
	.BYTE 0x1
_TWI_buf_G104:
	.BYTE 0x14
_TWI_state_G104:
	.BYTE 0x1
_TWI_statusReg:
	.BYTE 0x1
_TWI_bufPtr_S1040006000:
	.BYTE 0x1
_Etat_BP_I2C_S1070000000:
	.BYTE 0x1

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
